#include <amxmodx>
#include <amxmisc>
#include <xp_string>
#define VERSION "1.0" //
enum
{
	stat_set,
	stat_add,
	stat_sub,
	stat_del
}

new Array:UserDynamicValues[33];
new fw_playdataloaded;
enum _: UserDynamicValue
{
	bool:udv_notempty,
	udv_name[30],
	udv_value[255]
}
public get_user_dynainfo(userid, dyname[])
{
	new UserDynamicValueInfo[UserDynamicValue];
	new dynamicvid = get_user_dynavalueid(userid, dyname);
	if(dynamicvid < 0) return UserDynamicValueInfo;
	ArrayGetArray( UserDynamicValues[userid], dynamicvid, UserDynamicValueInfo );
	return UserDynamicValueInfo;
}
public get_user_dynavalueid(userid, dyname[])
{
	for( new i = 0; i < ArraySize( UserDynamicValues[userid] ); i++ )
    {
		new UserDynamicValueInfo[UserDynamicValue];
		ArrayGetArray( UserDynamicValues[userid], i, UserDynamicValueInfo );
		if(equali(UserDynamicValueInfo[udv_name], dyname))
		{
			return i;
		}
    }
	return -1;
}
public set_user_dynavalue(userid, dyname[], dyvalue[], dysetype)
{
	new dynamicvid = get_user_dynavalueid(userid, dyname);
	new UserDynamicValueInfo[UserDynamicValue];
	if(dynamicvid < 0)
	{
		formatex(UserDynamicValueInfo[udv_name], charsmax(UserDynamicValueInfo[udv_name]), dyname);
		if(dysetype == stat_sub && isNumeric(dyvalue))
		{
			formatex(UserDynamicValueInfo[udv_value], charsmax(UserDynamicValueInfo[udv_value]), "%f", -1 * str_to_float(dyvalue));
		}
		else
		{
			formatex(UserDynamicValueInfo[udv_value], charsmax(UserDynamicValueInfo[udv_value]), dyvalue);
		}
		UserDynamicValueInfo[udv_notempty] = true;
		ArrayPushArray( UserDynamicValues[userid], UserDynamicValueInfo);
		return;
	}
	ArrayGetArray( UserDynamicValues[userid], dynamicvid, UserDynamicValueInfo );
	new Float:CurrentValue;
	new Float:SetValue;
	new Float:NewValue;
	if(dysetype == stat_add || dysetype == stat_sub)
	{
		if(!isNumeric(dyvalue))
		{
			return;
		}
		if(!isNumeric(UserDynamicValueInfo[udv_value]) && strlen(UserDynamicValueInfo[udv_value]) > 0)
		{
			return;
		}		
		SetValue = str_to_float(dyvalue);
		CurrentValue = str_to_float(UserDynamicValueInfo[udv_value]);
	}
	if(dysetype == stat_add)
	{
		NewValue = CurrentValue + SetValue;
		formatex(UserDynamicValueInfo[udv_value], charsmax(UserDynamicValueInfo[udv_value]), "%f", NewValue);
	}
	else if(dysetype == stat_sub)
	{
		NewValue = CurrentValue - SetValue;
		formatex(UserDynamicValueInfo[udv_value], charsmax(UserDynamicValueInfo[udv_value]), "%f", NewValue);
	}
	else
	{
		formatex(UserDynamicValueInfo[udv_value], charsmax(UserDynamicValueInfo[udv_value]), dyvalue);
	}
	ArraySetArray(UserDynamicValues[userid], dynamicvid, UserDynamicValueInfo);
}
public del_user_dynavalue(userid, dyname[])
{
	new dynamicvid = get_user_dynavalueid(userid, dyname);
	if(dynamicvid < 0) return;
	ArrayDeleteItem(UserDynamicValues[userid], dynamicvid);
}
public plugin_init()
{
	register_plugin("CS User Istatistic", VERSION, "Ibm")
	fw_playdataloaded = CreateMultiForward("xp_player_dataloaded", ET_IGNORE, FP_CELL);	// id
	UserDynamicValues[0] = ArrayCreate(UserDynamicValue);
}
public plugin_natives()
{
	register_library("cs istatistik");
	register_native("xp_setuserdynvalue", "xp_setuserdynvalue_n"); // id, dynamicname[], dynamicvalue[]
	register_native("xp_setuserdynvalue_num", "xp_setuserdynvalue_n2"); // id, dynamicname[], dynamicvalue, dynamictype
	register_native("xp_setuserdynvalue_float", "xp_setuserdynvalue_n3"); // id, dynamicname[], Float:dynamicvalue, dynamictype
	register_native("xp_getuserdynvalue", "xp_getuserdynvalue_n"); // id, dynamicname[], dynamicvalue[], outlen
	register_native("xp_getuserdynvalue_num", "xp_getuserdynvalue_n2"); // id, dynamicname[]
	register_native("xp_getuserdynvalue_float", "xp_getuserdynvalue_n3"); // id, dynamicname[]
	register_native("xp_loaduserdatalog", "xp_loaduserdatalog_n"); //id, loginid[]
}
public xp_loaduserdatalog_n()
{
	new strusername[50];
	get_string(2, strusername, 49);
	LoadUserVariableFromFiles(get_param(1), strusername);
}
public LoadUserVariableFromFiles(id, const logname[])
{
	new UserDynamicValueInfo[UserDynamicValue];
	UserDynamicValueInfo = get_user_dynainfo(id, "udata_loaded");
	if(UserDynamicValueInfo[udv_notempty])
	{
		return;
	}
	new configdir[80];
	get_configsdir(configdir, 79);
	formatex(configdir, 79, "%s/cs_uyeistatistik.ini", configdir);
	new fp = fopen(configdir, "r");
	if (!fp)
	{
		return;
	}
	new username[50];
	get_user_name(id, username, 49);
	new steamid[32];
	get_user_authid(id, steamid, charsmax(steamid));
	new text[256];
	new varname[125];
	new varvalue[125];
	new bool:Founded = false;
	new totaladded = 0;
	new bool:IsimArea = false;
	new bool:onlylogin = false;
	while (!feof(fp))
	{
		fgets(fp, text, charsmax(text));
		trim(text);
		if (text[0] == ';')
		{
			continue;
		}
		new txtlen = strlen(text);
		IsimArea = false;
		onlylogin = false;
		if(text[0] == '[' && text[txtlen - 1] == ']')
		{
			if(Founded) break;
			text[txtlen - 1] = '^0';
			copy(varname, 124, text[1]);
			IsimArea = true;
		}
		if(IsimArea)
		{
			if(Founded) break;
			new UserSplit[15][50];
			new spltlen = ExplodeStringEx(UserSplit, 14, 49, varname, ",");
			for(new i = 0; i < spltlen; i++)
			{
				trim(UserSplit[i]);
				new newtext[125];
				onlylogin = false;
				if(UserSplit[i][1] == '*')
				{
					onlylogin = true;
					copy(newtext, 124, UserSplit[i][1]);
				}
				else
				{
					copy(newtext, 124, UserSplit[i]);
				}
				
				
				
				if(onlylogin)
				{
					if(equali(UserSplit[i], logname))
					{
						Founded = true;
						break;
					}
				}
				else
				{
					if(equali(UserSplit[i], username) || equali(UserSplit[i], steamid) || equali(UserSplit[i], logname))
					{
						Founded = true;
						break;
					}
				}
			}
			IsimArea = false;
			continue;
		}
		if(!Founded) continue;
		if (parse(text, varname, charsmax(varname), varvalue, charsmax(varvalue)) < 1)
		{
			continue;
		}
		new nname[125];
		formatex(nname, 124, "udata_%s", varname);
		set_user_dynavalue(id, nname, varvalue, stat_set);
		totaladded++;
	}
	if(totaladded)
	{
		set_user_dynavalue(id, "udata_loaded", "1", stat_set);
		new FWReturn;
		ExecuteForward(fw_playdataloaded, FWReturn, id);
	}
	fclose(fp);
}
public xp_getuserdynvalue_n()
{
	new Float:DOValue;
	return xp_get_userdyna_nn(0, DOValue);
}
public xp_getuserdynvalue_n2()
{
	new Float:DOValue;
	return xp_get_userdyna_nn(1, DOValue);
}
public Float:xp_getuserdynvalue_n3()
{
	new Float:DOValue;
	xp_get_userdyna_nn(2, DOValue);
	return DOValue;
}
public xp_get_userdyna_nn(nnstype, &Float:OutValue)
{
	new id = get_param(1);
	if(id == -1) id = 0;
	new dyname[30];
	get_string(2, dyname, 29);
	new UserDynamicValueInfo[UserDynamicValue];
	UserDynamicValueInfo = get_user_dynainfo(id, dyname);
	if(!UserDynamicValueInfo[udv_notempty])
	{
		return 0;
	}
	if(nnstype == 1) //NUMERIC
	{
		return str_to_num(UserDynamicValueInfo[udv_value]);
	}
	else if(nnstype == 2) //FLOAT
	{
		OutValue = str_to_float(UserDynamicValueInfo[udv_value]);
	}
	else
	{
		set_array(4, UserDynamicValueInfo[udv_value], get_param(5));
	}
	return 1;
}
public xp_setuserdynvalue_n()//
{
	xp_setuserdynvalue_nn(0, 0);
}
public xp_setuserdynvalue_n2()//
{
	xp_setuserdynvalue_nn(1, get_param(4));
}
public xp_setuserdynvalue_n3()//
{
	xp_setuserdynvalue_nn(2, get_param(4));
}
public xp_setuserdynvalue_nn(nnstype, nnstype2)
{
	new id = get_param(1);
	if(id == 0)
	{
		for( new i = 1; i < 33 ; i++ )
		{
			if(!is_user_connected(i)) continue;
			xp_setuserdynvalue_nnn(i, nnstype, nnstype2);
		}
		return;
	}
	if(id == -1) id = 0;
	xp_setuserdynvalue_nnn(id, nnstype, nnstype2);
}
public xp_setuserdynvalue_nnn(id, nnstype, nnstype2)
{
	new n_dyname[50];
	new strvalue[255];
	get_string(2, n_dyname, 49);
	if(nnstype == 0)
	{
		get_string(3, strvalue, 254);
	}
	else
	{
		if(nnstype == 2)
		{
			formatex(strvalue, charsmax(strvalue), "%f", get_param_f(3));
		}
		else
		{
			formatex(strvalue, charsmax(strvalue), "%i", get_param(3));
		}
	}
	if(nnstype == 1) //Numeric
	{
		set_user_dynavalue(id, n_dyname, strvalue, nnstype2)
	}
	else if(nnstype == 2) //Float
	{
		set_user_dynavalue(id, n_dyname, strvalue, nnstype2)
	}
	else //string
	{
		set_user_dynavalue(id, n_dyname, strvalue, stat_set)
	}
}
public client_connect(id)
{
	UserDynamicValues[id] = ArrayCreate(UserDynamicValue);
	LoadUserVariableFromFiles(id, "");
}
public client_putinserver(id)
{

}
public client_disconnected(id)
{
	ArrayDestroy(UserDynamicValues[id])
}
public plugin_end() 
{
	ArrayDestroy(UserDynamicValues[0])
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
