#include <amxmodx>
#include <fakemeta>
#include <xp_string>
new SettingCount;
new SetArray[301][301];
new SetArrayV[301][301];
stock get_setting_index(const Name[])
{
	for(new i = 0;i < SettingCount;i++)
	{
		if(equal(SetArray[i], Name))
		{
			return i;
		}
	}
	return -1;
}
public bool:setting_exists(const Name[])
{
	return ((get_setting_index(Name) > 0) ? true : false);
}
public bool:settings_setvalue(const Name[], const Value[], bool:addifnotexists)
{
	if(strlen(Name) < 3) return false;
	new setindex = get_setting_index(Name);
	if(setindex < 0)
	{
		if(!addifnotexists) return false;
		return settings_add(Name, Value);
	}
	format(SetArray[setindex], 300, "%s", Name);
	format(SetArrayV[setindex], 300, "%s", Value);
	return true;
}
public bool:settings_setvalue_num(const Name[], Value, bool:addifnotexists)
{
	new StrD[301];
	format(StrD, 300, "%i", Value);
	return settings_setvalue(Name, StrD, addifnotexists);
}
public bool:settings_setvalue_float(const Name[], Float:Value, bool:addifnotexists)
{
	new StrD[301];
	format(StrD, 300, "%f", Value);
	return settings_setvalue(Name, StrD, addifnotexists);
}
public bool:settings_add(const Name[], const Value[])
{
	if(setting_exists(Name)) return false;
	if(SettingCount > 300) return false;
	format(SetArray[SettingCount], 300, "%s", Name);
	format(SetArrayV[SettingCount], 300, "%s", Value);
	SettingCount++;
	return true;
}
public bool:settings_add_num(const Name[], Value)
{
	new StrD[301];
	format(StrD, 300, "%i", Value);
	return settings_add(Name, StrD);
}
public bool:settings_add_float(const Name[], Float:Value)
{
	new StrD[301];
	format(StrD, 300, "%f", Value);
	return settings_add(Name, StrD);
}
public bool:settings_delete(const Name[])
{
	new setindex = get_setting_index(Name);
	if(setindex < 0) return false;
	for(new i = setindex; i < SettingCount;i++)
	{
		SetArray[i] = SetArray[i + 1];
		SetArrayV[i] = SetArrayV[i + 1];
	}
	SettingCount--;
	return true;
}
public bool:settings_getvalue(const Name[], OutPut[])
{
	new setindex = get_setting_index(Name);
	if(setindex < 0) return false;
	copy ( OutPut, 300, SetArrayV[setindex] ) ;
	return true;
}
public settings_getvalue_num(const Name[])
{
	new StrD[301];
	settings_getvalue(Name, StrD);
	return str_to_num(StrD);
}
public Float:settings_getvalue_float(const Name[])
{
	new StrD[301];
	settings_getvalue(Name, StrD);
	return str_to_float(StrD);
}
public settings_getall(OutPut[])
{
	if(SettingCount <= 0) return;
	new StrC[90001];
	format(StrC, 90000, "%s=%s", SetArray[0], SetArrayV[0]);
	for(new i = 1;i < SettingCount;i++)
	{
		format(StrC, 90000, "%s|%s=%s", StrC, SetArray[i], SetArrayV[i]);
	}
	copy (OutPut, 90000, StrC);
}
public settings_setall(InStr[], bool:append)
{
	new InStrExt[301][301];
	new TwoVarible[2][151]
	ExplodeString( InStrExt, 300, 300,InStr, '|');
	new NameI[100];
	if(!append)
	{
		SettingCount = 0;
	}
	for(new i = 0; i < 301;i++)
	{
		if(strfind (InStrExt[i],"=")  > -1)
		{
			ExplodeString(TwoVarible, 2, 150,InStrExt[i], '=');
			settings_add(TwoVarible[0], TwoVarible[1]);
		}
		else
		{
			format(NameI, 99, "%s%i", "Settings", SettingCount); 
			settings_add(NameI, InStrExt[i]);
		}
	}

}
public settings_count()
{
	return SettingCount;
}
public settings_clear()
{
	SettingCount = 0;
}