#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <scxpmod>
#include <fun>
#define VERSION "1.0"
#define SAYCMD "/redbull"
new Cvar_RedbullSpeed, Cvar_RedbullKillReq, Cvar_RedbullTime, Cvar_RedbullHealthRgn;
new bool:UserHasRedbull[33];
new RedBullFinishTime[33];
new Float:ServerMaxSpeed;
new Cvar_MaxSpeed;
new bool:Setted;
new myengid = 0;
public plugin_init()
{
	register_plugin("SCXP Energy Redbull", VERSION, "Ibm")
}
public xp_main()
{
	Cvar_RedbullKillReq = register_cvar("xp_energy_redbull_kilreq", "10");
	Cvar_RedbullTime = register_cvar("xp_energy_redbull_time", "30");
	Cvar_RedbullSpeed = register_cvar("xp_energy_redbull_speed","650.0");
	Cvar_RedbullHealthRgn = register_cvar("xp_energy_redbull_health", "2.0");
	Cvar_MaxSpeed = get_cvar_pointer("sv_maxspeed" );
	ServerMaxSpeed = 270.0;
	myengid = xp_energy_register(SAYCMD, Cvar_RedbullKillReq, 1);
}
public xp_player_prethink(id, plclass)
{
	new Float:MaxSpeed;
	pev(id, pev_maxspeed, MaxSpeed);
	if(UserHasRedbull[id])
	{
		if(MaxSpeed != get_pcvar_float(Cvar_RedbullSpeed))
		{
			set_pev(id, pev_maxspeed, get_pcvar_float(Cvar_RedbullSpeed));
		}
	}
	else
	{
		if(MaxSpeed > ServerMaxSpeed || MaxSpeed <= 0.1)
		{
			set_pev(id, pev_maxspeed, ServerMaxSpeed);
		}
	}
}
public xp_energy_using_item(id, energyid)
{
	if(energyid != myengid) return PLUGIN_CONTINUE;
	if(!user_canuseredbull(id))
	{
		return PLUGIN_CONTINUE;
	}
	use_redbull(id);
	return PLUGIN_HANDLED;
}
public xp_energy_canuseitem(id, energyid, hudmsg)
{
	if(energyid != myengid) return PLUGIN_CONTINUE;
	if(hudmsg)
	{
		return user_canuseredbull(id, 0);
	}
	else
	{
		return user_canuseredbull(id, 1);
	}
}
public xp_player_spawned(id, plclass)
{
	if(UserHasRedbull[id])
	{
		set_task(0.5, "SetUserGlow", id + 32);
	}
}
public SetUserGlow(tid)
{
	new id = tid - 32;
	set_user_rendering(id, kRenderFxGlowShell, 135, 206, 250, kRenderTransAlpha, 200);
}
stock use_redbull(id)
{
	UserHasRedbull[id] = true;
	new redbulltime = get_pcvar_num(Cvar_RedbullTime);
	RedBullFinishTime[id] = redbulltime;
	client_print(id, print_chat, "%s%L", PREFIX, id, "ENG_REDBULL_SCC", redbulltime);
	set_user_maxspeed(id, get_pcvar_float(Cvar_RedbullSpeed));
	client_cmd(id, "cl_forwardspeed 9999");
	client_cmd(id, "cl_backspeed 9999");
	client_cmd(id, "cl_sidespeed 9999");
	set_task(1.0,"xp_redbull_timer",id,"",0,"b");
	set_task(0.5, "SetUserGlow", id + 32);
}
public xp_redbull_timer(id)
{
	if(!is_user_alive(id))
	{
		return;
	}
	if(!UserHasRedbull[id])
	{
		remove_task(id);
		return;
	}
	set_user_health(id,get_user_health(id) + get_pcvar_num(Cvar_RedbullHealthRgn));
	RedBullFinishTime[id]--;
	if(RedBullFinishTime[id] <= 0)
	{
		remove_redbull(id);
		remove_task(id);
		return;
	}
}
public xp_timer()
{
	if(xp_enabled())
	{
		if(get_pcvar_float(Cvar_MaxSpeed) < 1000.0)
		{
			set_pcvar_float(Cvar_MaxSpeed, 1000.0);
		}
		if(Setted) Setted = false;
	}
	else
	{
		if(Setted) return;
		set_cvar_float("sv_maxspeed", 1000.0);
		for(new i = 0; i < 33;i++)
		{
			if(!is_user_connected(i)) continue;
			if(UserHasRedbull[i])
			{
				set_pev(i, pev_maxspeed, get_pcvar_float(Cvar_RedbullSpeed));
			}
			else
			{
				set_pev(i, pev_maxspeed, ServerMaxSpeed);
			}
			
		}
		Setted = true;
	}
}
stock remove_redbull(id)
{
	if(!UserHasRedbull[id]) return;
	UserHasRedbull[id] = false;
	client_print(id, print_chat, "%s%L", PREFIX, id, "SK_INF_GLB_TMF", SAYCMD);
	set_user_maxspeed(id, ServerMaxSpeed);
	if(is_user_alive(id))
	{
		set_user_rendering(id);
	}
}
stock user_canuseredbull(id, showmessage = 1)
{
	if(UserHasRedbull[id])
	{
		if(showmessage) client_print(id, print_chat, "%s%L", PREFIX, id, "SK_ERR_GLB_USE", SAYCMD);
		return 0;
	}
	return 1;
}
public client_disconnect(id)
{
	if(UserHasRedbull[id])
	{
		remove_task(id)
	}
}
public client_putinserver(id)
{
	UserHasRedbull[id] = false;
	RedBullFinishTime[id] = 0;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
