#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <scxpmod>
#include <fun>
#define VERSION "1.0"
#define SAYCMD "/unammo"
new Cvar_UnAmmoReq, Cvar_UnAmmoTime;
new bool:UserHasUnammo[33];
new UnAmmoFinishTime[33];
new myengid = 0;
public plugin_init()
{
	register_plugin("SCXP Energy UnAmmo", VERSION, "Ibm")
}
public xp_main()
{
	Cvar_UnAmmoReq = register_cvar("xp_energy_unammo_kilreq", "20");
	Cvar_UnAmmoTime = register_cvar("xp_energy_unammo_time", "40");
	myengid = xp_energy_register(SAYCMD, Cvar_UnAmmoReq, 1);
}
stock use_unammo(id)
{
	UserHasUnammo[id] = true;
	new itemtime = get_pcvar_num(Cvar_UnAmmoTime);
	UnAmmoFinishTime[id] = itemtime;
	client_print(id, print_chat, "%s%L", PREFIX, id, "SK_INF_GLB_USE", itemtime, SAYCMD);
	engfunc(EngFunc_SetPhysicsKeyValue, id, "snrld", "1");
	set_task(1.0,"xp_noreloadtime",id,"",0,"b");
}
public xp_energy_using_item(id, energyid)
{
	if(energyid != myengid) return PLUGIN_CONTINUE;
	if(!user_canuseitem(id))
	{
		return PLUGIN_CONTINUE;
	}
	use_unammo(id);
	return PLUGIN_HANDLED;
}
public xp_energy_canuseitem(id, energyid, hudmsg)
{
	if(energyid != myengid) return PLUGIN_CONTINUE;
	if(hudmsg)
	{
		return user_canuseitem(id, 0);
	}
	else
	{
		return user_canuseitem(id, 1);
	}
}
public xp_noreloadtime(id)
{
	if(!UserHasUnammo[id])
	{
		remove_task(id);
		return;
	}
	if(!is_user_alive(id))
	{
		return;
	}
	UnAmmoFinishTime[id]--;
	if(UnAmmoFinishTime[id] <= 0)
	{
		remove_task(id);
		remove_item(id);
	}
}

stock remove_item(id)
{
	if(!UserHasUnammo[id]) return;
	UserHasUnammo[id] = false;
	client_print(id, print_chat, "%s%L", PREFIX, id, "SK_INF_GLB_TMF", SAYCMD);
	new itemvalue[10]
	engfunc(EngFunc_GetPhysicsKeyValue, id, "snrld", itemvalue, 9);
	if(!equali(itemvalue, "-1"))
	{
		engfunc(EngFunc_SetPhysicsKeyValue, id, "snrld", "0");
	}
}
stock user_hasunammo(id)
{
	new itemvalue[10]
	engfunc(EngFunc_GetPhysicsKeyValue, id, "snrld", itemvalue, 9);
	if(equali(itemvalue, "-1") || equali(itemvalue, "1"))
	{
		return 1;
	}
	return 0;
}
stock user_canuseitem(id, showmessage = 1)
{
	if(UserHasUnammo[id] || user_hasunammo(id))
	{
		if(showmessage) client_print(id, print_chat, "%s%L", PREFIX, id, "SK_ERR_GLB_USE", SAYCMD);
		return 0;
	}
	return 1;
}
public client_disconnect(id)
{
	if(UserHasUnammo[id])
	{
		remove_task(id);
	}
}
public client_putinserver(id)
{
	UserHasUnammo[id] = false;
	UnAmmoFinishTime[id] = 0;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
