#include <amxmodx>
#include <amxmisc>
#define VERSION "1.0.0(1)" //build 1
#define LUPDATE "13/08/2014"
#define HudChannel 346
new NotifyString[21][70];
new NotifyIsLang[21];
//Added 14.08.2014 1.0.0(1)
new NotifyParam[21][7][50];
//
new NotifyCount;
new HudDuration;
new fw_main, FWReturn;
public plugin_init()
{
	register_plugin("SCXP Notify", VERSION, "Ibm")
	register_cvar("xp_notify_max", "5");
	register_cvar("xp_notify_duration", "10");
	set_task(1.00, "ShowTask", 0, "", 0, "b");
	fw_main = CreateMultiForward("xp_notify_load", ET_IGNORE);
	ExecuteForward(fw_main, FWReturn);
	HudDuration = -1;
	NotifyCount = -1;
}
public plugin_natives()
{
	register_library("scxp notify");
	register_native("xp_notify_show", "xp_notify_show");
	//Added 14.08.2014 1.0.0(1)
	register_native("xp_notify_showtwouser", "xp_notify_showtwouser");
	//
}
//Changed 14.08.2014 1.0.0(1)
public xp_notify_showtwouser() //sting
{
	new NotifyStr[70];
	new NParam[7][50];
	new playername[50];
	new playername2[50];
	new first = get_param(2);
	new second = get_param(3);
	new islang = get_param(4);
	get_string(1, NotifyStr, 69);
	if(first)
	{
		get_user_name(first, playername, 49)
		NParam[0] = playername;
	}
	if(second)
	{
		get_user_name(second, playername, 49)
		NParam[1] = playername2;
	}
	AddMessage(NotifyStr, NParam, islang);
}
//
//Added 14.08.2014 1.0.0(1)
public xp_notify_show(plugin, params)
{
	new NotifyStr[70];
	new islang = get_param(2);
	get_string(1, NotifyStr, 69);
	new NParam[7][50];
	if(params > 2)
	{
		for(new i = 3; i < 9;i++)
		{
			if(i > params) break;
			get_string(i, NParam[i-3], 49);
		}
	}
	AddMessage(NotifyStr, NParam, islang);
}
//

//Changed 14.08.2014 1.0.0(1)
public AddMessage(message[], Params[7][50], islang)
{
	NotifyCount++;	
	if (NotifyCount <= 0)
	{
		format(NotifyString[NotifyCount], 69, "%s", message);
		NotifyIsLang[NotifyCount] = islang;
		//Added 14.08.2014 1.0.0(1)
		for(new j=0;j < 7;j++)
		{
			format(NotifyParam[NotifyCount][j], 49, "%s", Params[j]);
		}
		//
	}
	else
	{
		for(new i=get_cvar_num("xp_notify_max");i > 0 ;i--)
		{
			format(NotifyString[i], 69, "%s", NotifyString[i - 1]);
			NotifyIsLang[i] = NotifyIsLang[i - 1];
			//Added 14.08.2014 1.0.0(1)
			for(new j=0;j < 7;j++)
			{
				format(NotifyParam[i][j], 49, "%s", NotifyParam[i - 1][j]);
			}
			//
		}
		format(NotifyString[0], 69, "%s", message);
		NotifyIsLang[0] = islang;
		//Added 14.08.2014 1.0.0(1)
		for(new j=0;j < 7;j++)
		{
			format(NotifyParam[0][j], 49, "%s", Params[j]);
		}
		//
	}
	if(NotifyCount > get_cvar_num("xp_notify_max"))
	{
		NotifyCount = get_cvar_num("xp_notify_max") - 1;
	}
	ShowMessage();
}
//
//Changed 14.08.2014 1.0.0(1)
public SetText(outputstr[], plid)
{
	new Text[1400];
	new NotifyParamEx[7][50];
	for(new i =  get_cvar_num("xp_notify_max") - 1; i >= 0; i--)
	{
		if(i > NotifyCount)
		{
			format(Text, 1400, "%s^n%s",Text, "");
		}
		else
		{
			for(new j=0;j < 7; j++)
			{
				NotifyParamEx[j] = NotifyParam[i][j];
				if(strfind (NotifyParam[i][j],"LANGIBM_")  > -1)
				{
					replace_all( NotifyParamEx[j], 49, "LANGIBM_", "" )
					format(NotifyParamEx[j], 49, "%L", ((plid > 0) ? plid : LANG_SERVER), NotifyParamEx[j]);
				}
				
			}
			//Changed 14.08.2014 1.0.0(1)
			if(NotifyIsLang[i] > 0)
			{
				format(Text, 1400, "%s^n%L",Text, ((plid > 0) ? plid : LANG_SERVER), NotifyString[i], NotifyParamEx[0], NotifyParamEx[1], NotifyParamEx[2], NotifyParamEx[3], NotifyParamEx[4], NotifyParamEx[5], NotifyParamEx[6]);
			}
			else
			{
				format(Text, 1400, "%s^n%s",Text, NotifyString[i], NotifyParamEx[0], NotifyParamEx[1], NotifyParamEx[2], NotifyParamEx[3], NotifyParamEx[4], NotifyParamEx[5], NotifyParamEx[6]);
			}
			//
		}

	}
	copy ( outputstr, 1400, Text ); 
}
//
public ShowMessage()
{
	for(new i = 1; i < 33; i++)
	{
		if(!is_user_connected(i)) continue;
		new HudText[1400];
		SetText(HudText, i);
		set_hudmessage(170, 170, 255, 0.0, 0.5, 0, 0.0, 300.0, 0.0, 0.0, HudChannel + 3);
		show_hudmessage(i, HudText);
		HudDuration = get_cvar_num("xp_notify_duration");
	}

}
public ShowTask()
{
	if(HudDuration > 0)
	{
		HudDuration--;
	}
	else
	{
		NotifyCount--;
		if(NotifyCount >= 0)
		{
			ShowMessage();
		}
		else if(HudDuration == 0)
		{
			set_hudmessage(170, 170, 255, 0.0, 0.5, 0, 0.0, 0.0, 0.0, 0.0, HudChannel + 3);
			show_hudmessage(0, "");
			HudDuration = -1;
		}
		if(NotifyCount < -1) NotifyCount = -1;
	}
}

