#include <amxmodx>
#include <amxmisc>
#define LastUpdate "06/11/2018"
#define MaxSayCount 501
new NO_SUCCESS_MSG = 1;
new SayCounts = 0;
enum SayContent
{
	PluginId,
	PluginName[50],
	CommandName[50],
	FunctionName[50],
	AccessFlag,
	Length,
	ContextStr[200],
	CmdInfo[50],
	PluginPrefix[30],
	bool:ShowAll,
	bool:NoHandleOnError,
	bool:ShowSuccessMsg
}
new SayCommands[MaxSayCount][SayContent];
new fw_main;
new Ayrac[34][MaxSayCount];
new ArgCount;
new bool:IsSayMsg;
new Cvar_Enabled;
public plugin_init()
{
	register_plugin("Advanced Say Commands", "1.2", "Lt.(Ibm)");
	Cvar_Enabled = register_cvar("say_command", "1");
	register_clcmd("say", "saycomminition", -1, "- say comminition");
	register_clcmd("say_team", "saycomminition", -1, "- say comminition");
	register_clcmd("list_say", "list_saycmd", -1, "- list say commands");
	register_dictionary("ibm_say.txt");
	new FWReturn;
	fw_main = CreateMultiForward("ibm_say_main", ET_IGNORE);
	ExecuteForward(fw_main, FWReturn);
}
public list_saycmd(id, level, cid)
{
	new nump[5];
	read_argv(1, nump, 4);
	new p = str_to_num(nump) - 1;
	if(p < 0) p = 0;
	new founded;
	for(new i = p;i < (p + 10);i++)
	{
		if (i >= SayCounts) break;
		if(access(id, SayCommands[i][AccessFlag]))
		{
			console_print(id, "%s: %s",  SayCommands[i][CommandName], SayCommands[i][ContextStr] );
			founded++;
		}
	}
	if(founded)
	{
		console_print(id, "%L", id, "SAY_CMD_LST", (p + 1), (p + founded));
	}
	else
	{
		console_print(id, "%L", id, "SAY_ERR_NOCMD");
	}
	return PLUGIN_HANDLED;
}
public plugin_natives()
{
	register_library("ibm say");
	//register_saycmd(cmdname[], function[], accessflag, len, context[], cmdinfo[], plprefix[], bool:ShowAll, bool:NoHandleOnError, bool:ShowSuccessMsg)
	register_native("register_saycmd", "register_saycommand_n");
	//get_say_argv(index, OutPut[], len)
	register_native("get_say_argv", "get_say_argv_n");
	//get_say_argc()
	register_native("get_say_argc", "get_say_argc_n");
}
public get_say_argc_n()
{
	if(!IsSayMsg) return 0;
	return ArgCount;
}
public get_say_argv_n(plugin, count)
{
	if(IsSayMsg && get_param(1) < ArgCount)
	{
		set_string(2, Ayrac[get_param(1)], get_param(3));
	}
}
public register_saycommand_n(plugin, count)
{
	if(!plugin) return -1;
	if(!count) return -1;
	new PlName[50];
	get_string(1, PlName, 49);
	new Func[50];
	get_string(2, Func, 49);
	new Flags = get_param(3);
	new CmdLen = get_param(4);
	new Strin_[200];
	get_string(5, Strin_, 199);
	new PlInfo[50];
	get_string(6, PlInfo, 49);
	new PlPrfx[50];
	get_string(7, PlPrfx, 49);
	return register_saycommand(plugin, PlName, Func, Flags, CmdLen, Strin_, PlInfo, PlPrfx, ((get_param(8) > 0) ? true : false) , ((get_param(9) > 0) ? true : false), ((get_param(10) > 0) ? true : false));
}
public saycomminition(id, level, cid)
{
	if(!get_pcvar_num(Cvar_Enabled) || !id || SayCounts <= 0) return PLUGIN_CONTINUE;
	new xp_allargs[1000];
	read_args(xp_allargs, 999);
	remove_quotes(xp_allargs);
	if(str_started(xp_allargs, "//") && xp_allargs[2] != '/')
	{
		formatex(xp_allargs, 999, "%s", xp_allargs[2]);
		client_cmd(id, xp_allargs);
		return PLUGIN_HANDLED;
	}
	if(!str_started(xp_allargs, "/")) return PLUGIN_CONTINUE;
	if(equal(xp_allargs, "/")) return PLUGIN_CONTINUE;
	ArgCount =  ExplodeStringEx( Ayrac, 33, (sizeof Ayrac) - 1, xp_allargs, " ");
	new callfnc;
	new cfrt;
	new pcount;
	new CmdArgs[21][50];
	new plcmd[50];
	for(new i = 0; i < SayCounts; i++)
	{
		if(containi(SayCommands[i][CommandName], "|") >= 0)
		{
			pcount = ExplodeStringEx(CmdArgs, 20, 49, SayCommands[i][CommandName], "|");
		}
		else
		{
			formatex(CmdArgs[0], 49, "%s", SayCommands[i][CommandName]);
		}
		for(new j = 0; j <= pcount; j++)
		{
			formatex(plcmd, 49, "/%s", CmdArgs[j]);
			if(str_started(xp_allargs, plcmd, true))
			{
				if(!is_plugin_running(SayCommands[i][PluginId])) continue;
				if(!access(id, SayCommands[i][AccessFlag]))
				{
					if(SayCommands[i][ShowAll])
					{
						client_print(0, print_chat,"%s%L", SayCommands[i][PluginPrefix], LANG_PLAYER, "NO_ACC_COM");
					}
					else
					{
						client_print(id, print_chat,"%s%L", SayCommands[i][PluginPrefix], id, "NO_ACC_COM");
					}
					if(SayCommands[i][NoHandleOnError]) return PLUGIN_CONTINUE;
					return PLUGIN_HANDLED;
				}
				if(ArgCount < SayCommands[i][Length])
				{
					if(SayCommands[i][ShowAll])
					{
						client_print(0, print_chat, "%s%L:  %s %s", SayCommands[i][PluginPrefix], LANG_PLAYER, "USAGE", CmdArgs[j], SayCommands[i][ContextStr]);
					}
					else
					{
						client_print(id, print_chat, "%s%L:  %s %s", SayCommands[i][PluginPrefix], id, "USAGE", CmdArgs[j], SayCommands[i][ContextStr]);
					}
					if(SayCommands[i][NoHandleOnError]) return PLUGIN_CONTINUE;
					return PLUGIN_HANDLED;
				}
				IsSayMsg = true;
				callfnc = callfunc_begin(SayCommands[i][FunctionName], SayCommands[i][PluginName]);
				if(callfnc != 1) continue;
				callfunc_push_int(id);
				callfunc_push_int(ArgCount);
				callfunc_push_str(SayCommands[i][CmdInfo]);
				cfrt = callfunc_end();
				if(SayCommands[i][ShowSuccessMsg])
				{
					if(!NO_SUCCESS_MSG)
					{
						if(SayCommands[i][ShowAll])
						{
							client_print(0, print_chat, "%s%L", SayCommands[i][PluginPrefix], LANG_PLAYER, "SAY_CMD_SC", CmdArgs[j]);
						}
						else
						{
							client_print(id, print_chat, "%s%L", SayCommands[i][PluginPrefix], id, "SAY_CMD_SC", CmdArgs[j]);
						}
					}

				}
				IsSayMsg = false;
				return cfrt;
			}
		}
	}
	return PLUGIN_CONTINUE;
}
public register_saycommand(plugin, cmdname[], function[], accessflag, len, context[], CmdInfoP[], PLPrefix[], bool:ShowAllP, bool:NoHandleOnErrorP, bool:ShowSuccessMsgP)
{
	if(!plugin) return -1;
	if(strlen(cmdname) <= 0) return -1;
	if(strlen(function) <= 0) return -1;
	if(saycmd_exists(cmdname)) return -1;
	SayCommands[SayCounts][PluginId] = plugin;
	new PlgName[50];
	get_plugin_name(plugin, PlgName, 49);
	formatex(SayCommands[SayCounts][PluginName], 49, "%s", PlgName);
	replace_all(SayCommands[SayCounts][PluginName], 49, " ", "")
	formatex(SayCommands[SayCounts][CommandName], 49, "%s", cmdname);
	formatex(SayCommands[SayCounts][FunctionName], 49, "%s", function);
	formatex(SayCommands[SayCounts][CmdInfo], 49, "%s", CmdInfoP);
	formatex(SayCommands[SayCounts][PluginPrefix], 29, "%s", PLPrefix);
	SayCommands[SayCounts][AccessFlag] = accessflag;
	SayCommands[SayCounts][Length] = len;
	SayCommands[SayCounts][ShowAll] = ShowAllP;
	SayCommands[SayCounts][NoHandleOnError] = NoHandleOnErrorP;
	SayCommands[SayCounts][ShowSuccessMsg] = ShowSuccessMsgP;
	formatex(SayCommands[SayCounts][ContextStr], 199, "%s", context);
	SayCounts++;
	return SayCounts - 1;
}
public get_plugin_name(plugin, OutPut[], len)
{
	new filename[50], name[50], version[50], author[50], status[50];
	get_plugin(plugin, filename, 49, name, 49, version, 49, author, 49, status, 49);
	copy(OutPut, len, filename);
}
stock bool:is_plugin_running(plugin)
{
	new filename[50], name[50], version[50], author[50], status[50];
	get_plugin(plugin, filename, 49, name, 49, version, 49, author, 49, status, 49);
	if (status[0]=='d' || status[0]=='r')
	{
		return true;
	}
	return false;
}
public saycmd_exists(cmdname[])
{
	for(new i = 0; i < SayCounts; i++)
	{
		if(equali(SayCommands[i][CommandName], cmdname)) return true;
	}
	return false;
}
stock ExplodeStringEx(Output[][], const Max, const Len, const Text[], const Delimiter[], bool:addspec = false)
{
	new bool:isquote = false;
	new Fnd = 0;
	new ccount = 0;
	new ilen = strlen(Text);
	new curchar;
	new CMAX = Max - 1;
	for(new i = 0; i < ilen; i++)
	{
		curchar = Text[i];
		if(curchar == '^"')
		{
			if(isquote)
			{
				isquote = false;
			}
			else
			{
				isquote = true;
			}
			if(addspec)
			{
				copy(Output[Fnd][ccount], 1, Text[i]);
			}
		}
		if(bCharIndex(Delimiter, curchar) && !isquote)
		{
			if(Fnd + 1 > CMAX)
			{
				if(ccount > Len)
				{
					break;
				}
				copy(Output[Fnd][ccount], 1, Text[i]);
				ccount++;
				continue;
			}
			else
			{
				Fnd++;
			}
			ccount = 0;
			continue;
		}
		if(curchar != '^"') 
		{
			copy(Output[Fnd][ccount], 1, Text[i]);
			ccount++;
		}
		if(ccount > Len)
		{
			Fnd++;
			if(Fnd > CMAX) break;
			ccount = 0;
		}
		if(i == ilen - 1 && ccount > 0)
		{			
			Fnd++;
			ccount = 0;
			continue;
		}
	}
	return Fnd;
}
stock CharIndex(const Input[], const mChar)
{
	for(new i = 0;i < strlen(Input); i++)
	{
		if(Input[i] == mChar)
		{
			return i;
		}
	}
	return -1;
}
stock bool:bCharIndex(const Input[], const mChar)
{
	if(CharIndex(Input, mChar) >= 0) return true;
	return false;
}
stock bool:str_started(source[], find[], bool:exact = false)
{
	new slen = strlen(find);
	new sourcelen = strlen(source);
	if(equal(source, find, slen))
	{
		if(exact)
		{
			if(slen == sourcelen) return true;
			if(source[slen] == ' ') return true;
			return false;
		}
		return true;
	}
	return false;
}