#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <scxpmod>
#include <fun>
#define VERSION "1.0"
new skillid;
new SkArray[4][SkillData];
public plugin_init()
{
	register_plugin("SCXP Bullet Damage", VERSION, "Ibm")
}
public xp_main()
{
	skillid = xp_newskill("SK_INCDAMAGE");
	if(skillid < 0) return;
	
	SkArray[XP_CL_PRESTIGE][skd_MaxLevel] = 25
	SkArray[XP_CL_PRESTIGE][skd_MaxInterval] = 0
	SkArray[XP_CL_PRESTIGE][skd_MaxEffect] = 1
	SkArray[XP_CL_PRESTIGE][skd_MaxRadius] = 0
	
	SkArray[XP_CL_MAROONBERETS][skd_MaxLevel] = 110
	SkArray[XP_CL_MAROONBERETS][skd_MaxInterval] = 0
	SkArray[XP_CL_MAROONBERETS][skd_MaxEffect] = 6
	SkArray[XP_CL_MAROONBERETS][skd_MaxRadius] = 0
	xp_setskill(XP_CL_PRESTIGE, skillid, SkArray[XP_CL_PRESTIGE]);
	xp_setskill(XP_CL_MAROONBERETS, skillid, SkArray[XP_CL_MAROONBERETS]);
}
public xp_player_takedamage(id, plclass, inflictor, attacker, Float:damage, damagebits)
{
	if(is_running("svencoop")) return XP_IGNORED;
	if(!attacker) return XP_IGNORED;
	if(attacker > 32) return XP_IGNORED;
	new aplclass = xp_get_userclass(attacker);
	if(aplclass != XP_CL_MAROONBERETS && aplclass != XP_CL_PRESTIGE) return XP_IGNORED;
	if(xp_isplayerbanned(attacker) || !xp_isplayerloggedin(attacker))
	{
		return XP_IGNORED;
	}
	new Float:Max_Level = float(SkArray[aplclass][skd_MaxLevel]);
	new Float:User_Level = float(xp_get_userlevel(attacker, skillid));
	if(User_Level > 0)
	{
		new Float:MaxEffectVal = float(SkArray[aplclass][skd_MaxEffect]);
		new Float:Multiplier = 1 + floatmul(floatdiv(User_Level , Max_Level), MaxEffectVal);
		xp_setf(floatmul(damage , Multiplier));
		return XP_HANDLED;
	}
	return XP_IGNORED;
}
public xp_monster_takedamage(id, plclass, inflictor, attacker, Float:damage, damagebits)
{
	if(plclass != XP_CL_MAROONBERETS && plclass != XP_CL_PRESTIGE) return XP_IGNORED;
	new userid;
	if(attacker > 32 && pev_valid(attacker))
	{
		userid = pev(attacker, pev_owner);
	}
	else
	{
		userid = attacker;
	}
	if(plclass >= 0)
	{	
		if(xp_isplayerbanned(userid) || !xp_isplayerloggedin(userid))
		{
			return XP_IGNORED;
		}
		new Float:Max_Level = float(SkArray[plclass][skd_MaxLevel]);
		new Float:User_Level = float(xp_get_userlevel(userid, skillid));
		if(User_Level > 0)
		{
			new Float:MaxEffectVal = float(SkArray[plclass][skd_MaxEffect]);
			new Float:Multiplier = 1 + (floatmul(floatdiv(User_Level , Max_Level), MaxEffectVal) * 0.5);
			xp_setf(floatmul(damage , Multiplier));
			return XP_HANDLED;
		}
	}
	return XP_IGNORED;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
