#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <scxpmod>
#include <fun>
#define VERSION "1.0"
new skillid;
new SkArray[4][SkillData];
new Float:LastTimeEx[33];
public plugin_init()
{
	register_plugin("SCXP GRAVITY", VERSION, "Ibm")
}
public xp_main()
{
	skillid = xp_newskill("SK_GRAVITY");
	if(skillid < 0) return;
	
	SkArray[XP_CL_PRESTIGE][skd_MaxLevel] = 25
	SkArray[XP_CL_PRESTIGE][skd_MaxInterval] = 0
	SkArray[XP_CL_PRESTIGE][skd_MaxEffect] = 25
	SkArray[XP_CL_PRESTIGE][skd_MaxRadius] = 0
	
	SkArray[XP_CL_MAROONBERETS][skd_MaxLevel] = 20
	SkArray[XP_CL_MAROONBERETS][skd_MaxInterval] = 0
	SkArray[XP_CL_MAROONBERETS][skd_MaxEffect] = 90
	SkArray[XP_CL_MAROONBERETS][skd_MaxRadius] = 0
	xp_setskill(XP_CL_PRESTIGE, skillid, SkArray[XP_CL_PRESTIGE]);
	xp_setskill(XP_CL_MAROONBERETS, skillid, SkArray[XP_CL_MAROONBERETS]);
}
public client_putinserver(id)
{
	LastTimeEx[id] = get_gametime();
}
public xp_player_prethink(id, plclass)
{
	if(get_gametime() - LastTimeEx[id] < 1.0) return;
	if(!xp_enabled()) return;
	LastTimeEx[id] = get_gametime();
	new Float:MaxGravity;
	pev(id, pev_gravity, MaxGravity);
	if(MaxGravity != CalcPlayerGravity(id, plclass))
	{
		set_pev(id, pev_gravity, CalcPlayerGravity(id, plclass));
	}
	if(!is_running("svencoop")) return;
	if(!xp_isplayerbanned(id) && xp_isplayerloggedin(id))
	{
		if(pev(id, pev_oldbuttons) & IN_JUMP && !(pev( id, pev_button ) & IN_JUMP))
		{
			new Float:velocity[3]
			entity_get_vector(id, EV_VEC_velocity, velocity)
			if(velocity[2] > 25.0)
			{
				velocity[2] = 25.0;
				entity_set_vector(id, EV_VEC_velocity, velocity);
			}
		}
	}
}
public xp_need_reset(id, skid, plclass)
{
	if(skid != skillid) return;
	set_pev(id, pev_gravity, 1.0);
}
public xp_need_calc(id, skid, plclass)
{
	if(skid != skillid) return;
	CalcPlayerGravity(id, plclass);
}
public CheckPlayerGravity(id, plclass)
{
	set_pev(id, pev_gravity, CalcPlayerGravity(id, plclass));
}
public Float:CalcPlayerGravity(id, plclass)
{
	if(plclass != XP_CL_MAROONBERETS && plclass != XP_CL_PRESTIGE) return 1.0;
	if(xp_isplayerbanned(id) || !xp_isplayerloggedin(id)) return 1.0;
	new User_Level = xp_get_userlevel(id, skillid);
	new Float:cGravityF = xp_calcpoints(id, skillid, User_Level);
	new Float:Sayi = 100.0;
	Sayi -= cGravityF;
	new Float:Deger;
	Deger = floatdiv(Sayi, 100.0);
	if(User_Level > 0)
	{
		return Deger;
	}
	else
	{
		return 1.0;
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
