#define game_svencoop
#define use_csistatistik
#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <fun>
#include <hamsandwich>
#include <xp_monster>
#include <xp_misc>
#include <scxpmod_const>
#include <ibm_say>
#include <sqlx>
#include <xp_string>

#if defined use_csistatistik
#include <cs_istatistik>
#endif
#include <scxp_notify>

#if !defined game_svencoop
#include <scxp_login>
#endif 

#define VERSION "1.4.5" //
#define LUPDATE "26/08/2019"
#define HudChannel 346
#pragma tabsize 0
#pragma dynamic 65536 


// Level Variants
#define MaxPlayers 32
#define SkillsCount 50
new StartXP, XPMultiplier;
#define MinRadiusValue 25.0
enum
{
	menu_increase = -5,
	menu_autoassign = -10
}
enum
{
	Medic = 0,
	Soldier,
	Maroon_Berets,
	Prestige
}
enum 
{
	//Oyuncu dier seenekleri,
	XP = 50,
	PlayerLevel,
	Class,
	PrestigeCount,
	Frags,
	Others,
	LoggedIn,
	Banned
}
enum
{
	MaxLevel = 0,
	Usable,
	MaxEffectValue,
	MaxRadiusValue,
	MaxIntervalValue, // 1000 - value, 1 ... 1000.
	MinLevel,
	AccessFlag
}
enum
{
	CurrentLevel = 0,
	CurrentValue,
	IntervalValue,
	LastValue,
	ReqValue,
	TopValue,
	Activate
}
enum _: EEnergyData
{
	eed_name[15],
	eed_energypoints,
	eed_pointiscvar,
	Float:eed_lasttime
}
enum _: UserXPDataHeader
{
	uxdh_userid[100],
	uxdh_first_username[50],
	uxdh_username[50],
	uxdh_joindate,
	uxdh_lastactivity,
	Array:uxdh_UserData,
	uxdh_loadeddata,
	uxdh_userlevel,
	uxdh_userxptotal,
	uxdh_banned,
	uxdh_xpdeactivated,
	uxdh_energykill,
	uxdh_userclass,
	uxdh_xpreqvalue,
	uxdh_xpvalue,
	uxdh_userlevel_max,
	uxdh_prestige,
	uxdh_beforefirst
	
}
enum _: UserXPData
{
	uxd_userid[100],
	uxd_dataname[50],
	uxd_value_A[50],
	uxd_value_B[50],
	uxd_value_C[50],
	uxd_value_D[50]	
}
new EnergyData[11][EEnergyData];
new PlayerHelpTime[33]
new LevelString[60][100]
new LevelClass[4][60][7]
new PlayerSkills[33][60][7]
new SelectedSkills[33];
new SelectedPage[33];
new MaxLevels[5]
new MaxLevels_items[4];
new MaxLevels_player[33][4];
new Float:UserXPMultiplier[33];
new XPSuperAdmin[33];
new XPSpecRankid[33];
new FWReturn;
new bool:FirstCalced[33];
new bool:DataNormallyLoaded[33];
new LastCheckTime;
new xpReturn, Float:xpReturnFloat;
new UserFrag[33];
new EnergyUsedCount[33];
new EnergyKillValue[33];
new energy_loaded = 1;
new energy_current_item[33];
//1.4.0 Energy System Improved
//1.4.0 Beta 1 Surumu
//--Yeni scxp_login eklentisi ile uyumlu hale getirildi.
//--xp_player_namechanged kaldrld.
//--timerregen her oyuncu icin task ayarland.
//--frag kontrol ekli artk playerkilled zerinden yaplacak
//--xp_maxlevel cvar eklendi.
//--xp_skill_balance cvar eklendi.
//--xp_level_incxp ve xp_startxp cvar eklendi
//--user_canaccessskill stock eklendi.
//--xp_player_levelchanged native eklendi.
//--xp_killpoints cvar eklendi.
//--svencoop ve cstrike ile uyumlu hale getirildi
//1.4.0 Beta 2 Srm
//--user_canselectskill fonksiyon ve bal forward eklendi.
//--performans iyiletirmesi yapld.
//--Motd mesajlar cs iinde dzeltidi.
//--svencoop iin loginmod bamll kaldrld.
//--svencoop kayt sorunu iin yeni yol yapld.
//k yaplrken verileri sfrlamama sorunu dzeltidi.
// Other Variants
new registered_skills;
new bool:TaskStarded;
new bool:LoginRequired;
new bool:SkillType;
new bool:CfgExec;
//Added 1.2.2: 21.03.2014
new LastAim[33];
new SkillTaskId;
new HudTaskId;
new XPDeactivate[33];
//Added 1.3: 23.03.2014
new fw_interval_invoked, fw_main;
//Added 1.3: 25.03.2014
new fw_needcalc, fw_player_takedamage, fw_monster_takedamage, fw_timer, fw_pre_think, fw_needreset;
new fw_plspawned, fw_plkilled, fw_pllevelchanged, fw_plselectskill, fw_energyusing_item, fw_energycanuse_item;
new fw_energyvalchanged, fw_energyused;
new bool:dMaps;
new moffset = 10;
new Float:LastNickTime[33];
new is_hl;
new Cvar_Enabled, Cvar_ShowAddonname, Cvar_Multipler, Cvar_Skilltype, Cvar_MulPrestige, Cvar_IntervalMul, Cvar_MaxLevel, Cvar_SkillBalance;
new Cvar_LevelIncXP, Cvar_StartXP, Cvar_KillPoints;
new Cvar_EnabledEnergy, Cvar_EnergyKill, Cvar_EnergyMapLimit, Cvar_EnergyMinlevel;
new Cvar_AccessCmdOnlySuperAdmin;
#if !defined game_svencoop
new Cvar_LoginRequired;
#endif
new Cvar_RoundFragLimit;
//Romoved From 1.2 03.03.2014: new SpeedTaskId; 
new Handle:g_Tuple;
new Handle:SQLConnection;
new bool:SQLLoaded;
public plugin_init()
{
	register_plugin("SC/CS Advanced Experience Mod", VERSION, "Lt.(Ibm)")
	register_forward(FM_GetGameDescription,"xp_gamedesc")
	register_forward(FM_ClientUserInfoChanged, "UserInfoChanged") 
	if(is_running("svencoop")) register_forward( FM_ClientKill, "client_kill" ); //Sadece svencoop icin
	register_dictionary("scxp_ibm.txt");
	register_dictionary("scxp_skills.txt");
	//1.2
	register_forward(FM_PlayerPreThink,"xp_variant_check")
	//
	register_concmd("xp_ban","xp_ban",ADMIN_BAN, "<player> - ban player from xp mod")
	register_concmd("xp_unban","xp_unban",ADMIN_BAN, "<Player> - unban player from xp mod")
	register_concmd("xp_deactivate","xp_deactivate",ADMIN_BAN, "Deactivate xp mod")
	register_concmd("xp_activate","xp_activate",ADMIN_BAN, "Activate xp mod")
	register_concmd("xp_clientcmd","xp_clientcmd",ADMIN_CVAR,"<Player> <Command> - set commands to player console")
	register_concmd("xp_setlevel","xp_setlevel",ADMIN_CVAR,"<Player> <Value> - Set player level")
	register_concmd("xp_remove","xp_remove",ADMIN_CVAR,"<Player> - Delete player data")
	register_concmd("xp_resetskill","xp_resetskill",ADMIN_CVAR,"<Player> - Oyuncunun tum bilgilerini sifirlar")
	register_concmd("xp_addxp","xp_addxp",ADMIN_CVAR,"<Player> Value - Increase player XP points")
	register_concmd("xp_removexp","xp_removexp",ADMIN_CVAR,"<Player> Value - Decrease player XP points")
	register_concmd("xp_about","xp_about",-1,"- Show addons about")
	register_concmd("xp_enerji_fulle","xp_enerji_fulle_cmd", ADMIN_CVAR,"<Player>  - Full enegy row for given player")
	register_concmd("xp_fill_energy","xp_enerji_fulle_cmd", ADMIN_CVAR,"<Player>  - Full enegy row for given player")
	//1.2

	#if defined game_svencoop
	register_clcmd("grenade","xp_useenergy",-1,"- User XP Energy")
	#else
	register_clcmd("radio3","xp_useenergy",-1,"- User XP Energy")
	#endif
	
	
	
	register_clcmd("xp_commandmenu","xp_komutmenusu",-1,"- Show the alaviable commands")
	register_concmd("xp_showplayers","xp_digeroyuncular",-1,"- Show other players")
	//
	//1.4.0 Beta 1 Srm ile kaldrld
	//register_clcmd("say vote", "xp_vote", -1, "- Show Vote Menu");
	//register_clcmd("say votemap", "xp_vote", -1, "- Show Vote Menu");
	register_cvar("xpmod_version", VERSION, FCVAR_SERVER);
	Cvar_Enabled = register_cvar("xp_enabled", "1");
	Cvar_ShowAddonname = register_cvar("xp_showaddonname","1")
	Cvar_Multipler = register_cvar("xp_multiplier", "1.0")
	Cvar_Skilltype = register_cvar("xp_skilltype", "0") //Siniflandirma yok
	Cvar_MulPrestige = register_cvar("xp_multiplier_prestige", "2.5");
	#if !defined game_svencoop
	Cvar_LoginRequired = register_cvar("xp_loginrequired", "1");
	#endif
	Cvar_RoundFragLimit = register_cvar("xp_roundfraglimit", "300");
	Cvar_IntervalMul = register_cvar("xp_intervalmultiplier", "2");
	register_cvar("xp_admin_showactionmessage", "1");
	Cvar_MaxLevel = register_cvar("xp_maxlevel", "100");
	Cvar_SkillBalance = register_cvar("xp_skill_balance", "1"); //1 olarak ayarlanrsa user dier itemlerin seviyesini artrmadan dorudan bir itemin seviyesini artramaz.
	//1.4.0 Beta 1 Srmyle eklendi 14.09.2018
	Cvar_LevelIncXP = register_cvar("xp_level_incxp", "30"); //Seviye atladka sonraki seviye iin gereken xp ye ekleyecei ek xp
	Cvar_StartXP = register_cvar("xp_startxp", "70"); //lk seviye iin gereken XP
	Cvar_KillPoints = register_cvar("xp_killpoints", "5"); //Her dman ldrdnde kazanlacak puan/xp;
	Cvar_AccessCmdOnlySuperAdmin = register_cvar("xp_access_superadminonly", "0"); //xp_setlevel, xp_addxp, xp_removexp only super admin to use.
	//
	SkillTaskId = 549;
	HudTaskId = 583;
	server_cmd("exec addons/amxmodx/configs/scxp_ibm.cfg");
	server_exec();
	GirisAyarlari();
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage", 0);
   	RegisterHam(Ham_Spawn, "player", "PlayerSpawned", 1);
	RegisterHam(Ham_Killed, "player", "PlayerKilled", 1);
	dMaps = CheckXPDisabled();
	StartTask();
	set_task(1.00, "xp_controller", 0, "", 0, "b");
	//1.4.0 Beta 1 de deitirildi.
	register_concmd("kaydet","xp_savexp",-1,"- Save your skills")
	register_concmd("save","xp_savexp",-1,"- Save your skills")
	is_hl = is_running("valve");
	
	
	Cvar_EnabledEnergy = register_cvar("xp_energy_enabled", "1");
	Cvar_EnergyMapLimit = register_cvar("xp_energy_maplimit", "3");
	Cvar_EnergyMinlevel = register_cvar("xp_energy_minlevel", "0");
	Cvar_EnergyKill = register_cvar("xp_energy_killcount", "30");
	sqlite_init();
}
public sqlite_init()
{
	new Error[256], ErrorCode, Handle:GcHandle;
	g_Tuple = SQL_MakeDbTuple("", "", "", "xp_mod_db");
	SQLConnection = SQL_Connect(g_Tuple, ErrorCode, Error, sizeof(Error) - 1);
	if(SQLConnection == Empty_Handle) return;
	GcHandle = SQL_PrepareQuery(SQLConnection, "CREATE TABLE IF NOT EXISTS xp_mod_main (userid TEXT, first_username TEXT, username TEXT, joindate NUMERIC, lastactivity NUMERIC)");
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
	
	GcHandle = SQL_PrepareQuery(SQLConnection, "CREATE TABLE IF NOT EXISTS xp_mod_userinfo (userid TEXT, userlevel NUMERIC, userlevel_max NUMERIC, userxptotal NUMERIC, banned NUMERIC, xpdeactivated NUMERIC, energykill NUMERIC, userclass NUMERIC, xpvalue NUMERIC, xpreqvalue NUMERIC, prestige NUMERIC, beforefirst NUMERIC)");
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
	
	GcHandle = SQL_PrepareQuery(SQLConnection, "CREATE TABLE IF NOT EXISTS xp_mod_data (userid TEXT, dataname TEXT, value_A TEXT, value_B TEXT, value_C TEXT, value_D TEXT)");
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
	SQLLoaded = true;
	//formatex(Query, sizeof(Query), "SELECT * FROM xp_lastid WHERE lastname = '%s'", XPL_Last);
	//SQL_ThreadQuery(g_Tuple, "LastID", Query, Data, sizeof(Data));
}
public stdquery(State, Handle:Query, Error[], ErrorCode, Data[])
{
	SQL_FreeHandle(Query);
}
stock get_nextbestability(id, outstr[15])
{
	energy_current_item[id] = 0;
	new eids[10];
	new ntotal = get_energyids(id, eids);
	if(!ntotal) return 0;
	new Float:GTime = get_gametime();
	new showid = -1;
	if(ntotal > 1)
	{
		for(new i = 0; i < ntotal; i++)
		{
			new EnData[EEnergyData];
			EnData = EnergyData[i];
			if(EnData[eed_lasttime] == 0.0)
			{
				showid = i;
				EnData[eed_lasttime] = GTime + 0.1;
				EnergyData[i] = EnData;
				break;
			}
			else
			{
				if(GTime - EnData[eed_lasttime] < 5.0)
				{
					showid = i;
				}
			}
		}
		if(showid < 0)
		{
			for(new i = 0; i < ntotal; i++)
			{
				new EnData[EEnergyData];
				EnData = EnergyData[i];
				if(i == 0)
				{
					EnData[eed_lasttime] = GTime + 0.1;
				}
				else
				{
					EnData[eed_lasttime] = 0.0;
				}
				EnergyData[i] = EnData;
			}
			showid = 0;
		}
	}
	else
	{
		showid = 0;
	}
	energy_current_item[id] = eids[showid];
	return formatex(outstr, 14, EnergyData[eids[showid]][eed_name]);
}
stock get_epoints(EnData[EEnergyData])
{
	if(EnData[eed_pointiscvar])
	{
		return get_pcvar_num(EnData[eed_energypoints]);
	}
	return EnData[eed_energypoints];
}
stock get_energyids(id, eng[10])
{
	new epoint = EnergyKillValue[id];
	if(epoint <= 0) return 0;
	new findpoint = 0;
	new totalenergy = 0;
	for(new i = 1; i < energy_loaded; i++)
	{
		new EnData[EEnergyData];
		EnData = EnergyData[i];
		new enerjipts = get_epoints(EnData);
		if(!energy_can_use(id, i, 1, 0, 0)) continue;
		if(enerjipts > findpoint)
		{
			eng[0] = i;
			totalenergy = 1;
			findpoint = enerjipts;
		}
		else if(enerjipts == findpoint)
		{
			eng[totalenergy] = i;
			totalenergy++;
		}
	}
	return totalenergy;
}
#if defined use_csistatistik
public xp_player_dataloaded(id)
{
	UserXPMultiplier[id] = xp_getuserdynvalue_float(id, "udata_xp_mul");
	if(UserXPMultiplier[id] <= 0) UserXPMultiplier[id] = 1.0;
	XPSuperAdmin[id] = xp_getuserdynvalue_num(id, "udata_xp_superadmin");
	XPSpecRankid[id] = xp_getuserdynvalue_num(id, "udata_xp_specialrankid");
}
#endif
public ibm_say_main()
{
	register_saycmd("xpmenu", "xp_komutmenusu_isay", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_players", "xp_digeroyuncular", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_resetskills", "xp_reset", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_skillsinfo", "xp_info", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_resetall", "xp_resetall", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_selectclass", "menu_skillsec", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_selectskill", "xp_yeteneksec", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_prestige", "xp_prestij", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("xp_myskills", "xp_yeteneklerim", -1, 0, "", "", PREFIX, true, false, true);
	register_saycmd("enerji|energy", "xp_enerjikomut", -1, 0, "", "", PREFIX, true, false, true);
}
//Added 1.3.2: 31.08.2014
public bool:CheckXPDisabled()
{
	new configdir[80];
	get_configsdir(configdir, 79);
	formatex(configdir, 79, "%s/scxp_ibm_dmaps.ini", configdir);
	new fp = fopen(configdir, "r");
	if (!fp)
	{
		return false;
	}
	new mapname[100]
	get_mapname(mapname,99);
	new text[256];
	new tempMap[100];
	new stlen;
	new bool:Sonuc = false;
	while (!feof(fp))
	{
		fgets(fp, text, charsmax(text));
		if (text[0] == ';')
		{
			continue;
		}
		if (parse(text, tempMap, charsmax(tempMap)) < 1)
		{
			continue;
		}
		stlen = strlen(tempMap);
		if(stlen <= 0) continue;
		new TestM[100];
		if(stlen > 1)
		{
			if(tempMap[stlen - 1] == '*')
			{
				copy(TestM, stlen - 1, tempMap);
				if(str_started(mapname, TestM))
				{
					Sonuc = true;
					break;
				}
			}
			if(equali(tempMap, mapname))
			{
				Sonuc = true;
				break;
			}
		}
	}
	fclose(fp);
	return Sonuc;
}
//
//Forwards
//Added 1.3: 24.03.2014
public xp_registerforwards()
{
	fw_interval_invoked = CreateMultiForward("xp_interval_invoked", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL);	// id, skid, class
	fw_needcalc = CreateMultiForward("xp_need_calc", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL);	// id, skid, class
	fw_needreset = CreateMultiForward("xp_need_reset", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL);	// id, skid, class
	//Added 1.3: 25.03.2014
	fw_main = CreateMultiForward("xp_main", ET_IGNORE );
	fw_player_takedamage = CreateMultiForward("xp_player_takedamage", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_FLOAT, FP_CELL);
	fw_monster_takedamage = CreateMultiForward("xp_monster_takedamage", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_FLOAT, FP_CELL);
	fw_timer = CreateMultiForward("xp_timer", ET_IGNORE);
	fw_pre_think = CreateMultiForward("xp_player_prethink", ET_IGNORE, FP_CELL, FP_CELL);
	fw_plkilled = CreateMultiForward("xp_player_killed", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL); //id, class, 
	fw_plspawned =   CreateMultiForward("xp_player_spawned", ET_IGNORE, FP_CELL, FP_CELL);
	//
	//Eklendi 1.4.0 Beta 1: 14.09.2018
	fw_pllevelchanged =   CreateMultiForward("xp_player_levelchanged", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL); //id, adminid, n_type, oldlevel, newlevel
	//
	//Eklendi 1.4.0 Beta 2: 14.09.2018
	fw_plselectskill =   CreateMultiForward("xp_player_selectskill", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL); //id, class, skill
	fw_energyvalchanged = CreateMultiForward("xp_energy_valuechanged", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL); //id, oldvalue, newvalue
	fw_energyused = CreateMultiForward("xp_energy_used", ET_CONTINUE, FP_CELL, FP_CELL); //id, usedcount, canbeusednexttime
	fw_energyusing_item = CreateMultiForward("xp_energy_using_item", ET_STOP, FP_CELL, FP_CELL); //id, energyid
	fw_energycanuse_item = CreateMultiForward("xp_energy_canuseitem", ET_STOP, FP_CELL, FP_CELL, FP_CELL); //id, energyid, hudmsg
}
//
//<End Forwards>

//Natives
//Added 1.3: 24.03.2014
public plugin_natives()
{
	register_library("scxp ibm");
	register_native("xp_newskill", "xp_newskill_n");
	register_native("xp_setskill", "xp_setskill_n");
	register_native("xp_get_userlevel", "xp_get_userlevel_n");
	register_native("xp_get_userreqxp", "xp_get_userreqxp_n");
	register_native("xp_get_userrankid", "xp_get_userrankid_n");
	register_native("xp_get_userrank", "xp_get_userrank_n");
	register_native("xp_get_userclass", "xp_get_userclass_n");
	register_native("xp_calcpoints", "xp_calcpoint_n");
	register_native("xp_calcradius", "xp_calcradius_n");
	//Added 1.3:25.03.2014
	register_native("xp_calcmax", "xp_calcmax_n");
	register_native("xp_isplayerbanned", "xp_isplayerbanned_n");
	//
	//Added 1.3:26.03.2014
	register_native("xp_set", "xp_set_n");
	register_native("xp_setf", "xp_setf_n");
	//
	register_native("xp_isplayerloggedin", "xp_isplayerloggedin_n");

	//Added 1.4.0 Beta 5:10.02.2019
	register_native("xp_enabled", "xp_enabled_n");
	
	//Added 1.4.0 Beta 10:28.06.2019
	register_native("xp_refresh_player_hud", "xp_refresh_player_hud_n");
	register_native("xp_energy_canuse", "xp_energy_canuse_n");
	register_native("xp_energy_killcount", "xp_energy_killcount_n");
	register_native("xp_energy_setkillcount", "xp_energy_setkillcount_n");
	register_native("xp_energy_usedcount", "xp_energy_usedcount_n");
	register_native("xp_energy_setusedcount", "xp_energy_setusedcount_n");
	register_native("xp_energy_enabled", "xp_energy_enabled_n");
	register_native("xp_energy_maxkill", "xp_energy_maxkill_n");
	register_native("xp_energy_maxusage", "xp_energy_maxusage_n");
	register_native("xp_energy_use", "xp_energy_use_n");
	register_native("xp_energy_register", "xp_energy_register_n");
}
public xp_energy_register_n() //id
{
	new SkillStr[15];
	if(!get_string(1, SkillStr, 14)) return 0;
	return xp_energy_register_stock(SkillStr, get_param(2), get_param(3));
}
stock xp_energy_register_stock(energynm[15], energypts, energyptsiscvar)
{
	if(energypts <= 0) return 0;
	new saycmds[15];
	new energym_new[15];
	new sayinfo[4];
	if(energynm[0] != '/')
	{
		formatex(energym_new, 13, energynm[1]);
	}
	else
	{
		formatex(energym_new, 14, energynm);
	}
	formatex(saycmds, 14, energynm[1]);
	formatex(sayinfo, 3, "%i", energy_loaded);
	register_saycmd(saycmds, "xp_enerjikomut_ext", -1, 0, "", sayinfo, PREFIX, true, false, true);
	new EnergyPrm[EEnergyData];
	formatex(EnergyPrm[eed_name], 14, energym_new);
	EnergyPrm[eed_energypoints] = energypts;
	EnergyPrm[eed_pointiscvar] = energyptsiscvar;
	EnergyData[energy_loaded] = EnergyPrm;
	energy_loaded++;
	return (energy_loaded - 1);	
}
public xp_energy_use_n() //id
{
	new id = get_param(1);
	return use_energy(id);
}
public xp_energy_maxusage_n() //id
{
	return get_pcvar_num(Cvar_EnergyMapLimit);
}
public xp_energy_maxkill_n() //id
{
	return get_pcvar_num(Cvar_EnergyKill);
}
public xp_energy_setusedcount_n() //id
{
	new id = get_param(1);
	if(!user_canuseenergy(id))
	{
		return;
	}
	new nparam2 = get_param(2);
	if(nparam2 < 0) nparam2 = 0;
	new ntype = get_param(3);
	new nvalue = nparam2;
	if(ntype == 1)
	{
		nvalue = EnergyUsedCount[id] + nparam2;
	}
	else if(ntype == 2)
	{
		nvalue = EnergyUsedCount[id] - nparam2;
	}
	EnergyUsedCount[id] = nvalue;
}
public xp_energy_setkillcount_n() //id
{
	new id = get_param(1);
	if(!user_canuseenergy(id))
	{
		return;
	}
	new EnergyKillCount = get_pcvar_num(Cvar_EnergyKill);
	new nparam2 = get_param(2);
	if(nparam2 < 0) nparam2 = 0;
	new ntype = get_param(3);
	new refhud = get_param(4);
	new nvalue = nparam2;
	if(ntype == 1)
	{
		nvalue = EnergyKillValue[id] + nparam2;
	}
	else if(ntype == 2)
	{
		nvalue = EnergyKillValue[id] - nparam2;
	}
	nvalue = clamp(nvalue, 0, EnergyKillCount);
	new oldval = EnergyKillValue[id];
	EnergyKillValue[id] = nvalue;
	new FWReturnEx;
	ExecuteForward(fw_energyvalchanged, FWReturnEx, id, oldval, nvalue);
	if(refhud)
	{
		xp_hud_show_player(id);
	}
}
public xp_energy_enabled_n() //id
{
	return get_pcvar_num(Cvar_EnabledEnergy);
}
public xp_energy_usedcount_n() //id
{
	new id = get_param(1);
	return EnergyUsedCount[id];
}
public xp_energy_canuse_n() //id
{
	new id = get_param(1);
	return user_canuseenergy(id);
}
public xp_energy_killcount_n() //id
{
	new id = get_param(1);
	if(user_canuseenergy(id))
	{	
		return EnergyKillValue[id];
	}
	return -1;
}
public xp_refresh_player_hud_n() //id
{
	new id = get_param(1);
	if(id)
	{
		xp_hud_show_player(id);
	}
	else
	{
		xp_hud_show();
	}
}
public xp_enabled_n()
{
	return get_pcvar_num(Cvar_Enabled);
}
//Eklendi 1.4.0 Beta 2: 22.09.2018
public xp_isplayerloggedin_extra(id)
{
	#if !defined game_svencoop
	return xp_isplayerloggedin(id);
	#else
	return 1;
	#endif
}
public bool:xp_isplayerloggedin_n() //id
{
	new id = get_param(1);
	return ((PlayerSkills[id][LoggedIn][CurrentValue] > 0) ? true : false);
}
//
//Added 1.3.2: 16.08.2014
public xp_player_loggedin(id, plid[], plname[])
{
	xp_loaduserdatalog(id, plname);
	if(!is_running("svencoop"))
	{
		Work_xp_player_loggedin(id, plid);
		DataNormallyLoaded[id] = true;
	}
}
public Work_xp_player_loggedin(id, plid[])
{
	PlayerSkills[id][PlayerLevel][LastValue] = -1
	PlayerHelpTime[id] = 50;
	PlayerSkills[id][Class][CurrentValue] = -1
	PlayerSkills[id][LoggedIn][CurrentValue] = 1;
	OyuncuAyarlariniYukle(id, plid);
	if (!get_pcvar_num(Cvar_Enabled))
	{
		resetplayervariants(id);
	}
	else
	{
		LevelAyarla(id);
	}
}
//
//Added 1.3.2: 16.08.2014
public xp_player_register(id, plid[], plname[])
{
	if(!is_running("svencoop"))
	{
		PlayerSkills[id][LoggedIn][CurrentValue] = 1;
		LevelAyarla(id);
		DataNormallyLoaded[id] = true;
	}
}
//
//Added 1.3.2: 16.08.2014
public xp_player_loggedout(id, plid[], plname[])
{
	if(!is_running("svencoop"))
	{
		xp_ibm_savexp(id, plid);
		PlayerSkills[id][LoggedIn][CurrentValue] = 0;
		resetplayervariants(id);
		PlayerSkills[id][PlayerLevel][LastValue] = -1;
		DataNormallyLoaded[id] = false;
		Work_client_disconected(id);
		calc_usermaxlevels(id);
	}
}
//
//Added 1.3: 24.03.2014
public xp_get_userlevel_n() 
{
	new id = get_param(1);
	new skid = get_param(2);
	if(skid > registered_skills) return -1;
	if(!id) return -2;
	if(id > 32) return -2;
	if(!isUserLoggedIn(id)) return -1;
	if(!skillactivate(id, skid)) return 0;
	if(skid < 0)
	{
		return PlayerSkills[id][PlayerLevel][CurrentValue];
	}
	return PlayerSkills[id][skid][CurrentLevel];
}
//

//Added 1.3: 24.03.2014
public xp_get_userrankid_n()
{
	new id = get_param(1);
	if(!id) return 0;
	if(id > 32) return 0;
	if(!isUserLoggedIn(id)) return 0;
	return get_user_rankid(id);
}
//
//Added 1.3: 24.03.2014
public xp_get_userrank_n()
{
	new id = get_param(1);
	if(!id) return 0;
	if(id > 32) return 0;
	if(!isUserLoggedIn(id)) return 0;
	new rankt[35];
	get_user_rank(id, rankt, 34);
	set_string(2, rankt, get_param(3));
	return 1;
}
//
//Added 1.3: 24.03.2014
public xp_get_userreqxp_n()
{
	new id = get_param(1);
	if(!id) return -1;
	if(id > 32) return -1;
	if(!isUserLoggedIn(id)) return -1;
	return PlayerSkills[id][XP][ReqValue];
}
//
//Added 1.3: 24.03.2014
public xp_newskill_n()
{
	if(registered_skills >  SkillsCount)
	{
		return 0;
	}
	registered_skills++;
	new SkillStr[100];
	get_string(1, SkillStr, 99);
	formatex(LevelString[registered_skills - 1], 99, "%s", SkillStr); 
	return registered_skills - 1;
}
//
//Added 1.3: 24.03.2014
public xp_setskill_n()
{	
	new skid = get_param(2);
	if(skid < 0 ||skid >= SkillsCount) return false;
	new classid = get_param(1);
	if(classid < 0 || classid > 3) return false;
	new nSkillData[SkillData];
	get_array(3, nSkillData, SkillData);
	new maxlevel = nSkillData[skd_MaxLevel];
	if(maxlevel < 1) return false;
	new maxinterval = nSkillData[skd_MaxInterval];
	new maxeffectval = nSkillData[skd_MaxEffect];
	new maxradius = nSkillData[skd_MaxRadius];
	LevelClass[classid][skid][Usable] = 1;
	LevelClass[classid][skid][MaxLevel] = maxlevel;
	LevelClass[classid][skid][MaxIntervalValue] = maxinterval;
	LevelClass[classid][skid][MaxEffectValue] = maxeffectval;
	LevelClass[classid][skid][MaxRadiusValue] = maxradius;
	LevelClass[classid][skid][MinLevel] = nSkillData[skd_MinLevel];
	LevelClass[classid][skid][AccessFlag] = nSkillData[skd_AccessFlag];
	MaxLeveliAyarla();
	return true;
}
//
//Added 1.3: 24.03.2014
public xp_get_userclass_n() //id
{
	new id = get_param(1);
	if(!id) return -1;
	if(id > 32) return -1;
	if(!isUserLoggedIn(id)) return -1;
	return PlayerSkills[id][Class][CurrentValue];
}
//

//Added 1.3: 24.03.2014
public Float:xp_calcpoint_n() //id, skill, playerlevel
{
	new id = get_param(1);
	if(!id) return 0.0;
	new skid = get_param(2);
	if(skid < 0 ||skid >= SkillsCount) return 0.0;
	new pllevel = get_param(3);
	if(pllevel <= 0) return 0.0;
	if(!isUserLoggedIn(id)) return 0.0;
	return CalcPlayerPoints(id, skid, pllevel);
}
//
//Added 1.3: 24.03.2014
public Float:xp_calcradius_n() //id, skill, playerlevel
{
	new id = get_param(1);
	if(!id) return 0.0;
	new skid = get_param(2);
	if(skid < 0 ||skid >= SkillsCount) return 0.0;
	new pllevel = get_param(3);
	if(pllevel <= 0) return 0.0;
	if(!isUserLoggedIn(id)) return 0.0;
	return (MinRadiusValue + CalcPlayerRadius(id, skid, pllevel));
}
//
//Added 1.3: 25.03.2014
public Float:xp_calcmax_n() //id, skillid, pevmax
{
	new id = get_param(1);
	if(!id) return 0.0;
	new skid = get_param(2);
	if(skid < 0 ||skid >= SkillsCount) return 0.0;
	new pevmax = get_param(3);
	return CalcPlayerMax(id, skid, pevmax);
}
//
//Added 1.3.4:22.07.2015
public bool:skillactivate(id, skid)
{
	if(id > 32) return false;
	if(skid < 0) return false;
	if(XPDeactivate[id]) return false;
	if(!PlayerSkills[id][skid][Activate]) return false;
	return true;
}
//
//Added 1.3: 25.03.2014
public bool:xp_isplayerbanned_n() //id
{
	return (PlayerSkills[get_param(1)][Banned][CurrentValue] > 0 ? true : false);
}
//
//Added 1.3: 26.03.2014
public xp_set_n()
{
	new val = get_param(1);
	xpReturn = val;
}
//
//Added 1.3: 26.03.2014
public xp_setf_n()
{
	new Float:val = get_param_f(1);
	xpReturnFloat = val;
}
//
//<End Natives>

//Added 1.3.1: 25.04.2014
public xp_deactivate(id, level, cid)
{
	if(!cmd_access(id,level,cid,1))
	{
		return PLUGIN_HANDLED;
	}
	if(!cmd_access_ex_superadmin(id)) return PLUGIN_HANDLED;
	server_cmd("xp_enabled 0");
	return PLUGIN_HANDLED;
}
//
//Added 1.3.1: 25.04.2014
public xp_activate(id, level, cid)
{
	if(!cmd_access(id,level,cid,1))
	{
		return PLUGIN_HANDLED;
	}
	if(!cmd_access_ex_superadmin(id)) return PLUGIN_HANDLED;
	server_cmd("xp_enabled 1");
	return PLUGIN_HANDLED;
}

//Added 1.2 03.03.2014
public SendServerError()
{
	server_print("%s%L", PREFIX, LANG_SERVER, "XP_CMD_ERROR_SERVER");
}
public plugin_cfg()
{
	if(!CfgExec)
	{
		CfgExec = true;
		#if defined game_svencoop
		LoginRequired = false;
		#else
		LoginRequired = (get_pcvar_num(Cvar_LoginRequired) > 0 ? true : false);
		#endif
		SkillType = (get_pcvar_num(Cvar_Skilltype) > 0 ? true : false);
		StartXP = get_pcvar_num(Cvar_StartXP);
		XPMultiplier = get_pcvar_num(Cvar_LevelIncXP);
	}
}

public xp_about(id)
{	
	console_print(id, "<--%sSven Coop/CStrike XPMod-->", PREFIX);
	console_print(id, "---%L", id, "XP_ABOUT_VER", VERSION);
	console_print(id, "---%L", id, "XP_ABOUT_LU", LUPDATE);
	//console_print(id, "---%L", id, "XP_ABOUT_TR");
	console_print(id, "---Author: %s", "Lt.");
	console_print(id, "---Web: %s", "www.ltibmcode.com");
	return PLUGIN_HANDLED;
}
//Added 1.2.1: 11.03.2014
public ShowPlayerHelpMessage(id)
{
		new HudText[500]
		set_hudmessage(255, 255, 0, 0.6, 0.8, 0, 1.0, 40.0, 0.0, 0.0, HudChannel + 2);
		formatex(HudText, 499, "%L", id, "XP_HELP_CMD", VERSION);
		//Added 1.3: 27.03.014
		//1.4.0 Beta 1 Srmnde kaldrld
		//formatex(HudText, 499, "%s^n-->%L", HudText, id, "XP_HELP_MENU");
		//
		formatex(HudText, 499, "%s^n-->/xpmenu | /xp_selectskill", HudText);
		formatex(HudText, 499, "%s^n-->/xp_skillsinfo | /xp_myskills", HudText)
		if(is_running("svencoop")) formatex(HudText, 499, "%s^n-->/votemap", HudText)
		formatex(HudText, 499, "%s^n-->/xp_players | /xp_resetskills", HudText)
		formatex(HudText, 499, "%s^n-->/login <n><pw> | /register <n><pw>", HudText)
		formatex(HudText, 499, "%s^n-->in console: xp_about", HudText)
		show_hudmessage(id, HudText);
}
//
public StartTask()
{
	for(new i = 1; i <= 32; i++)
	{
		set_task(0.20, "xp_skills_regen", SkillTaskId + i, "", 0, "b")
	}
	//set_task(0.25, "xp_check_frags", FragTaskId, "", 0, "b")
	set_task(10.00, "xp_hud_show", HudTaskId, "", 0, "b");
	//Removed From 1.2: set_task(0.00, "xp_variant_check", SpeedTaskId, "", 0, "b"); 03.03.2014
	TaskStarded = true;
}
public StopTask()
{
	for(new i = 1; i <= 32; i++)
	{
		remove_task(SkillTaskId + i);
	}
	//remove_task(FragTaskId);
	remove_task(HudTaskId);
	//Removed From 1.2: remove_task(SpeedTaskId); 03.03.2014
	TaskStarded = false;
}
public xp_controller()
{
	ExecuteForward(fw_timer, FWReturn);
	if(dMaps)
	{
		set_cvar_num("xp_enabled", 0);
		dMaps = false;
	}
	LastCheckTime--;
	if(LastCheckTime <= 0)
	{
		for(new i=1; i < 33; i++)
		{
			if(!is_user_connected(i)) continue;
			if(is_user_bot(i)) continue;
			if(DataNormallyLoaded[i]) continue;
			Work_cputinserver(i);
		}
		LastCheckTime = 10;
	}
	if (get_pcvar_num(Cvar_Enabled))
	{
		if(!TaskStarded)
		{
			StartTask();
			for(new i = 1; i < 33;i++)
			{
				if(!is_user_connected(i)) continue;
				#if !defined game_svencoop
				PlayerSkills[i][LoggedIn][CurrentValue] = xp_isplayerloggedin(i);
				#else
				PlayerSkills[i][LoggedIn][CurrentValue] = 1;
				#endif
				
				PlayerSkills[i][Others][CurrentValue] = 1;
				CheckPlayerVariants(i);
				PlayerSkills[i][Frags][CurrentValue] = get_user_frags(i);
			}
			xp_hud_show();

		}
	}
	else
	{
		if(TaskStarded)
		{
			StopTask();
			for(new i = 1; i < 33;i++)
			{
				if(!is_user_connected(i)) continue;
				if(is_running("svencoop"))
				{
					new steamid[32];
					get_user_authid( i, steamid, charsmax(steamid));
					xp_ibm_savexp(i, steamid);
				}
				else
				{
					#if !defined game_svencoop
					new uid[15];
					if(xp_login_getplayerid(i, uid, 14))
					{
						xp_ibm_savexp(i, uid);
					}
					#endif
				}

				PlayerSkills[i][LoggedIn][CurrentValue] = 0;
				resetplayervariants(i);
				set_hudmessage(0, 255, 170, 0.0, 0.0, 0, 1.0, 1.0, 0.1, 0.2, HudChannel);
				show_hudmessage(i, "");
			}
		}
	}
}
public xp_clientcmd(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id, targetarg, 2)
	if(!target)
	{
		console_print(id, "%s%L", PREFIX, id, "CMD_USER_NFOUND", targetarg);
		return PLUGIN_HANDLED;
	}
	new commandarg[90]
	read_argv(2,commandarg,89)
	console_print(id, "%s%L", PREFIX, id, "XP_CLIENTCMD_SUCCESS");
	replace_all( commandarg, 89, "{q}", "^"" )
	client_cmd(target, "%s", commandarg);
	return PLUGIN_HANDLED;
}
// Added 1.2.2: 21.03.2014
// Changed 1.3.2: 17.08.2014 Bug Fixed
// Updated 1.4.0 Beta 10
public showplayerinfo(id)
{
	if(!is_user_alive(id)) return;
	new body, target;
	get_user_aiming(id, target, body);
	new HudText[1000];
	new hudchars = charsmax(HudText);
	new HudWritten;
	new UserLevel;
	new URank[35]
	new entclass[50];
	new UName[40];
	if(target == LastAim[id]) return;
	LastAim[id] = target;
	//42 255 212
	// Added 1.3.2: 17.08.2014
	pev(target, pev_classname, entclass, sizeof entclass - 1)
	if(strfind (entclass,"player") == -1) 
	{
		return;
	}
	//
	new Float:lx;
	new Float:ly;
	new Float:UHeatlh;
	new Float:UArmor;
	pev(target, pev_health, UHeatlh);
	pev(target, pev_armorvalue, UArmor);
	lx = 0.2;
	ly = 0.6;
	get_user_name(target, UName, 39);
	new bool:isenemy = false;
	if(target > 0 && target <= 32)
	{
		if(!is_running("svencoop"))
		{
			if(get_user_team(target) != get_user_team(id) || is_hl)
			{
				HudWritten += formatex(HudText[HudWritten], hudchars - HudWritten, "%L^n", id, "XP_INFOEX_NAME_A", UName);
				isenemy = true;
			}
			else
			{
				HudWritten += formatex(HudText[HudWritten], hudchars - HudWritten, "%L^n", id, "XP_INFOEX_NAME_F", UName);
			}
			HudWritten += formatex(HudText[HudWritten], hudchars - HudWritten, "Hp: %i/Ap: %i^n", floatround(UHeatlh), floatround(UArmor));
		}
		if(isUserLoggedIn(target))
		{
			get_user_rank(target, URank, 34, id);
			UserLevel = PlayerSkills[target][PlayerLevel][CurrentValue];
			HudWritten += formatex(HudText[HudWritten], hudchars - HudWritten, "%L: %i^n", id, "XP_INFO_LEVEL", UserLevel);
			HudWritten += formatex(HudText[HudWritten], hudchars - HudWritten, "%L", id, "XP_MSG_RANK", URank);
			if(isenemy && !is_running("svencoop"))
			{
				set_hudmessage(220, 20, 60, lx, ly, 0, 1.0, 1.9, 0.0, 0.0, HudChannel - 1);
			}
			else
			{
				set_hudmessage(42, 255, 200, lx, ly, 0, 1.0, 1.9, 0.0, 0.0, HudChannel - 1);
			}
			show_hudmessage(id, HudText);
		}
		else
		{
			HudWritten += formatex(HudText[HudWritten], hudchars - HudWritten, "%L: %i^n", id, "XP_INFO_LEVEL", -1);
			if(isenemy && !is_running("svencoop"))
			{
				set_hudmessage(220, 20, 60, lx, ly, 0, 1.0, 1.9, 0.0, 0.0, HudChannel - 1);
			}
			else
			{
				set_hudmessage(42, 255, 200, lx, ly, 0, 1.0, 1.9, 0.0, 0.0, HudChannel - 1);
			}
			show_hudmessage(id, HudText);
		}
	}
}
//
public client_kill(id)
{
	if(get_entity_flagsEx(id, FL_FROZEN))
	{
		return FMRES_SUPERCEDE;
	}
	return PLUGIN_CONTINUE;
}
public xp_variant_check(id)
{
	if(get_gametime() - LastNickTime[id] < 0.1) return;
	//if(get_pcvar_num(Cvar_Enabled))
	//{
	ExecuteForward(fw_pre_think, FWReturn, id, PlayerSkills[id][Class][CurrentValue]);
	//}
	LastNickTime[id] = get_gametime();
	showplayerinfo(id);
}
public xp_yeteneklerim(id)
{
	//Added From 1.2: 04.03.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(id))
	{
		console_print(id, "%s%L", PREFIX, id, "YOU_RQ_LOGGED");
		return PLUGIN_HANDLED;
	}
	YetenekMenusuGoster(id, 0);
	return PLUGIN_HANDLED;
}
public xp_ban(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id,targetarg, 1)
	if(!target)
	{
		console_print(id, "%s%L", PREFIX, id, "CMD_USER_NFOUND", targetarg);
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(target))
	{
		console_print(target, "%s%L", PREFIX, target, "XP_SETLVL_ERR_NL");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[target][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_BAN_ERROR_AL", targetarg);
		return PLUGIN_HANDLED;
	}
	PlayerSkills[target][Banned][CurrentValue] = 1;
	console_print(id, "%s%L", PREFIX, id, "XP_BAN_SUCCESS", targetarg);
	client_print(target, print_chat, "%s%L", PREFIX, target, "XP_BAN_SUCCESS_USERMSG");
	SendClientMessage(id, target, "XP_BAN_SUCCESS_ALL", true, 0, PREFIX);
	resetplayervariants(target);
	return PLUGIN_HANDLED;
}
public xp_unban(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id,targetarg,11)
	if(!target)
	{
		console_print(id, "%s%L", PREFIX, id, "CMD_USER_NFOUND", targetarg);
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(target))
	{
		console_print(target, "%s%L", PREFIX, target, "XP_SETLVL_ERR_NL");
		return PLUGIN_HANDLED;
	}
	if(!PlayerSkills[target][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_UNBAN_ERROR_AL", targetarg);
		return PLUGIN_HANDLED;
	}
	PlayerSkills[target][Banned][CurrentValue] = 0;
	console_print(id, "%s%L", PREFIX, id, "XP_UNBAN_SUCCESS", targetarg);
	client_print(target, print_chat, "%s%L", PREFIX, target, "XP_UNBAN_SUCCESS_USERMSG");
	SendClientMessage(id, target, "XP_UNBAN_SUCCESS_ALL", true, 0, PREFIX);
	CheckPlayerVariants(target);
	return PLUGIN_HANDLED;
}
public xp_enerji_fulle_cmd(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED
	}
	if(!cmd_access_ex_superadmin(id))
	{
		return PLUGIN_HANDLED
	}
	if (!get_pcvar_num(Cvar_Enabled) || !get_pcvar_num(Cvar_EnabledEnergy))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id,targetarg,11)
	if(!target)
	{
		console_print(id, "%s%L", PREFIX, id, "CMD_USER_NFOUND", targetarg);
		return PLUGIN_HANDLED
	}
	if(PlayerSkills[target][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(target))
	{
		console_print(id, "%s%L", PREFIX, id, "ADDXP_USER_NOTSET");
		return PLUGIN_HANDLED;
	}
	new mplimit = get_pcvar_num(Cvar_EnergyMapLimit);
	new tused = EnergyUsedCount[target];
	if(mplimit > 0 && tused >= mplimit)
	{
		tused = mplimit - 1;
	}
	new killcnt = EnergyKillValue[target];
	new killlimit = get_pcvar_num(Cvar_EnergyKill);
	new UName[31];
	get_user_name(target, UName, 31);
	if(killcnt >= killlimit)
	{
		console_print(id, "%s%L", PREFIX, id, "XP_ADM_ENERGY_ERR", UName);
		return PLUGIN_HANDLED;
	}
	else
	{
		new oldval = EnergyKillValue[target];
		EnergyKillValue[target] = killlimit;
		new FWReturnEx;
		ExecuteForward(fw_energyvalchanged, FWReturnEx, target, oldval, killlimit);
		console_print(id, "%s%L", PREFIX, id, "XP_ADM_ENERGY_OK", UName);
		xp_hud_show_player(target);
		return PLUGIN_HANDLED;
	}
	
}
public xp_addxp(id, level, cid)
{
	if(!cmd_access(id,level,cid,3))
	{
		return PLUGIN_HANDLED
	}
	if(!cmd_access_ex_superadmin(id))
	{
		return PLUGIN_HANDLED
	}
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id,targetarg,11)
	if(!target)
	{
		console_print(id, "%s%L", PREFIX, id, "CMD_USER_NFOUND", targetarg);
		return PLUGIN_HANDLED
	}
	if(PlayerSkills[target][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(target))
	{
		console_print(id, "%s%L", PREFIX, id, "ADDXP_USER_NOTSET");
		return PLUGIN_HANDLED;
	}
	new xparg[32]
	read_argv(2,xparg,31)
	new newxp = str_to_num(xparg)
	if(newxp <= 0)
	{
		console_print(id, "%s%L", PREFIX, id, "ADDXP_ERROR_ZERO");
		return PLUGIN_HANDLED
	}
	add_xp_to_user(target, newxp, true);
	console_print(id, "%s%L", PREFIX, id, "ADDXP_SUCCESS");
	SendClientMessage(id, target, "ADDXP_SUCCESS_ALL", false, newxp, PREFIX);	
	return PLUGIN_HANDLED;
}
public xp_removexp(id, level, cid)
{
	if(!cmd_access(id,level,cid,3))
	{
		return PLUGIN_HANDLED
	}
	if(!cmd_access_ex_superadmin(id))
	{
		return PLUGIN_HANDLED
	}
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id,targetarg,11)
	if(!target)
	{
		console_print(id, "%s%L", PREFIX, id ,"CMD_USER_NFOUND", targetarg);
		return PLUGIN_HANDLED
	}
	if(PlayerSkills[target][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(target))
	{
		console_print(id, "%s%L", PREFIX, id, "REMOVEXP_USER_NOTSET");
		return PLUGIN_HANDLED;
	}
	new xparg[32]
	read_argv(2,xparg,31)
	new newxp = str_to_num(xparg)
	if(newxp <= 0)
	{
		console_print(id, "%s%L", PREFIX, id, "ADDXP_ERROR_ZERO");
		return PLUGIN_HANDLED
	}
	remove_xp_to_user(target, id, newxp, true);
	console_print(id, "%s%L", PREFIX, id, "REMOVEXP_SUCCESS");
	SendClientMessage(id, target, "REMOVEXP_SUCCESS_ALL", false, newxp, PREFIX);	
	return PLUGIN_HANDLED;
}
public ClearPlayerData(id, bool:resetpass)
{
	new sltype = setlevel_reset;
	if(resetpass) sltype = setlevel_delete;
	new bool:canchglevel = user_canchangelevel(id, id, sltype, PlayerSkills[id][PlayerLevel][CurrentValue], 0);
	if(!canchglevel && !resetpass) return;
	PlayerSkills[id][Class][CurrentValue] = -1;
	PlayerSkills[id][XP][TopValue] = 0;
	PlayerSkills[id][XP][ReqValue] = StartXP + XPMultiplier;
	PlayerSkills[id][PlayerLevel][CurrentValue] = 0;

	PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
	PlayerSkills[id][XP][CurrentValue] = 0;
	PlayerSkills[id][PrestigeCount][CurrentValue] = 0;
	PlayerSkills[id][PlayerLevel][LastValue] = -1;
	ClearSkills(id);
	resetplayervariants(id);
}
public xp_resetskill(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED
	}
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(!cmd_access_ex_superadmin(id)) return PLUGIN_HANDLED;
	new targetarg[32]
	read_argv(1,targetarg,31)
	new starget=cmd_target(id,targetarg,11)
	if(starget)
	{
		ClearPlayerData(id, false);
		new uname[40];
		get_user_name(starget, uname, 39);
		console_print(id,"%s%L", PREFIX, id, "CMD_RSKILL_SUCCESS", uname)
		SendClientMessage(id, starget, "CMD_RSKILL_ALL", true, 0, PREFIX);
	}
	else
	{
		console_print(id,"%s%L", PREFIX, id, "CMD_RSKILL_NF", targetarg)
	}
	return PLUGIN_HANDLED;
}
public xp_remove(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED
	}
	if(!cmd_access_ex_superadmin(id)) return PLUGIN_HANDLED;
	new username[40]
	read_argv(1,username,39)
	new targetc = find_player("a", username);
	if(strlen(username) > 0)
	{
		if(OyuncuVerileriVar(username))
		{
			if(targetc)
			{
				ClearPlayerData(targetc, true);
				client_print(targetc, print_chat, "%s%L", PREFIX, id, "XP_RMV_SC_USER");
			}
			OyuncuTumDegerleriniSifirla(username);
			console_print(id,"%s%L", PREFIX, id, "CMD_RMV_SUCCESS", username)
		}
		else
		{
			console_print(id,"%s%L", PREFIX, id, "CMD_RMV_NF", username)
		}
	}
	return PLUGIN_HANDLED;
}
public xp_check_frags()
{
	for(new i = 1;i < MaxPlayers; i++)
	{
		if(!is_user_connected(i)) continue;
		if(!isUserLoggedIn(i) || PlayerSkills[i][Class][CurrentValue] < 0)
		{
			//Added 1.2.2: 16.03.2014
			PlayerSkills[i][Frags][CurrentValue] = get_user_frags(i);
			continue;
			//
		}
		new LastFrag = PlayerSkills[i][Frags][CurrentValue];
		new NewFrag = get_user_frags(i)
		
		if(NewFrag > LastFrag && PlayerSkills[i][PlayerLevel][CurrentValue] < MaxLevels[PlayerSkills[i][Class][CurrentValue]])
		{
			new FCount = NewFrag - LastFrag;
			if(!PlayerSkills[i][Banned][CurrentValue])
			{
				user_frag_increased(i, FCount);
			}
			PlayerSkills[i][Frags][CurrentValue] = NewFrag;
		}
	}

}
public user_frag_increased(id, fcount)
{
	if(!get_pcvar_num(Cvar_Enabled))
	{
		return;
	}
	if(!isUserLoggedIn(id))
	{
		return;
	}
	new UserClass = PlayerSkills[id][Class][CurrentValue];
	if(UserClass < 0 && SkillType)
	{
		return;
	}
	new Float:SpecMul = UserXPMultiplier[id];
	if(SpecMul <= 0.0) SpecMul = 1.0;
	new Float:Multiplier = get_pcvar_float(Cvar_Multipler) * SpecMul;
	new Float:MultiplierPrestige = floatmul(float(PlayerSkills[id][PrestigeCount][CurrentValue]), get_pcvar_float(Cvar_MulPrestige))
	new AwardedXP;
	new Prcount = PlayerSkills[id][PrestigeCount][CurrentValue];
	//Changed From 1.2: 03.03.2014
	PlayerSkills[id][Frags][CurrentLevel] = get_pcvar_num(Cvar_KillPoints);
	if(Prcount > 0)
	{
		AwardedXP = fcount * PlayerSkills[id][Frags][CurrentLevel]  * floatround(MultiplierPrestige) * floatround(Multiplier);
	}
	else
	{
		AwardedXP = fcount * PlayerSkills[id][Frags][CurrentLevel] * floatround(Multiplier);
	}
	//		
	xp_hud_show_player(id);
	add_xp_to_user(id, AwardedXP, false);

}
public CheckPlayerVariants(id)
{
	if(PlayerSkills[id][Banned][CurrentValue]) return;
	if(!isUserLoggedIn(id)) return;
	for(new i = 0;i < registered_skills;i++)
	{
		ExecuteForward(fw_needcalc, FWReturn, id, i, PlayerSkills[id][Class][CurrentValue]);
	}
}
public remove_xp_to_user(id, adminid, xpcount, bool:sendmessage)
{
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(LoginRequired && logged <= 0)
	{
		return PLUGIN_HANDLED;
	}
	if(xpcount <= 0)
	{
		return PLUGIN_HANDLED;
	}
	new OldXP = PlayerSkills[id][XP][CurrentValue];
	new NewXP = OldXP - xpcount;
	PlayerSkills[id][XP][CurrentValue] = NewXP;
	if(NewXP < 0)
	{
		new CurLvl = PlayerSkills[id][PlayerLevel][CurrentValue];
		if(CurLvl <= 0)
		{
			PlayerSkills[id][XP][CurrentValue] = 0;
			if(sendmessage)
			{
				client_print(id, print_chat, "%s%L", PREFIX, id, "REMOVEXP_USERMSG");
			}
			return PLUGIN_HANDLED;
		}
		new lvlxp = get_real_xp(CurLvl);
		new TopXP = lvlxp + NewXP;
		if(TopXP <= 0 || TopXP < (StartXP + XPMultiplier))
		{
			if(user_canchangelevel(id, adminid, setlevel_reset, PlayerSkills[id][PlayerLevel][CurrentValue], 0))
			{
				return PLUGIN_HANDLED;
			}
			PlayerSkills[id][PlayerLevel][CurrentValue] = 0;
			PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
			for(new j = 0; j < registered_skills;j++)
			{
				PlayerSkills[id][j][CurrentLevel] = 0;
			}
			if(sendmessage)
			{
				client_print(id, print_chat, "%s%L", PREFIX, id, "REMOVEXP_USERMSG");
			}
			if(TopXP <= 0)
			{
				PlayerSkills[id][XP][CurrentValue] = 0;
			}
			else
			{
				PlayerSkills[id][XP][CurrentValue] = TopXP;
			}
			resetplayervariants(id);
			PlayerSkills[id][XP][ReqValue] = StartXP + XPMultiplier;
			CheckPlayerVariants(id);
			return PLUGIN_HANDLED;
		}
		else
		{
			new UserLvl = get_real_level(TopXP, PlayerSkills[id][Class][CurrentValue]) - 1;
			new AradakiFark =  CurLvl - UserLvl;
			if(PlayerSkills[id][PlayerLevel][CurrentLevel] > 0)
			{
				new PLCL = PlayerSkills[id][PlayerLevel][CurrentLevel] 
				PLCL -= AradakiFark;
				if(PLCL < 0)
				{
					AradakiFark = PLCL * -1;
					PlayerSkills[id][PlayerLevel][CurrentLevel]  = 0;
					PLCL = 0;
				}
				PlayerSkills[id][PlayerLevel][CurrentLevel] = PLCL;
			}
			for(new j = 0;j < AradakiFark;j++)
			{
				new PlclB = PlayerSkills[id][j][CurrentLevel];
				if(PlclB > 0)
				{
					PlclB -= 1;
					PlayerSkills[id][j][CurrentLevel] = PlclB;
				}
			}
			if(UserLvl < 0) UserLvl = 0;
			if(user_canchangelevel(id, adminid, setlevel_decxp, PlayerSkills[id][PlayerLevel][CurrentValue], UserLvl))
			{
				return PLUGIN_HANDLED;
			}
			PlayerSkills[id][PlayerLevel][CurrentValue] = UserLvl;
			PlayerSkills[id][XP][ReqValue] = (UserLvl + 1) * XPMultiplier + StartXP;
			PlayerSkills[id][XP][TopValue] = UserLvl * XPMultiplier + UserLvl * StartXP
			PlayerSkills[id][XP][CurrentValue] = PlayerSkills[id][XP][ReqValue] + NewXP;
			if(sendmessage)
			{
				client_print(id, print_chat, "%s%L", PREFIX, id, "REMOVEXP_USERMSG");
			}
			CheckPlayerVariants(id);
			return PLUGIN_HANDLED;
		}
	}
	xp_hud_show_player(id);
	return PLUGIN_HANDLED;
}
public get_real_xp(lvlcount)
{
	if(lvlcount <= 0) return (StartXP + XPMultiplier);
	return (lvlcount * XPMultiplier + lvlcount * StartXP + (((lvlcount - 1)*lvlcount) / 2) * XPMultiplier)
}
public get_real_level(xpcount, classid)
{
	if(xpcount <= 0 || xpcount < (StartXP + XPMultiplier)) return 1;
	for(new i = MaxLevels[classid]; i > 0; i--)
	{
		new TempCount = get_real_xp(i);
		if( xpcount >= TempCount)
		{
			return i + 1;
		}
	}
	return 0;
}
//Gncellendi 1.4.0 Beta 1 Srm ile 14.09.2018
public add_xp_to_user(id, xpcount, bool:sendmessage)
{
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(LoginRequired && logged <= 0)
	{
		return PLUGIN_HANDLED;
	}
	if(xpcount <= 0)
	{
		return PLUGIN_HANDLED;
	}
	new OldXP = PlayerSkills[id][XP][CurrentValue];
	new ReqXP = PlayerSkills[id][XP][ReqValue];
	new NewXP = OldXP + xpcount;
	PlayerSkills[id][XP][CurrentValue] = NewXP;
	if(xpcount > 0 && sendmessage)
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "ADDXP_USERMSG");
	}
	if(NewXP >= ReqXP)
	{
		new oncekilev = PlayerSkills[id][PlayerLevel][CurrentValue];
		new lvlxp =  oncekilev * XPMultiplier + oncekilev * StartXP + (((oncekilev - 1)*oncekilev) / 2) * XPMultiplier;
		new topvalue2 = lvlxp + NewXP;
		new nextlvl = get_real_level(topvalue2, PlayerSkills[id][Class][CurrentValue]);
		new AradakiFarkXP = get_real_xp(nextlvl) - topvalue2;
		new AradakiFarkLvl = (nextlvl - 1) - oncekilev;
		if(!user_canchangelevel(id, id, setlevel_default, oncekilev, nextlvl - 1))
		{
			PlayerSkills[id][XP][CurrentValue] = OldXP;
			return PLUGIN_HANDLED;
		}
		PlayerSkills[id][XP][TopValue] = topvalue2;
		PlayerSkills[id][PlayerLevel][CurrentValue] = nextlvl - 1;
		if(PlayerSkills[id][Class][CurrentValue] < 0)
		{
			PlayerSkills[id][Class][CurrentValue] = Prestige;
		}
		else
		{
			if(PlayerSkills[id][Class][CurrentValue] > Prestige)
			{
				PlayerSkills[id][Class][CurrentValue] = Prestige;
			}
		}
		if(PlayerSkills[id][PlayerLevel][CurrentValue] >= MaxLevels[PlayerSkills[id][Class][CurrentValue]])
		{
			new AradakiFark;
			PlayerSkills[id][XP][CurrentValue] = 0;
			PlayerSkills[id][XP][ReqValue] = 0;
			AradakiFark = PlayerSkills[id][PlayerLevel][CurrentValue] - MaxLevels[PlayerSkills[id][Class][CurrentValue]];
			PlayerSkills[id][PlayerLevel][CurrentLevel] = AradakiFark;
		}
		else
		{
			new NextReqXP = StartXP + (nextlvl * XPMultiplier);
			PlayerSkills[id][XP][CurrentValue] = NextReqXP - AradakiFarkXP;
			PlayerSkills[id][XP][ReqValue] = NextReqXP;
		}
		menu_selectskills(id, AradakiFarkLvl)
	}
	xp_hud_show_player(id);
	return PLUGIN_HANDLED;
}
public UsteYuvarla(Float:d1)
{
	new strfloat[15];
	new nmrc[2][5];
	float_to_str(d1, strfloat, sizeof strfloat - 1);
	if(strfind (strfloat, ".") > -1)
	{
		ExplodeString( nmrc, 1, 4,strfloat, '.');
		return str_to_num(nmrc[0]) + 1;
	}
	return floatround(d1) + 1;
}
public set_user_level(sender, id, n_type, level, bool:sendtouser)
{
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	new PL_Class = PlayerSkills[id][Class][CurrentValue];
	new Pl_AwSkill = PlayerSkills[id][PlayerLevel][CurrentLevel];
	new AradakiFark;
	new bool:isIncreased = false;
	if(level == PL_Level) return false;
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(LoginRequired && logged <= 0)
	{
		console_print(sender, "%s%L", PREFIX, sender, "XP_SETLVL_ERR_NL");
		return false;
	}
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(sender, "%s%L", PREFIX, sender, "XP_ERROR_BAN");
		return false;
	}
	if(PL_Class < 0) 
	{
		if(!SkillType)
		{
			PlayerSkills[id][Class][CurrentValue] = Prestige;
		}
		else
		{
			if(PlayerSkills[id][PrestigeCount][CurrentValue] <= 0)
			{
				if(PlayerSkills[id][Class][CurrentValue] == Prestige)
				{
					PlayerSkills[id][Class][CurrentValue] = -1;
				}
			}
			return false;
		}
	}
	if(!user_canchangelevel(id, sender, n_type, PL_Level, level))
	{
		return false;
	}
	if(level < PL_Level)
	{
		AradakiFark = PL_Level - level;
		if(Pl_AwSkill > 0)
		{
			new SkillB = Pl_AwSkill - AradakiFark;
			AradakiFark -= Pl_AwSkill;
			if(SkillB < 0) SkillB = 0;
			PlayerSkills[id][PlayerLevel][CurrentLevel] = SkillB;
			if(sendtouser)
			{
				client_print(id, print_chat, "%s%L", PREFIX, id, "XP_SETLVL_USERMSG_DESC");
			}
		}
		while(AradakiFark > 0)
		{
			new bool:RemovedSK = false;
			for(new j = 0; j < registered_skills; j++)
			{
				//1.4.0 Beta 1 Srm ile deitirildi. 14.09.2018
				new PlLevel = PlayerSkills[id][j][CurrentLevel];
				if(user_canaccessskill(id, PL_Class, j, PL_Level) && PlLevel > 0)
				{
					PlayerSkills[id][j][CurrentLevel] =  PlLevel - 1;
					AradakiFark--;
					RemovedSK = true;
				}
				if(AradakiFark <= 0) 
				{
					break;
				}
			}	
			if(!RemovedSK) break;
		}
		if(sendtouser)
		{
			client_print(id, print_chat, "%s%L", PREFIX, id, "XP_SETLVL_USERMSG_DESC");
		}
		if(level <= 0)
		{
			resetplayervariants(id);
		}
		else
		{
			CheckPlayerVariants(id);
		}
		
	}
	else
	{
		AradakiFark = level - PL_Level;
		if(sendtouser)
		{
			client_print(id, print_chat, "%s%L", PREFIX, id, "XP_SETLVL_USERMSG_INC");
		}
		isIncreased = true;
	}
	PlayerSkills[id][PlayerLevel][CurrentValue] = level;
	PlayerSkills[id][XP][CurrentValue] = 0;
	PlayerSkills[id][XP][TopValue] = (level * StartXP) + (level * XPMultiplier);
	PlayerSkills[id][XP][ReqValue] = StartXP + (level + 1) * XPMultiplier;
	xp_hud_show_player(id);
	if(isIncreased) menu_selectskills(id, AradakiFark);
	return true;
}
public menu_selectskills(id, skillscount)
{
	if(skillscount <= 0) return;
	PlayerSkills[id][PlayerLevel][CurrentLevel] += skillscount;
	SkillSecmeMenusuGoster(id, 0);
	CheckPlayerVariants(id);
}
public xp_yeteneksec(id)
{
	//Added 1.2: 04.03.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(id))
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "SKILL_SELECT_ERROR_NL");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][PlayerLevel][CurrentLevel] > 0)
	{
		SkillSecmeMenusuGoster(id, 0);
	}
	else
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "SKILL_SELECT_ERROR");
	}
	return PLUGIN_HANDLED;
}
//Added 1.2: 03.03.2014
public ShowPrompt(id, pid)
{
	new LangStr[128];
	new LangStrA[128];
	switch(pid)
	{
		case 1: //Reset All Skills
		{
			formatex(LangStrA,127,"%L", id, "XP_CMDMENU_RESETSKILL");
		}
		case 2: //Reset All Levels
		{
			formatex(LangStrA,127,"%L", id, "XP_CMDMENU_RESETLEVEL");
		}
		case 3: //Enter the prestige mode.
		{
			formatex(LangStrA,127,"%L", id, "XP_CMDMENU_PRESTIGE");
		}
		default: return;
	}
	formatex(LangStr,127,"%L", id, "XP_PROMPT_SURE", LangStrA);
	new menu = menu_create( LangStr, "PromptHandler")
	formatex(LangStr, 10, "%L", id, "XP_PROMPT_YES"); 
	menu_additem( menu, LangStr, "", 0 );
	formatex(LangStr, 10, "%L", id, "XP_PROMPT_NO"); 
	menu_additem( menu, LangStr, "", 0 );
	menu_setprop( menu, MPROP_EXIT, MEXIT_NEVER );
	PlayerSkills[id][Others][ReqValue] = pid;
	menu_display( id, menu, 0 );
}
//Added 1.2: 03.03.2014
public PromptHandler(id, menu, item)
{
	if(item != 0)
	{
		PlayerSkills[id][Others][ReqValue] = 0;
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Others][ReqValue])
	{
		switch(PlayerSkills[id][Others][ReqValue])
		{
			case 1:  //Reset All Skills
			{
				xp_reset(id);
			}
			case 2: //Reset All Levels
			{
				xp_resetall(id);
			}
			case 3: //Enter the prestige mode.
			{
				xp_prestij(id);
			}
		}
		PlayerSkills[id][Others][ReqValue] = 0;
	}
	menu_destroy( menu );
	return PLUGIN_HANDLED;
}
//
public YetenekMenusuGoster(id, page)
{
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(id)) return PLUGIN_HANDLED;
	new plclass = PlayerSkills[id][Class][CurrentValue];
	
	new strk[55];
	formatex(strk, 54, "\r%L", id, "SKILL_MENU_HEADER");
	new menu = menu_create( strk, "YetenekHandler" )
	new ItemLevelMax, ItemCurrentLevel;
	//1.4.0 Beta 1 srm ile deitirildi
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	for(new j = 0; j < registered_skills; j++)
	{
		if(user_canaccessskill(id, plclass, j, PL_Level))
		{
			new strc[100]
			new strl[10];
			ItemLevelMax = LevelClass[plclass][j][MaxLevel];
			ItemCurrentLevel =  PlayerSkills[id][j][CurrentLevel];
			if(PlayerSkills[id][j][Activate])
			{
				formatex(strc,99,"\w%L %i/%i", id,  LevelString[j], ItemCurrentLevel, ItemLevelMax);
			}
			else
			{
				formatex(strc,99,"\w[0]%L %i/%i", id,  LevelString[j], ItemCurrentLevel, ItemLevelMax);
			}
			formatex(strl, 2, "%i", j + moffset);
			menu_additem( menu, strc, strl, 0 );
		}
	}
	menu_display( id, menu, page );
	return PLUGIN_HANDLED;
}
//Updated 1.3.4: 20.07.2015
public YetenekHandler( id, menu, item )
{
	SelectedSkills[id] = -1;
	if(item == MENU_EXIT) 
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	new itemid = getMenuIndex_num(menu, item) - moffset;
	if(itemid == -1) 
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	SelectedSkills[id] = itemid;
	SelectedPage[id] = item / 7;
	menu_destroy( menu );
	YetenekAyarMenusuGoster(id);
	return PLUGIN_HANDLED;
}
//

new ItemCount = 0;
public SkillSecmeMenusuGoster(id, sayfa)
{
	if(!isUserLoggedIn(id)) return PLUGIN_HANDLED;
	new plclass = PlayerSkills[id][Class][CurrentValue];
	
	new strk[55];
	formatex(strk, 54, "\r%L", id, "SKILL_MENUSELECT_HEADER", PlayerSkills[id][PlayerLevel][CurrentLevel]);
	new menu = menu_create( strk, "YetenekMenuHandler" )
	menu_setprop( menu, MPROP_PERPAGE, 6);
	new ItemLevelMax, ItemCurrentLevel;
	ItemCount = 0;
	new bool:LastAdded
	new SelectAmount = PlayerSkills[id][PlayerLevel][ReqValue];
	SelectAmount = SetPlayerSelectAmount(id, SelectAmount);
	new strinf[15];
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	for(new j = 0; j < registered_skills; j++)
	{
		LastAdded = false;
		if(user_canaccessskill(id, plclass, j, PL_Level))
		{
			new strl[3];
			new strc[100];
			if((menu_items(menu) + 1) % 6 == 0)
			{
				menu_addblank(menu, 0);
				formatex(strc,99,"%L", id, "SKILL_MENUSELECT_AMOUNT", SelectAmount);
				menu_addtext( menu, strc, 0 );
				
				formatex(strc,99,"\w%L", id, "SKILL_MENUSELECT_INC");
				formatex(strinf, 15, "%i", menu_increase + moffset);
				menu_additem(menu, strc, strinf, 0);
				LastAdded = true;
			}
			formatex(strl, 2, "%i", j + moffset);
			ItemLevelMax = LevelClass[plclass][j][MaxLevel];
			ItemCurrentLevel =  PlayerSkills[id][j][CurrentLevel];
			if(ItemCurrentLevel < ItemLevelMax)
			{
				ItemCount++;
				if(PlayerSkills[id][j][Activate])
				{
					formatex(strc,99,"\w%L %i/%i", id, LevelString[j], ItemCurrentLevel, ItemLevelMax);
				}
				else
				{
					formatex(strc,99,"\w[0]%L %i/%i", id, LevelString[j], ItemCurrentLevel, ItemLevelMax);
				}
				menu_additem( menu, strc, strl, 0 );
			}
		}
	}
	if(ItemCount > 0)
	{
		new strc[100];
		new pitems =  (menu_items(menu) + 1) % 6 - 1 + 2;
		if(pitems -2 != 0)
		//for(new i = 0; i < 6 - pitems; i++)
		//{
			//menu_addblank(menu, 0);	
		//}
		if(pitems -2 == 0) LastAdded = true;
		menu_addblank(menu, 0);	
		if(!LastAdded)
		{
			formatex(strc,99,"%L", id, "SKILL_MENUSELECT_AMOUNT", SelectAmount);
			menu_addtext( menu, strc, 0);
			formatex(strc,99,"\w%L", id, "SKILL_MENUSELECT_INC");
			formatex(strinf, 15, "%i", menu_increase + moffset);
			menu_additem(menu, strc, strinf, 0);
		}
		formatex(strc, 99, "%L", id, "SKILL_MENUSELECT_AUTO");
		formatex(strinf, 15, "%i", menu_autoassign + moffset);
		menu_additem( menu, strc, strinf, 0 );
	}
	menu_display( id, menu, sayfa );
	return PLUGIN_HANDLED;
}
public GetClassUsableItemCount(id, classid, OutputArr[], bool:except_max_item)
{
	new ccount = 0;
	new MaxItemLevel;
	new PlayerItemLevel;
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	for(new i = 0; i < registered_skills; i++)
	{
		MaxItemLevel = LevelClass[classid][i][MaxLevel];
		PlayerItemLevel = PlayerSkills[id][i][CurrentLevel];
		if(user_canaccessskill(id, classid, i, PL_Level))
		{
			if(except_max_item)
			{
				if(PlayerItemLevel < MaxItemLevel)
				{
					OutputArr[ccount] =i;
					ccount++;
				}
			}
			else
			{
				OutputArr[ccount] = i;
				ccount++;
			}
		}
	}
	return ccount;
}

public SetPlayerSelectAmount(id, newvalue)
{
	if(newvalue <= 0 || newvalue > PlayerSkills[id][PlayerLevel][CurrentLevel] || newvalue > 50)
	{
		newvalue = 1;
		PlayerSkills[id][PlayerLevel][ReqValue] = newvalue;
	}
	else
	{
		PlayerSkills[id][PlayerLevel][ReqValue] = newvalue;
	}
	return newvalue;
}
//Added 1.2: 03.03.2014
//Updated 1.2: 05.03.2014
//Updated 1.2.2: 14.03.2014
public GetSkillSelectableCount(id, skillid, &levelex)
{
	new Float:PercentC = 10.0;
	if(!FirstCalced[id])
	{
		calc_usermaxlevels(id);
	}
	new classes = PlayerSkills[id][Class][CurrentValue];
	new PlayerMxlvl = MaxLevels_player[id][classes];
	new PlayerLvl = PlayerSkills[id][PlayerLevel][CurrentValue];
	new Float:OranYuzde = floatmul(100.0, floatdiv(float(PlayerLvl),float(PlayerMxlvl)));
	new OranEx = UsteYuvarla(floatdiv(OranYuzde, PercentC));
	if(OranEx > floatround(PercentC)) OranEx = floatround(PercentC);
	new SkillMaxLevel = LevelClass[PlayerSkills[id][Class][CurrentValue]][skillid][MaxLevel]; 
	new PlayerSkLvl = PlayerSkills[id][skillid][CurrentLevel];
	//return SkillMaxLevel - PlayerSkLvl;
	new MaxSelectAble = floatround(floatmul(floatdiv(float(SkillMaxLevel), PercentC), float(OranEx)));
	//new Oran1 = floatround(floatmul(floatdiv(float(PlayerSkLvl), float(SkillMaxLevel)), PercentC), floatround_floor);
	levelex = floatround(floatmul(float(PlayerMxlvl), floatdiv(float(MaxSelectAble), float(SkillMaxLevel))));
	new SonucA = MaxSelectAble - PlayerSkLvl;
	if(SonucA < 0) SonucA = 0;
	return SonucA;
}
//
//Updated 1.3.3: 22.06.2015
public YetenekMenuHandler( id, menu, item )
 {
	new MenuInfo[6], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, MenuInfo, 5, MenuItemName, 31, callback)
	if(item == MENU_EXIT)
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	new SkillId = str_to_num(MenuInfo);

	if(SkillId < 1 && item == MENU_EXIT)
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	SkillId = SkillId - moffset;
	if(SkillId == -1)
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}

	new KalanSkill = PlayerSkills[id][PlayerLevel][CurrentLevel];
	new plclass = PlayerSkills[id][Class][CurrentValue];
	new SayfaC = item / 6 ;
	new SelectAmount = PlayerSkills[id][PlayerLevel][ReqValue];
	//Added 1.2: 03.03.2014
	new SkillReqLevel;
	//
	SelectAmount = SetPlayerSelectAmount(id, SelectAmount);
	if(SkillId == menu_increase) //Seme Saysn Artr
	{
		new incamount = 1;
		switch(SelectAmount)
		{
			case 0..2:
			{
				incamount = 1;
			}
			case 3..4:
			{
				incamount = 2;
			}
			case 5..9:
			{
				incamount = 5;
			}
			case 10..49:
			{
				incamount = 10;
			}
		}

		SelectAmount += incamount;
		SetPlayerSelectAmount(id, SelectAmount)
		menu_destroy(menu);
		SkillSecmeMenusuGoster(id, SayfaC);
		return PLUGIN_HANDLED;
	}
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	if(SkillId == menu_autoassign) //Otomatik Ata
	{
		while(KalanSkill > 0)
		{
			new bool:AddedSk = false;
			for(new j = 0; j < registered_skills; j++)
			{
				//Changed From 1.2: 03.03.2014
				//Gncellendi 1.4.0 Beta 1: 14.09.2018
				if(user_canaccessskill(id, plclass, j, PL_Level) && GetSkillSelectableCount(id, j, SkillReqLevel) && user_canselectskill(id, plclass, j))
				{
					new ItemLevelMaxB, ItemCurrentLevelB;
					ItemLevelMaxB = LevelClass[plclass][j][MaxLevel];
					ItemCurrentLevelB =  PlayerSkills[id][j][CurrentLevel];
					if(ItemCurrentLevelB < ItemLevelMaxB && KalanSkill > 0)
					{
						ItemCurrentLevelB++;
						PlayerSkills[id][j][CurrentLevel] = ItemCurrentLevelB;
						KalanSkill--;
						PlayerSkills[id][PlayerLevel][CurrentLevel] = KalanSkill;
						AddedSk = true;
					}
					if(KalanSkill <= 0) 
					{
						PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
						break;
					}
				}
			}	
			if(!AddedSk) break;
		}
		CheckPlayerVariants(id);
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	new plClevel = PlayerSkills[id][SkillId][CurrentLevel];
	new ItemLevelMax = LevelClass[plclass][SkillId][MaxLevel];

	if(plClevel < ItemLevelMax)
	{	
		//Added 1.2: 03.03.2014
		new countsk = GetSkillSelectableCount(id, SkillId, SkillReqLevel);
		if(!user_canselectskill(id, plclass, SkillId))
		{
			return PLUGIN_HANDLED;
		}
		if(!countsk && get_pcvar_num(Cvar_SkillBalance))
		{
			client_print(id, print_chat, "%s%L", PREFIX, id, "XP_ERROR_TOO", SkillReqLevel);
			menu_destroy( menu );
			SkillSecmeMenusuGoster(id, SayfaC);
			return PLUGIN_HANDLED;
		}
		//
		if(SelectAmount > KalanSkill)
		{
			SelectAmount = KalanSkill;
			SetPlayerSelectAmount(id, SelectAmount);
		}
		if(SelectAmount > countsk)
		{
			SelectAmount = countsk;
		}
		plClevel += SelectAmount;
		KalanSkill -= SelectAmount;
		if(plClevel > ItemLevelMax)
		{
			KalanSkill += plClevel - ItemLevelMax;
			plClevel = ItemLevelMax;
		}
		PlayerSkills[id][SkillId][CurrentLevel] = plClevel;
		PlayerSkills[id][PlayerLevel][CurrentLevel] = KalanSkill;
	}
	if(KalanSkill > 0)
	{
		menu_destroy( menu );
		SkillSecmeMenusuGoster(id, SayfaC);
	}
	else
	{
		menu_destroy( menu );
	}
	CheckPlayerVariants(id);
	return PLUGIN_HANDLED;
 }
//1.4.0 Beta 10 Gncellendi
public bool:xp_hud_show_player(id)
{
	new i = id;
	if(!i) return false;
	if(!is_user_connected(i)) return false;
	new plclass = PlayerSkills[i][Class][CurrentValue];
	new logged = PlayerSkills[i][LoggedIn][CurrentValue];
	if(!SkillType) plclass = Prestige;
	new Red, Green, Blue;
	Red = 1 + random(254);
	Green = 1 + random(254);
	Blue = 1 + random(254);
	new HudWritten = 0;
	if(PlayerSkills[i][Banned][CurrentValue])
	{
		new HudText[100];
		new UName[31];
		get_user_name(i, UName, 31);
		set_hudmessage(0, 255, 170, 0.0, 0.0, 0, 1.0, 512.0, 0.0, 0.0, HudChannel);
		formatex(HudText, 99, "^n%s %L^n", HudText, i, "XP_MSG_HELLO", UName);
		new HudTextEx[100];
		formatex(HudTextEx, 99, "^n%s %L^n", HudText, i, "XP_INFO_BANNED");
		show_hudmessage(i, HudTextEx);
		return true;
	}
	if(LoginRequired && logged <= 0)
	{		
		set_hudmessage( Red, Green, Blue, -1.0, 0.3, 0, 1.0, 512.0, 0.0, 0.0, HudChannel);
		show_hudmessage( i, "%s%L", PREFIX, i, "XP_MAIN_ERROR_LR");
		return true;
	}
	else
	{
		if(plclass < 0)
		{
			set_hudmessage( Red, Green, Blue, -1.0, 0.3, 0, 1.0, 512.0, 0.0, 0.0, HudChannel);
			show_hudmessage(i, "%s%L", PREFIX, i, "XP_MAIN_ERROR_CR");
			return true;
		}
		else
		{
			new UserLevel = PlayerSkills[i][PlayerLevel][CurrentValue];
			new UserXP = PlayerSkills[i][XP][CurrentValue];
			new UserXP_req = PlayerSkills[i][XP][ReqValue];
			new Rutbe[35];
			new HudText[350];
			new hudcharex = charsmax(HudText);
			new UName[31];
			get_user_name(i, UName, 31);
			//1.4.0 Beta 10 Hata dzeltmesi
			HudWritten += formatex(HudText, hudcharex, "^n %L^n", i, "XP_MSG_HELLO", UName);
			if(SkillType)
			{
				new SinifIsmi[40];
				switch(plclass)
				{
					case Maroon_Berets:
					{
						formatex(SinifIsmi, 39, "%L", i, "XP_CLASS_MB");
					}
					case Medic:
					{
						formatex(SinifIsmi, 39, "%L", i, "XP_CLASS_MEDIC");
					}
					case Soldier:
					{
						formatex(SinifIsmi, 39, "%L", i, "XP_CLASS_SOL");
					}
					case Prestige:
					{
						formatex(SinifIsmi, 39, "%L", i, "XP_CLASS_PR");
					}
				}
				HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", i, "XP_MSG_CL", SinifIsmi);
			}
			HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", i, "XP_MSG_LEVEL", UserLevel, MaxLevels[plclass]);
			//Added 1.3.2: 17.08.2014
			new Mult[10];
			new Float:SpecMul = UserXPMultiplier[i];
			if(SpecMul <= 0.0) SpecMul = 1.0;
			if(PlayerSkills[i][PrestigeCount][CurrentValue] > 0)
			{
				float_to_str_ex(get_pcvar_float(Cvar_Multipler) * get_pcvar_float(Cvar_MulPrestige) * SpecMul, 1, Mult, 9);
			}
			else
			{
				float_to_str_ex(get_pcvar_float(Cvar_Multipler) * SpecMul, 1, Mult, 9);
			}
			formatex(Mult, 9, "%s%s", Mult, "X");
			//
			if(UserLevel < MaxLevels[plclass]) HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", i, "XP_MSG_LEVEL_NX", UserXP, UserXP_req, Mult);
			get_user_rank(i, Rutbe, 34);
			HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", i, "XP_MSG_RANK", Rutbe);
			if(!is_running("svencoop"))
			{
				new Float:UHeatlh;
				new Float:UArmor;
				pev(i, pev_health, UHeatlh);
				pev(i, pev_armorvalue, UArmor);
				HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " Hp: %i / Ap: %i^n", floatround(UHeatlh), floatround(UArmor));
			}
			if(user_canuseenergy(id))
			{
				if(EnergyKillValue[id] >= get_pcvar_num(Cvar_EnergyKill))
				{
					energy_current_item[id] = 0;
					HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", id, "XP_NFO_ENERGY_F");
				}
				else
				{
					//new Float:maxkkill = get_pcvar_float(Cvar_EnergyKill);
					//new Float:currentkill = float(EnergyKillValue[id]);
					//new oranti = floatround(currentkill / maxkkill * 100.0);
					new EngStr[15];
					if(get_nextbestability(id, EngStr))
					{
						HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", id, "XP_NFO_ENERGY_FEXT", EngStr);
					}
					else
					{
						HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %L^n", id, "XP_NFO_ENERGY_N");
					}
					

				}
				new ESayac[60];
				xp_createenergyrow(id, 20, 2, ESayac, 59);
				HudWritten += formatex(HudText[HudWritten], hudcharex - HudWritten, " %s^n", ESayac);
			}
			set_hudmessage(0, 255, 170, 0.0, 0.1, 0, 1.0, 512.0, 0.1, 0.2, HudChannel);
			show_hudmessage(i, HudText);
		}
	}
	return false;
}
public xp_createenergyrow(id, imax, imax_mul, Outstr[], Outstr_Len)
{
	new Float:maxkkill = get_pcvar_float(Cvar_EnergyKill);
	new Float:currentkill = float(EnergyKillValue[id]);
	new Float:Oranti = 1.0;
	if(currentkill < maxkkill)
	{
		Oranti = currentkill / maxkkill;
	}
	new snc = floatround(float(imax) * Oranti);
	if(snc < 1) snc = 1;
	new bosluksayac = (imax - snc) * imax_mul;
	new twrited = formatex(Outstr, Outstr_Len, "[");
	for(new i = 0; i < snc ; i++)
	{
		twrited += formatex(Outstr[twrited], Outstr_Len - twrited, "=");
	}
	if(bosluksayac > 0)
	{
		twrited += formatex(Outstr[twrited], Outstr_Len - twrited, "|");
	}
	for(new i = 0; i < bosluksayac ; i++)
	{
		twrited += formatex(Outstr[twrited], Outstr_Len - twrited, " ");
	}
	formatex(Outstr[twrited], Outstr_Len - twrited, "]");
}
public xp_hud_show()
{
	for(new i = 1;i <= MaxPlayers; i++)
	{	
		xp_hud_show_player(i);
	}
}
public xp_enerjikomut_ext(id, say_argc, say_info[])
{
	new enid = str_to_num(say_info);
	if(enid <= 0) return;
	energy_use(id, enid);
}
stock energy_use(id, energyid)
{
	if(!user_canuseenergy(id))
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "SK_ERR_GLB", EnergyData[energyid][eed_name]);
		return 0;
	}
	if(energy_can_use(id, energyid, 0, 1))
	{
		new EReturn;
		ExecuteForward(fw_energyusing_item, EReturn, id, energyid);
		if(EReturn)
		{
			EnergyKillValue[id] -= get_epoints(EnergyData[energyid]);
			xp_hud_show_player(id);
		}
		return EReturn;
	}
	return 0;
}
stock energy_can_use(id, energyid, hudmsg, nofw = 0, showmessage = 1)
{
	if(!id || !energyid) return 0;
	new energyvalue = EnergyKillValue[id];
	new energyreq = get_epoints(EnergyData[energyid]);
	if(energyvalue < energyreq)
	{
		if(showmessage) client_print(id, print_chat, "%s%L", PREFIX, id, "SK_ERR_GLB_NE", EnergyData[energyid][eed_name], energyreq, energyvalue);
		return 0;
	}
	new EReturn = 1;
	if(!nofw)
	{
		EReturn = 0;
		ExecuteForward(fw_energycanuse_item, EReturn, id, energyid, hudmsg);
	}
	return EReturn;
}
public xp_enerjikomut(id)
{
	use_energy(id);
}
public xp_useenergy(id)
{
	if(energy_current_item[id])
	{
		if(energy_use(id, energy_current_item[id]))
		{
			return PLUGIN_HANDLED;
		}
		else
		{
			return PLUGIN_CONTINUE;
		}
	}
	if(use_energy(id))
	{
		return PLUGIN_HANDLED;
	}
	if(is_running("valve"))
	{
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}
stock use_energy(id)
{
	if(!user_canuseenergy(id)) return 0;
	if(!is_user_alive(id)) return 0;
	new killv = EnergyKillValue[id];
	if(killv >= get_pcvar_num(Cvar_EnergyKill))
	{
		new oldval = EnergyKillValue[id];
		EnergyKillValue[id] = 0;
		new FWReturnEx;
		ExecuteForward(fw_energyvalchanged, FWReturnEx, id, oldval, EnergyKillValue[id]);
		ExecuteForward(fw_energyused, FWReturnEx, id, user_canuseenergy(id));
		if(FWReturnEx && !user_spec(id))
		{
			EnergyUsedCount[id]++;
		}
		if(FWReturnEx) 
		{
			xp_hud_show_player(id);
		}
		return 1;
	}
	return 0;
}
stock user_canuseenergy(id)
{
	if(!get_pcvar_num(Cvar_Enabled)) return 0;
	if(!get_pcvar_num(Cvar_EnabledEnergy)) return 0;
	if(!get_pcvar_num(Cvar_EnergyKill)) return 0;
	if(PlayerSkills[id][Banned][CurrentValue]) return 0;
	new UserLevel = PlayerSkills[id][PlayerLevel][CurrentValue];
	new RLevel = get_pcvar_num(Cvar_EnergyMinlevel);
	if(RLevel >= get_pcvar_num(Cvar_MaxLevel)) RLevel = get_pcvar_num(Cvar_MaxLevel);
	if(UserLevel < RLevel) return 0;
	if(user_spec(id)) return 1;
	new inum = get_pcvar_num(Cvar_EnergyMapLimit);
	if(inum > 0 && EnergyUsedCount[id] > inum) return 0;
	return 1;
}
public xp_energy_valuechanged(id, oldvalue, newvalue)
{
	if(!user_canuseenergy(id)) return;
	if(newvalue <= oldvalue) return;
	new maxlimit = get_pcvar_num(Cvar_EnergyKill);
	if(newvalue >= maxlimit) return;
	new msgex[150];
	if(get_energy_betweenmsg(id, oldvalue, newvalue, msgex, 149))
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "SK_INF_GLB", msgex);
	}
}
stock get_energy_betweenmsg(id, oldvalue, newvalue, outstr[], outlen)
{
	new engmsg[100];
	new engmsl = charsmax(engmsg);
	new engmsgw = 0;
	new itotal = 0;
	for(new i = 1; i < energy_loaded; i++)
	{
		new EData[EEnergyData];
		EData = EnergyData[i];
		new Epoints = get_epoints(EData);
		if(!energy_can_use(id, i, 1, 0, 0))
		{
			continue;
		}
		if(newvalue < Epoints)  continue;
		if(oldvalue >= Epoints) continue;
		if(itotal == 0)
		{
			engmsgw += formatex(engmsg[engmsgw], engmsl - engmsgw, EData[eed_name]);
		}
		else
		{
			engmsgw += formatex(engmsg[engmsgw], engmsl - engmsgw, ", %s", EData[eed_name]);
		}
		itotal++;
	}
	formatex(outstr, outlen, engmsg);
	return itotal;
}
public Work_cputinserver(id)
{
	new steamid[32];
	get_user_authid( id, steamid, charsmax(steamid));
	if(strlen(steamid) > 0)
	{
		DataNormallyLoaded[id] = true;
	}
	EnergyUsedCount[id] = 0;
	EnergyKillValue[id] = 0;
	Work_xp_player_loggedin(id, steamid);

}
public client_putinserver(id)
{
	if(is_running("svencoop"))
	{
		DataNormallyLoaded[id] = false;
		Work_cputinserver(id);
		UserFrag[id] = 0;
	}
	LastNickTime[id] = get_gametime();
	xp_hud_show_player(id);
	energy_current_item[id] = 0;
}
//Gncellendi 1.4.0 Beta 1: 14.09.2018
public xp_skills_regen_tmr(id)
{
	if(!is_user_connected(id)) return;
	new plclass = PlayerSkills[id][Class][CurrentValue];
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	new plevel;
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(!SkillType) plclass = Prestige;
	if(PlayerHelpTime[id] > 0 && PlayerHelpTime[id] != -1)
	{
		PlayerHelpTime[id]--;
		if(PlayerHelpTime[id] <= 0)
		{
			if(is_user_alive(id))
			{
				ShowPlayerHelpMessage(id);
				PlayerHelpTime[id] = -1;
			}
			else
			{
				PlayerHelpTime[id] = 1;
			}
		}
	}
	if(LoginRequired && logged <= 0)
	{		
		xp_hud_show_player(id);
		return;
	}
	if(plclass >= 0)
	{
		if(!PlayerSkills[id][Banned][CurrentValue] && isUserLoggedIn(id))
		{
			for(new sk = 0; sk < registered_skills;sk++)
			{
				plevel = LevelClass[plclass][sk][CurrentLevel];
				if(user_canaccessskill(id, plclass, sk, PL_Level) && plevel > 0)
				{
					new cValue = PlayerSkills[id][sk][IntervalValue];
					cValue--;
					PlayerSkills[id][sk][IntervalValue] = cValue;
					if(cValue - 1 <= 0)
					{
						ExecuteForward(fw_interval_invoked, FWReturn, id, sk, plclass)
						SetNewInterVal(id, sk, plclass);
					}
				}
			}
		}
	}
}
public xp_skills_regen(nid)
{
	new id =  nid - SkillTaskId;
	xp_skills_regen_tmr(id);
}
public SetNewInterVal(plid, skillsid, plcassid)
{
	new MaxInt = LevelClass[plcassid][skillsid][MaxIntervalValue];
	new MaxLevelc = LevelClass[plcassid][skillsid][MaxLevel];
	new CurLvl = PlayerSkills[plid][skillsid][CurrentLevel];
	if(CurLvl > MaxLevelc)
	{
		CurLvl = MaxLevelc;
		PlayerSkills[plid][skillsid][CurrentLevel] = CurLvl;
	}	
	
	new NewInterval = get_pcvar_num(Cvar_IntervalMul) * MaxLevelc - get_pcvar_num(Cvar_IntervalMul) * CurLvl + MaxInt;
	PlayerSkills[plid][skillsid][IntervalValue] = NewInterval;
}
public bool:isUserLoggedInB(id)
{
	if(is_user_bot(id)) return false;
	if(is_running("svencoop"))
	{
		return true;
	}
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(LoginRequired && logged <= 0)
	{
		return false;
	}
	return true;
}
public bool:isUserLoggedIn(id)
{
	if(is_user_bot(id)) return false;
	if(is_running("svencoop"))
	{
		return true;
	}
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(LoginRequired && logged <= 0)
	{
		return false;
	}
	new playerclass = PlayerSkills[id][Class][CurrentValue];
	if(playerclass < 0 && SkillType)
	{
		return false;
	}
	if(!SkillType) PlayerSkills[id][Class][CurrentValue] = Prestige;
	return true;
}
public MonsterTakeDamage(id, inflictor, attacker, Float:damage, damagebits)
{
	//Changed: 26.03.2014
	
	//Ham_IsAlive
	if(!get_pcvar_num(Cvar_Enabled)) return HAM_IGNORED;
	if(isMonsterAlly(id) && isMonsterAlive(id) && pev(id, pev_euser1))
	{
		if(!attacker || attacker > 32) return HAM_IGNORED;
		SetHamParamFloat(4, 0.0);
		return HAM_HANDLED;
	}
	new cl;
	cl = -1;
	if(attacker > 0 && attacker <= 32) cl = PlayerSkills[attacker][Class][CurrentValue];
	//Added 1.3: 29.03.2014;
	if(SkillType && cl < 0) cl = Prestige;
	//Added 1.3: 25.03.2014
	ExecuteForward(fw_monster_takedamage, FWReturn, id, cl, inflictor, attacker, damage, damagebits);
	return HAM_IGNORED;
}
public GirisAyarlari()
{
	StartXP = get_pcvar_num(Cvar_StartXP);
	XPMultiplier = get_pcvar_num(Cvar_LevelIncXP);
	xp_registerforwards();
	ExecuteForward(fw_main, FWReturn);
	MaxLeveliAyarla()
	DigerAyarlar()
}
public MaxLeveliAyarla()
{
	new maxlevel = get_pcvar_num(Cvar_MaxLevel);
	MaxLevels[0] = maxlevel;
	MaxLevels[1] = maxlevel;
	MaxLevels[2] = maxlevel;
	MaxLevels[3] = maxlevel;
	//1.4.0 Beta 1 Srm ile deitirildi 12.09.2018
	for(new i = 0; i < registered_skills;i++)
	{
		
		for(new j = 0; j < 4; j++)
		{
			if(LevelClass[j][i][Usable])
			{
				MaxLevels_items[j] += LevelClass[j][i][MaxLevel];
			}
		}
		
	}
	for(new j = 0; j < 4; j++)
	{
		MaxLevels_items[j] = clamp(MaxLevels_items[j], 0, maxlevel);
	}
}
public DigerAyarlar()
{
	if(is_running("svencoop"))
	{
		for(new i = 0;i < sizeof MonsterClassList;i++)
		{
			RegisterHam(Ham_TakeDamage, MonsterClassList[i], "MonsterTakeDamage", 0);
			RegisterHam(Ham_Killed, MonsterClassList[i], "MonsterKilled", 0);
		}
	}

}
public MonsterKilled(victim, attacker, shouldgib) 
{
	if(!victim) return HAM_IGNORED;
	if(attacker <= 0) return HAM_IGNORED;
	if(attacker > 32) return HAM_IGNORED;
	new flimit = get_pcvar_num(Cvar_RoundFragLimit);
	new nocall = 0;
	if(flimit > 0)
	{
		if(UserFrag[attacker] > flimit)
		{
			nocall = 1;
		}
		if(!nocall) UserFrag[attacker]++;
	}
	if(isMonsterAlly(victim))
	{
		return HAM_IGNORED;
	}
	if(!isMonsterAlive(victim))
	{
		return HAM_IGNORED;
	}
	new vmax = get_pcvar_num(Cvar_EnergyKill);
	if(user_canuseenergy(attacker) && EnergyKillValue[attacker] < vmax)
	{
		new oldval = EnergyKillValue[attacker];
		EnergyKillValue[attacker]++;
		new FWReturnEx;
		ExecuteForward(fw_energyvalchanged, FWReturnEx, attacker, oldval, EnergyKillValue[attacker]);
		xp_hud_show_player(attacker);
	}
	if(!nocall) user_frag_increased(attacker, 1);
	return HAM_IGNORED;
}  
public resetplayervariants(id)
{
	for(new i = 0; i < registered_skills;i++)
	{
		ExecuteForward(fw_needreset, FWReturn, id, i, PlayerSkills[id][Class][CurrentValue]);
	}
}
public Float:CalcPlayerPoints(id, skillid, userlevel)
{
	if(!isUserLoggedIn(id)) userlevel = 0;
	if(!skillactivate(id, skillid)) userlevel = 0;
	new plclass = PlayerSkills[id][Class][CurrentValue];
	if(plclass < 0) 
	{
		plclass = Prestige;
		PlayerSkills[id][Class][CurrentValue] = plclass;
	}
	new Float:MaxEffectVal = float(LevelClass[plclass][skillid][MaxEffectValue]);
	new Float:Max_Level = float(LevelClass[plclass][skillid][MaxLevel]);
	return floatmul(floatdiv(float(userlevel) , Max_Level), MaxEffectVal);
}
public Float:CalcPlayerRadius(id, skillid, userlevel)
{
	if(!isUserLoggedIn(id)) userlevel = 0;
	if(!skillactivate(id, skillid)) userlevel = 0;
	new plclass = PlayerSkills[id][Class][CurrentValue];
	if(plclass < 0) 
	{
		plclass = Prestige;
		PlayerSkills[id][Class][CurrentValue] = plclass;
	}
	new Float:Self_MaxRadius = float(LevelClass[plclass][skillid][MaxRadiusValue]);
	new Float:Max_Level = float(LevelClass[plclass][skillid][MaxLevel]);	
	return MinRadiusValue + floatmul(floatdiv(float(userlevel) , Max_Level), Self_MaxRadius);
}
//Changed 1.3.2: 17.08.2014: Fixed error
public Float:CalcPlayerMax(id, skillid, pevmax)
{
	new plclass = PlayerSkills[id][Class][CurrentValue];
	if(!SkillType) plclass = Prestige;
	new isUsable;
	isUsable = 0;
	if(plclass >= 0) isUsable = LevelClass[plclass][skillid][Usable];
	if(PlayerSkills[id][skillid][CurrentValue] <= 0)
	{
		new Float:FloatMaxH;
		pev(id, pevmax, FloatMaxH);
		PlayerSkills[id][skillid][CurrentValue] = floatround(FloatMaxH);
	}
	if(PlayerSkills[id][Banned][CurrentValue]) return float(PlayerSkills[id][skillid][CurrentValue]);
	new MaxPHealth = PlayerSkills[id][skillid][CurrentValue];
	if(MaxPHealth <= 0) MaxPHealth = 100;
	new Float:MHealth = float(MaxPHealth);
	if(isUsable > 0)
	{
		new User_Level = PlayerSkills[id][skillid][CurrentLevel];
		if(!skillactivate(id, skillid)) User_Level = 0;
		if(!isUserLoggedIn(id)) User_Level = 0;
		new Float:cHealth = CalcPlayerPoints(id, skillid, User_Level) + 1;
		new FirstMaxHealth = PlayerSkills[id][skillid][CurrentValue];
		if(User_Level > 0)
		{
			new FroundC = floatround(cHealth);
			FroundC += FirstMaxHealth;
			return float(FroundC);
		}
		else
		{
			return MHealth;
		}
	}
	return MHealth;
}
public xp_komutmenusu_isay(id)
{
	xp_komutmenusu(id, 1);
}
public xp_komutmenusu(id, idevamet)
{
	//Added 1.2: 04.04.2014
	new idonus = PLUGIN_HANDLED;
	if(idevamet) idonus = PLUGIN_CONTINUE;
	if(!id)
	{
		SendServerError();

		return idonus;
	}
	//
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		client_print(id, print_chat, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return idonus;
	}
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if(LoginRequired && logged <= 0)
	{
		console_print(id, "%s%L", PREFIX, id, "XP_CMDMENU_ERROR_LR");
		client_print(id, print_chat, "%s%L", PREFIX, id, "XP_CMDMENU_ERROR_LR");
		return idonus;
	}
	new HeaderMenu[400]
	if(!is_running("svencoop") && !xp_isplayerloggedin_extra(id))
	{
		formatex(HeaderMenu, 399, "%s%L^n%L", PREFIX, id, "XP_CMDMENU_HEADER", id, "XP_MENU_LOGRQDESC");
	}
	else
	{
		formatex(HeaderMenu, 399, "%s%L", PREFIX, id, "XP_CMDMENU_HEADER");
	}
	new menu = menu_create( HeaderMenu, "KomutMenuHandler" )
	new plclass = PlayerSkills[id][Class][CurrentValue];
	new strl[3];
	new strlang[60];
	if(!is_running("svencoop") && !xp_isplayerloggedin_extra(id))
	{
		formatex(strl, 2, "%i", 11);
		formatex(strlang, 59, "%L", id, "XP_MENU_LOGRQ");
		menu_additem( menu, strlang, strl, 0 );
	}
	if(plclass < 0 && SkillType)
	{
			formatex(strl, 2, "%i", 1);
			formatex(strlang, 59, "%L", id, "XP_CMDMENU_CLASS");
			menu_additem( menu, strlang, strl, 0 );
	}
	formatex(strl, 2, "%i", 10);
	formatex(strlang, 59, "%L", id, "XP_SET_DEACTIVATE");
	if(XPDeactivate[id])
	{
		formatex(strlang, 59, "%L", id, "XP_SET_ACTIVE");
	}
	menu_additem( menu, strlang, strl, 0 );

	/*formatex(strl, 2, "%i", 9);
	formatex(strlang, 59, "%s", "VoteMap");
	menu_additem( menu, strlang, strl, 0 );*/
	if(plclass >= 0 && PlayerSkills[id][PlayerLevel][CurrentLevel] > 0)
	{
			formatex(strl, 2, "%i", 2);
			formatex(strlang, 59, "%L", id, "XP_CMDMENU_SKILL");
			menu_additem( menu, strlang, strl, 0 );
	}
	if(isUserLoggedIn(id))
	{
			formatex(strl, 2, "%i", 8);
			formatex(strlang, 59, "%L", id, "XP_CMDMENU_MYSKILL");
			menu_additem( menu, strlang, strl, 0 );
	}
	new iPlayers[32], iNum
	get_players(iPlayers, iNum, "h")
	if(iNum > 1)
	{
		formatex(strl, 2, "%i", 3);
		formatex(strlang, 59, "%L", id, "XP_CMDMENU_OTHERPL");
		menu_additem( menu, strlang, strl, 0 );
	}
	if(plclass >= 0 && PlayerSkills[id][PlayerLevel][CurrentValue] > 0)
	{
		formatex(strl, 2, "%i", 4);
		formatex(strlang, 59, "%L", id, "XP_CMDMENU_RESETSKILL");
		menu_additem( menu, strlang, strl, 0 );
	}
	if(plclass >= 0 && PlayerSkills[id][PlayerLevel][CurrentValue] >= MaxLevels[plclass])
	{
		formatex(strl, 2, "%i", 6);
		formatex(strlang, 59, "%L", id, "XP_CMDMENU_PRESTIGE");
		menu_additem( menu, strlang, strl, 0 );
	}
	else if(plclass >= 0 && PlayerSkills[id][PlayerLevel][CurrentValue] > 0)
	{
		formatex(strl, 2, "%i", 5);
		formatex(strlang, 59, "%L", id, "XP_CMDMENU_RESETLEVEL");
		menu_additem( menu, strlang, strl, 0 );
	}
	formatex(strl, 2, "%i", 7);
	formatex(strlang, 59, "%L", id, "XP_CMDMENU_SKILLINFO");
	menu_additem( menu, strlang, strl, 0 );
	menu_display( id, menu, 0 );
	return idonus;
}
public KomutMenuHandler(id, menu, item)
{
	new MenuInfo[6], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, MenuInfo, 5, MenuItemName, 31, callback)
	new CId = str_to_num(MenuInfo);
	switch(CId)
	{
		case 1: //Snf seme mens
		{
			menu_skillsec(id);
		}
		case 2: //Yetenek seme mens
		{
			xp_yeteneksec(id);
		}
		case 3: //Dier oyuncu bilgileri
		{
			xp_digeroyuncular(id);
		}
		//Changed From 1.2: 03.03.2014
		case 4: //Btn yetenekleri sfrla.
		{
			ShowPrompt(id, 1);
		}
		case 5: //Btn seviyeleri sfrla.
		{
			ShowPrompt(id, 2);
		}
		case 6: //Prestij moduna ge.
		{
			ShowPrompt(id, 3);
		}
		//
		case 7: //Yetenek bilgileri.
		{
			xp_info(id);
		}
		case 8: //Yeteneklerim
		{
			YetenekMenusuGoster(id, 0);
		}
		case 9: //Votemap
		{
			client_cmd(id, "say vote");
		}
		case 10: //Activate or Deactivate
		{
			if(XPDeactivate[id]) XPDeactivate[id] = 0
			else XPDeactivate[id] = 1
		}
		case 11: //Loginmenu
		{
			#if !defined game_svencoop
			xp_show_loginmenu(id);
			#endif
		}
	}
	menu_destroy( menu );
}
public TakeDamage(id, inflictor, attacker, Float:damage, damagebits)
{
	if (!get_pcvar_num(Cvar_Enabled))
	{
		return HAM_IGNORED;
	}
	//Added 1.3: 29.03.2014;
	if(SkillType && PlayerSkills[id][Class][CurrentValue] < 0) PlayerSkills[id][Class][CurrentValue] = Prestige;
	//
	ExecuteForward(fw_player_takedamage, FWReturn, id, PlayerSkills[id][Class][CurrentValue], inflictor, attacker, damage, damagebits);
	if(FWReturn)
	{
		SetHamParamFloat(4, xpReturnFloat);
		return HAM_HANDLED;
	}
	return HAM_IGNORED;
}  
public PlayerSpawned(id)
{
	if(!get_pcvar_num(Cvar_Enabled)) return;
	CheckPlayerVariants(id);
	ExecuteForward(fw_plspawned, FWReturn, id, PlayerSkills[id][Class][CurrentValue]);
}
public PlayerKilled(victim, attacker, shouldgib) 
{
	if(!is_running("svencoop"))
	{
		if(!victim) return HAM_IGNORED;
		if(victim > 32) return HAM_IGNORED;
		if(attacker <= 0) return HAM_IGNORED;
		if(attacker > 32) return HAM_IGNORED;
		if(victim == attacker) return HAM_IGNORED;
		if(get_user_team(victim) == get_user_team(attacker) && !is_running("valve")) return HAM_IGNORED;
		user_frag_increased(attacker, 1);
		new vmax = get_pcvar_num(Cvar_EnergyKill);
		if(user_canuseenergy(attacker) && EnergyKillValue[attacker] < vmax)
		{
			new oldval = EnergyKillValue[attacker];
			EnergyKillValue[attacker]++;
			new FWReturnEx;
			ExecuteForward(fw_energyvalchanged, FWReturnEx, attacker, oldval, EnergyKillValue[attacker]);
			xp_hud_show_player(attacker);
		}
	}
	ExecuteForward(fw_plkilled, FWReturn, victim, PlayerSkills[victim][Class][CurrentValue], attacker, shouldgib);
	return HAM_IGNORED;	
}  
public SetMenuItemName(id, target, menu, item, bool:NType)
{
	new PLName[50]
	get_user_name(target, PLName, 49);
	if(NType)
	{
		formatex(PLName, 49, "%s%L", PLName, id, "XP_ON");
	}
	menu_item_setname( menu, item, PLName);
}
public getMenuIndex_num(menu, item)
{
	new MenuInfo[6], MenuItemName[60];
	new access, callback;
	menu_item_getinfo( menu, item, access, MenuInfo, 5, MenuItemName, 59, callback)
	return str_to_num(MenuInfo);
}
public xp_gamedesc()
{ 
	if(get_pcvar_num(Cvar_ShowAddonname) >= 1)
	{
		new g[32]
		formatex(g,31,"XP: %s",VERSION)
		forward_return(FMV_STRING, g)
		return FMRES_SUPERCEDE
	}
	return PLUGIN_HANDLED
}
public xp_setlevel(id,level,cid)
{
	if(!cmd_access(id,level,cid,3))
	{
		return PLUGIN_HANDLED
	}
	if(!cmd_access_ex_superadmin(id))
	{
		return PLUGIN_HANDLED
	}
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	new targetarg[32]
	read_argv(1,targetarg,31)
	new target=cmd_target(id,targetarg, 11)
	if(!target)
	{
		return PLUGIN_HANDLED;
	}
	new lvlarg[32]
	read_argv(2,lvlarg,31)
	new newlvl = str_to_num(lvlarg)
	new name[32]
	new PL_Level = PlayerSkills[target][PlayerLevel][CurrentValue];
	new PL_Class = PlayerSkills[target][Class][CurrentValue];

	get_user_name(target, name,31)
	if(PlayerSkills[target][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(PL_Class < 0)
	{
		console_print(id, "%s%L", PREFIX, id, "XP_SETLEVEL_ERROR_NL");
		return PLUGIN_HANDLED
	}
	if(newlvl>MaxLevels[PL_Class])
	{
		newlvl = MaxLevels[PL_Class];
	}
	else
	{
		if(newlvl<0)
		{
			newlvl=0
		}
	} 
	if(newlvl == PL_Level)
	{
		console_print(id,"%s%L", PREFIX, id, "XP_SETLEVEL_ERROR_AL", name,newlvl)
		return PLUGIN_HANDLED
	}
	if(set_user_level(id, target, setlevel_admin, newlvl, true))
	{
		console_print(id,"%s%L", PREFIX, id, "XP_SETLEVEL_SUCCESS", name,newlvl)
		SendClientMessage(id, target, "XP_SETLEVEL_SUCCESS_ALL", false, newlvl, PREFIX);	
	}
	return PLUGIN_HANDLED;
}
public xp_prestij(id)
{
	//Added 1.2: 04.04.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(id))
	{
		client_print(id,print_chat, "%s%L", PREFIX, id, "YOU_RQ_LOGGED");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][PlayerLevel][CurrentValue] >= MaxLevels[PlayerSkills[id][Class][CurrentValue]])
	{
		if(!user_canchangelevel(id, id, setlevel_enterprestige, PlayerSkills[id][PlayerLevel][CurrentValue], 0))
		{
			return PLUGIN_HANDLED;
		}
		if(SkillType) PlayerSkills[id][PlayerLevel][CurrentValue] = -1;
		PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
		xp_reset1(id);
		new oldprestij = PlayerSkills[id][PrestigeCount][CurrentValue];
		oldprestij++;
		PlayerSkills[id][PrestigeCount][CurrentValue] = oldprestij;
		client_print(id,print_chat, "%s%L", PREFIX, id, "XP_PRESTIGE_SUCCESS", get_pcvar_float(Cvar_MulPrestige));
		resetplayervariants(id);
		if(SkillType) SinifSecmeMenusuGoster(id);
	}
	else
	{
		client_print(id,print_chat, "%s%L", PREFIX, id, "XP_PRESTIGE_ERROR");
	}
	return PLUGIN_HANDLED;
}
public xp_reset1(id)
{
	PlayerSkills[id][Class][CurrentValue] = -1;
	PlayerSkills[id][XP][TopValue] = 0;
	PlayerSkills[id][XP][ReqValue] = StartXP + XPMultiplier;
	PlayerSkills[id][PlayerLevel][CurrentValue] = 0;
	PlayerSkills[id][XP][CurrentValue] = 0;
	ClearSkills(id);
}
public xp_resetall(id)
{
	//Added 1.2: 04.04.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(id))
	{
		client_print(id,print_chat, "%s%L", PREFIX, id, "YOU_RQ_LOGGED");
		return PLUGIN_HANDLED;
	}
	if(SkillType) PlayerSkills[id][Class][CurrentValue] = -1;
	PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
	xp_reset1(id);
	client_print(id,print_chat, "%s%L", PREFIX, id, "XP_RESETLEVEL_SUCCESS");
	resetplayervariants(id);
	if(SkillType) SinifSecmeMenusuGoster(id);
	return PLUGIN_HANDLED;

}
public xp_reset(id)
{
	//Added 1.2: 04.04.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(!isUserLoggedIn(id))
	{
		client_print(id,print_chat, "%s%L", PREFIX, id, "YOU_RQ_LOGGED");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][PlayerLevel][CurrentValue] > 0)
	{
		client_print(id,print_chat, "%s%L", PREFIX, id, "XP_RESETSKILL_SUCCESS")
		ClearSkills(id);
		PlayerSkills[id][PlayerLevel][CurrentLevel] = PlayerSkills[id][PlayerLevel][CurrentValue];
		resetplayervariants(id);
		SkillSecmeMenusuGoster(id, 0);
	}
	else
	{
		client_print(id,print_chat, "%s%L", PREFIX, id, "XP_RESETSKILL_ERROR")
	}
	return PLUGIN_HANDLED;
}

public xp_info(id)
{
	//Added 1.2: 04.04.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	new yetenekler[1600];
	new stringcontect[255];
	new strings[90];
	for(new i = 0; i < registered_skills; i++)
	{
		formatex(strings, 89, "%L", id, LevelString[i]);
		formatex(stringcontect, 254, "%s_CT", LevelString[i]);
		formatex(stringcontect, 254, "%L", id, stringcontect);
		if(is_running("cstrike"))
		{
			formatex(yetenekler, 1599, "%s%i. %s:<br> %s<br>",yetenekler, i + 1, strings, stringcontect);
		}
		else
		{
			formatex(yetenekler, 1599, "%s%i. %s:^n %s^n",yetenekler, i + 1, strings, stringcontect);
		}
		
	}
	if(is_running("cstrike"))
	{
		formatex(yetenekler,1599,"%s<br>- %L ",yetenekler, id, "XP_CLASS_PR_CTA", get_pcvar_float(Cvar_MulPrestige))
	}
	else
	{
		formatex(yetenekler,1599,"%s^n- %L ",yetenekler, id, "XP_CLASS_PR_CTA", get_pcvar_float(Cvar_MulPrestige))
	}
	new Header[75];
	formatex(Header, 74, "%L", id, "XP_CMDMENU_SKILLINFO");
	show_motdex(id,yetenekler, Header)
	return PLUGIN_HANDLED;
}
// Added 1.2: 04.04.2014
public xp_showplayeronserver()
{
	new sdata[300]
	new PName[80];
	new LevelS[80];
	formatex(PName, 79, "%L", LANG_SERVER, "XP_INFO_PNAME");
	formatex(LevelS, 79, "%L", LANG_SERVER, "XP_INFO_LEVEL");
	formatex(sdata, 299, "%s               %s", PName, LevelS);
	server_print(sdata)
	new iPlayers[32],iNum
	get_players(iPlayers,iNum, "g")

	new name[30]
	new namesp[80];
	new ulvl;
	for(new g=0;g<iNum;g++)
	{
		new i=iPlayers[g]
		get_user_name(i,name,29)
		add_spacestostr((15 + strlen(PName)) - strlen(name), namesp, (15 + strlen(PName)) - strlen(name));
		if(!isUserLoggedIn(i))
		{
			ulvl = -1;
		}
		else
		{
			ulvl = PlayerSkills[i][PlayerLevel][CurrentValue];
		}
		if(PlayerSkills[i][Banned][CurrentValue])
		{
			formatex(sdata,299,"%s%s%i(%L)",name, namesp, ulvl, LANG_SERVER, "XP_PLAYERS_INFO_BANNED")
		}
		else
		{
			formatex(sdata,299,"%s%s%i",name, namesp, ulvl)
		}
		server_print(sdata);
	}
}
//
public xp_digeroyuncular(id)
{
	//Added 1.2: 04.04.2014
	if(!id)
	{
		xp_showplayeronserver();
		return PLUGIN_HANDLED;
	}
	//
	new alldata[1200]
	new PName[80];
	new LevelS[80];
	new RankS[80];
	new ClassS[80];
	new EnergyS[80];
	formatex(PName, 79, "%L", id, "XP_INFO_PNAME");
	formatex(LevelS, 79, "%L", id, "XP_INFO_LEVEL");
	formatex(RankS, 79, "%L", id, "XP_INFO_RANK");
	formatex(ClassS, 79, "%L", id, "XP_INFO_CLASS");
	formatex(EnergyS, 79, "%L", id, "XP_INFO_ENERGY");
	if(!SkillType)
	{
		if(is_running("cstrike"))
		{
			formatex(alldata, 1199, "%s               %s           %s<br>", PName, LevelS, RankS);
		}
		else
		{
			formatex(alldata, 1199, "%s               %s           %s           %s^n", PName, LevelS, RankS, EnergyS);
		}
	}
	else
	{
		if(is_running("cstrike"))
		{
			formatex(alldata, 1199, "%s               %s           %s               %s<br>", PName, LevelS, RankS, ClassS);
		}
		else
		{
			formatex(alldata, 1199, "%s               %s           %s               %s           %s^n", PName, LevelS, RankS, ClassS, EnergyS);
		}
		
	}
	new iPlayers[32],iNum
	get_players(iPlayers,iNum, "g")
	for(new g=0;g<iNum;g++)
	{
		new i=iPlayers[g]
		if(!isUserLoggedIn(i))
		{
			continue;
		}
		if(is_user_connected(i))
		{
			new name[30]
			new rankname[30]
			get_user_name(i,name,19)
			//Updated 1.3: 27.03.2014
			get_user_rank(i, rankname, 29, id);
			//
			new namesp[80];
			new seviyesp[80];
			new seviyestr[80];
			new ranksp[80];
			new energysp[80];
			formatex(energysp, 79, "          ");
			new uranking[60];
			if(!user_canuseenergy(i))
			{
				formatex(uranking, 59, "%L", i, "XP_NFO_ENERGY_ERR");
			}
			else
			{
				xp_createenergyrow(i, 10, 2, uranking, 59);
			}
			formatex(seviyestr, 5, "%i", PlayerSkills[i][PlayerLevel][CurrentValue]);
			add_spacestostr((15 + strlen(RankS)) - strlen(rankname), ranksp, (15 + strlen(RankS)) - strlen(ranksp))
			add_spacestostr((15 + strlen(PName)) - strlen(name), namesp, (15 + strlen(PName)) - strlen(name));
			add_spacestostr((11 + strlen(LevelS)) - strlen(seviyestr), seviyesp, (11 + strlen(LevelS)) - strlen(seviyestr));
			//add_spacestostr((11 + strlen(EnergyS)) - strlen(uranking), energysp, (11 + strlen(EnergyS)) - strlen(uranking));
			if(PlayerSkills[i][Banned][CurrentValue])
			{
				if(is_running("cstrike"))
				{
					formatex(alldata,1199,"%s<br>%s%s%L",alldata, name, namesp, i, "XP_PLAYERS_INFO_BANNED")
				}
				else
				{
					formatex(alldata,1199,"%s^n%s%s%L",alldata, name, namesp, i, "XP_PLAYERS_INFO_BANNED")
				}
				
				continue;
			}
			if(!SkillType)
			{
				if(is_running("cstrike"))
				{
					formatex(alldata,1199,"%s<br>%s%s%i%s%s",alldata, name, namesp, PlayerSkills[i][PlayerLevel][CurrentValue], seviyesp, rankname)
				}
				else
				{
					formatex(alldata,1199,"%s^n%s%s%i%s%s%s%s",alldata, name, namesp, PlayerSkills[i][PlayerLevel][CurrentValue], seviyesp, rankname, energysp, uranking)
				}
			}
			else
			{
				new ClassNameF[35];
				switch(PlayerSkills[i][Class][CurrentValue])
				{
					case Maroon_Berets:
					{
						formatex(ClassNameF, 34, "%L", id, "XP_CLASS_MB");
					}
					case Prestige:
					{
						formatex(ClassNameF, 34, "%L", id, "XP_CLASS_PR");
					}
					case Medic:
					{
						formatex(ClassNameF, 34, "%L", id, "XP_CLASS_MEDIC");
					}
					case Soldier:
					{
						formatex(ClassNameF, 34, "%L", id, "XP_CLASS_SOL");
					}
					default:
					{
						formatex(ClassNameF, 34, "%L", id, "XP_CLASS_N");
					}
				}
				if(is_running("cstrike"))
				{
					formatex(alldata,1199,"%s<br>%s%s%i%s%s%s%s",alldata, name, namesp, PlayerSkills[i][PlayerLevel][CurrentValue], seviyesp, rankname, ranksp, ClassNameF)
				}
				else
				{
					formatex(alldata,1199,"%s^n%s%s%i%s%s%s%s%s%s",alldata, name, namesp, PlayerSkills[i][PlayerLevel][CurrentValue], seviyesp, rankname, ranksp, ClassNameF, energysp, uranking)
				}
				
			 }
		}
	}
	new Header[100]
	formatex(Header, 99, "%L", id, "XP_PLAYERS_INFO");
	show_motdex(id,alldata, Header)
	return PLUGIN_HANDLED;
}
stock add_spacestostr(scount, outputstr[], len)
{
	if(len <= 0) return;
	new StrA[255];
	for(new i = 0; i < scount; i++)
	{

		formatex(StrA, len, "%s%s",StrA, " ");
	}
	copy ( outputstr, len, StrA ) 
}
stock cmd_access_ex_superadmin(id)
{
	if(!get_pcvar_num(Cvar_AccessCmdOnlySuperAdmin))
	{
		return 1;
	}
	return user_spec(id);
}
stock user_spec(id)
{
	if(XPSuperAdmin[id])
	{
		return 1;
	}
	return 0;
}
// Added 1.3: 24.03.2014
stock get_user_rankid(id)
{
	if(XPSpecRankid[id] > 0)
	{
		return XPSpecRankid[id];
	}
	new plclass = PlayerSkills[id][Class][CurrentValue];
	if(plclass == -1) plclass = Prestige;
	new ULevel = PlayerSkills[id][PlayerLevel][CurrentValue];
	new Oran1 = MaxLevels[plclass] / 25;
	if(Oran1 <= 0) return -1;
	return (ULevel / Oran1);
}
//
stock get_user_rank(id, outputstr[], len, langid = -1)
{
	new PlayerRank[45];
	new RankText[45];
	//Changed 1.3: 24.03.2014
	new RutbeA = get_user_rankid(id);
	//
	//Changed from 1.2.2: 14.03.2014
	switch(RutbeA)
	{
		case 666:
		{
			RankText = "XP_RANK_XP";
		}
		case 665:
		{
			RankText = "XP_RANK_GA";
		}
		case 24:
		{
			RankText = "XP_RANK_GEN"
		}
		case 23:
		{
			RankText = "XP_RANK_LTGEN"
		}
		case 22:
		{
			RankText = "XP_RANK_MGEN"
		}
		case 21:
		{
			RankText = "XP_RANK_BRG"
		}
		case 20:
		{
			RankText = "XP_RANK_COL"
		}
		case 19:
		{
			RankText = "XP_RANK_LTCOL"
		}
		case 18:
		{
			RankText = "XP_RANK_MAJ"
		}
		case 17:
		{
			RankText = "XP_RANK_CAP"
		}
		case 16:
		{
			RankText = "XP_RANK_FLT"
		}
		case 15:
		{
			RankText = "XP_RANK_SLT"
		}
		case 14:
		{
			RankText = "XP_RANK_TLT"
		}
		case 13:
		{
			RankText = "XP_RANK_SCMAJ"
		}
		case 12:
		{
			RankText = "XP_RANK_SMAJ"
		}
		case 11:
		{
			RankText = "XP_RANK_FSER"

		}
		case 10:
		{
			RankText = "XP_RANK_MSER"
		}
		case 9:
		{
			RankText = "XP_RANK_SFC"
		}
		case 8:
		{
			RankText = "XP_RANK_STSER"
		}
		case 7:
		{
			RankText = "XP_RANK_SERSP"
		}
		case 6:
		{
			RankText = "XP_RANK_SER"	
		}
		case 5:
		{
			RankText = "XP_RANK_CORSP"
		}
		case 4:
		{
			RankText = "XP_RANK_COR"
		}
		case 3:
		{
			RankText = "XP_RANK_PFC"
		}
		case 2:
		{
			RankText = "XP_RANK_PVT"
		}
		case 1:
		{
			RankText = "XP_RANK_NB"
		}
		case 0:
		{
			RankText = "XP_RANK_CIV"
		}
		default:
		{
			RankText = "XP_RANK_MARSHAL"
		}
	}
	//
	//Changed 1.2.2: 21.03.2014
	if(langid >= 0)
	{
		formatex(PlayerRank, 44, "%L", langid, RankText);
	}
	else
	{
		formatex(PlayerRank, 44, "%L", id, RankText);
	}
	//
	if(RutbeA > PlayerSkills[id][PlayerLevel][LastValue] && PlayerSkills[id][PlayerLevel][LastValue] != -1)
	{
		new RankLang[50]
		new playername[50]
		get_user_name(id, playername, 49)
		formatex(RankLang, 49, "%s%s", "LANGIBM_", RankText)
		xp_notify_show("XP_NTF_USERRNK", 1, playername, RankLang);
	}
	copy ( outputstr, len, PlayerRank ) ;
	PlayerSkills[id][PlayerLevel][LastValue] = RutbeA
}
stock xp_get_skillid_byname(const Name[])
{
	for(new i = 0;i < registered_skills;i++)
	{
		if(equal(LevelString[i], Name))
		{
			return i;
		}
	}
	return -1;
}
public menu_skillsec(id)
{
	//Added 1.2: 04.04.2014
	if(!id)
	{
		return PLUGIN_CONTINUE;
	}
	//
	new logged = PlayerSkills[id][LoggedIn][CurrentValue];
	if (!get_pcvar_num(Cvar_Enabled))
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_DIS");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Banned][CurrentValue])
	{
		console_print(id, "%s%L", PREFIX, id, "XP_MAIN_ERROR_BAN");
		return PLUGIN_HANDLED;
	}
	if(LoginRequired && logged <= 0)
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "XP_MENUSKILL_ERROR_LR");
		return PLUGIN_HANDLED;
	}
	if(PlayerSkills[id][Class][CurrentValue] >= 0)
	{
		client_print(id, print_chat, "%s%L", PREFIX, id, "XP_MENUSKILL_ERROR_AL");
	}
	else
	{
		SinifSecmeMenusuGoster(id);
	}
	return PLUGIN_HANDLED;
}
public Array:OyuncuVerileriniGetir(const TQuery[])
{
	new itemcount = 0;
	new Array:g_ItemArray;
	g_ItemArray = ArrayCreate( UserXPData )
	new NQuery[1024];
	formatex(NQuery, sizeof(NQuery) - 1, "SELECT * FROM xp_mod_data WHERE userid =^"%s^"", TQuery);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	while (SQL_MoreResults(GcHandle))
	{
		new UserData[UserXPData];
		SQL_ReadResult(GcHandle, 0, UserData[uxd_userid], charsmax(UserData[uxd_userid]));
		SQL_ReadResult(GcHandle, 1, UserData[uxd_dataname], charsmax(UserData[uxd_dataname]));
		SQL_ReadResult(GcHandle, 2, UserData[uxd_value_A], charsmax(UserData[uxd_value_A]));
		SQL_ReadResult(GcHandle, 3, UserData[uxd_value_B], charsmax(UserData[uxd_value_B]));
		SQL_ReadResult(GcHandle, 4, UserData[uxd_value_C], charsmax(UserData[uxd_value_C]));
		SQL_ReadResult(GcHandle, 5, UserData[uxd_value_D], charsmax(UserData[uxd_value_D]));
		convert_to_unsafestring(UserData[uxd_value_A], charsmax(UserData[uxd_value_A]));
		convert_to_unsafestring(UserData[uxd_value_B], charsmax(UserData[uxd_value_B]));
		convert_to_unsafestring(UserData[uxd_value_C], charsmax(UserData[uxd_value_C]));
		convert_to_unsafestring(UserData[uxd_value_D], charsmax(UserData[uxd_value_D]));
		ArrayPushArray( g_ItemArray, UserData)
		itemcount++;
		SQL_NextRow(GcHandle);
	}
	SQL_FreeHandle(GcHandle);
	return g_ItemArray;
	
}
public OyuncuSonVerileriGuncelle(const userid[], const lastname[])
{
	if(!SQLLoaded)
	{
		return false;
	}
	new safestring[100];
	formatex(safestring, 99, lastname);
	new NQuery[1024];
	convert_to_safestring(safestring, 99);
	formatex(NQuery, sizeof(NQuery) - 1, "UPDATE xp_mod_main SET username = '%s', lastactivity = %i WHERE userid = '%s'", safestring, get_currenttime_num(), userid);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	if(!SQL_Execute(GcHandle)) return false;
	SQL_FreeHandle(GcHandle);
	return true;
}
public bool:OyuncuVerileriVar(const TQuery[])
{
	new NQuery[255];
	formatex(NQuery, sizeof(NQuery) - 1, "SELECT userid FROM xp_mod_main WHERE userid =^"%s^"", TQuery);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	new found = 0;
	while (SQL_MoreResults(GcHandle))
	{
		found = 1;
		break;
	}
	SQL_FreeHandle(GcHandle);
	if(found)
	{
		return true;
	}
	return false;
}
public OyuncuTumDegerleriniSifirla(const TQuery[])
{	
	new NQuery[255];
	formatex(NQuery, sizeof(NQuery) - 1, "DELETE FROM xp_mod_data WHERE userid =^"%s^"", TQuery);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
	OyuncuInfoDegerleriniGuncelle(TQuery, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
}
public OyuncuInfoDegerleriniGuncelle(const TQuery[], userlevel, userlevel_max, userxptotal, banned, xpdeactivated, energykill, userclass, xpvalue, xpreqvalue, prestige, beforefirst)
{
	new NQuery[512];
	formatex(NQuery, sizeof(NQuery) - 1, "UPDATE xp_mod_userinfo SET userlevel = %i, userlevel_max = %i, userxptotal = %i, banned = %i, xpdeactivated = %i, energykill = %i, userclass = %i, xpvalue = %i, xpreqvalue = %i, prestige = %i, beforefirst = %i  WHERE userid = '%s'", userlevel, userlevel_max, userxptotal, banned, xpdeactivated, energykill, userclass, xpvalue, xpreqvalue, prestige, beforefirst, TQuery);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
}
public OyuncuDegeriGuncelleOlustur(const TQuery[], const DataName[], const ValueA[], const ValueB[], const ValueC[], const ValueD[])
{
	new NQuery[255];
	new safestringA[100];
	formatex(safestringA, 99, DataName);
	convert_to_safestring(safestringA, 99);
	
	new safestringB[100];
	formatex(safestringB, 99, ValueA);
	convert_to_safestring(safestringB, 99);
	
	new safestringC[100];
	formatex(safestringC, 99, ValueB);
	convert_to_safestring(safestringC, 99);
	
	new safestringD[100];
	formatex(safestringD, 99, ValueC);
	convert_to_safestring(safestringD, 99)
	
	new safestringE[100];
	formatex(safestringE, 99, ValueD);
	convert_to_safestring(safestringE, 99)

	formatex(NQuery, sizeof(NQuery) - 1, "DELETE FROM xp_mod_data WHERE userid =^"%s^" AND dataname = ^"%s^"", TQuery, safestringA);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
	formatex(NQuery, sizeof(NQuery) - 1, "INSERT INTO xp_mod_data VALUES('%s', '%s', '%s', '%s', '%s', '%s')", TQuery, safestringA, safestringB, safestringC, safestringD, safestringE);
	GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
}
public OyuncuHeaderiOlustur(const TQuery[], const UserName[])
{
	new safestring[100];
	formatex(safestring, 99, UserName);
	new NQuery[1024];
	convert_to_safestring(safestring, 99);
	formatex(NQuery, sizeof(NQuery) - 1, "INSERT INTO xp_mod_main VALUES('%s', '%s', '%s', %i, %i)", TQuery, safestring, safestring, get_currenttime_num(), get_currenttime_num());
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
	formatex(NQuery, sizeof(NQuery) - 1, "INSERT INTO xp_mod_userinfo VALUES('%s', %i, %i, %i, %i, %i, %i, %i, %i, %i, %i, %i)", TQuery, 0, 0, 0, 0, 0, 0, XP_CL_PRESTIGE, 0, 0, 0, 0);
	GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	SQL_FreeHandle(GcHandle);
}
public OyuncuHeaderiKontrolEtOlustur(const TQuery[], const UserName[])
{
	if(!OyuncuVerileriVar(TQuery))
	{
		OyuncuHeaderiOlustur(TQuery, UserName);
	}
	else
	{
		OyuncuSonVerileriGuncelle(TQuery, UserName);
	}
}
public OyuncuAyarlariniGetir(const TQuery[])
{
	new NQuery[255];

	formatex(NQuery, sizeof(NQuery) - 1, "SELECT * FROM xp_mod_main INNER JOIN xp_mod_userinfo ON xp_mod_main.userid = xp_mod_userinfo.userid  WHERE xp_mod_main.userid =^"%s^"", TQuery);
	new Handle:GcHandle = SQL_PrepareQuery(SQLConnection, NQuery);
	SQL_Execute(GcHandle);
	new UPlayerXPData[UserXPDataHeader];
	new found = 0;
	while (SQL_MoreResults(GcHandle))
	{
		SQL_ReadResult(GcHandle, 0, UPlayerXPData[uxdh_userid], charsmax(UPlayerXPData[uxdh_userid]));
		SQL_ReadResult(GcHandle, 1, UPlayerXPData[uxdh_first_username], charsmax(UPlayerXPData[uxdh_first_username]));
		SQL_ReadResult(GcHandle, 2, UPlayerXPData[uxdh_username], charsmax(UPlayerXPData[uxdh_username]));
		convert_to_unsafestring(UPlayerXPData[uxdh_first_username], charsmax(UPlayerXPData[uxdh_first_username]));
		convert_to_unsafestring(UPlayerXPData[uxdh_username], charsmax(UPlayerXPData[uxdh_username]));
		UPlayerXPData[uxdh_joindate] = SQL_ReadResult(GcHandle, 3);
		UPlayerXPData[uxdh_lastactivity] = SQL_ReadResult(GcHandle, 4);
		UPlayerXPData[uxdh_userlevel] = SQL_ReadResult(GcHandle, 6);
		UPlayerXPData[uxdh_userlevel_max] = SQL_ReadResult(GcHandle, 7);
		UPlayerXPData[uxdh_userxptotal] = SQL_ReadResult(GcHandle, 8);
		UPlayerXPData[uxdh_banned] = SQL_ReadResult(GcHandle, 9);
		UPlayerXPData[uxdh_xpdeactivated] = SQL_ReadResult(GcHandle, 10);
		UPlayerXPData[uxdh_energykill] = SQL_ReadResult(GcHandle, 11);
		UPlayerXPData[uxdh_userclass] = SQL_ReadResult(GcHandle, 12);
		UPlayerXPData[uxdh_xpvalue] = SQL_ReadResult(GcHandle, 13);
		UPlayerXPData[uxdh_xpreqvalue] = SQL_ReadResult(GcHandle, 14);
		UPlayerXPData[uxdh_prestige] = SQL_ReadResult(GcHandle, 15);
		UPlayerXPData[uxdh_beforefirst] = SQL_ReadResult(GcHandle, 16);
		found = 1;

		break;
	}
	SQL_FreeHandle(GcHandle);
	if(found)
	{
		UPlayerXPData[uxdh_UserData] = OyuncuVerileriniGetir(TQuery);
		UPlayerXPData[uxdh_loadeddata] = ArraySize(UPlayerXPData[uxdh_UserData]);
	}
	return UPlayerXPData;
	
}
public OyuncuAyarlariniYukleB(id, const TQuery[], const UserName[])
{
	OyuncuHeaderiKontrolEtOlustur(TQuery, UserName);
	new UserAllData[UserXPDataHeader];
	UserAllData = OyuncuAyarlariniGetir(TQuery);
	if(UserAllData[uxdh_beforefirst] > 0)
	{
		//Changed 1.3: 26.03.2014
		new skactivate = 0;
		for(new i = 0; i < registered_skills; i++)
		{
			for(new j = 0; j < UserAllData[uxdh_loadeddata]; j++)
			{
				new UserSubData[UserXPData];
				ArrayGetArray(UserAllData[uxdh_UserData], j, UserSubData);
				if(equali(UserSubData[uxd_dataname], LevelString[i]))
				{
					PlayerSkills[id][i][CurrentLevel] = str_to_num(UserSubData[uxd_value_A]);
					PlayerSkills[id][i][Activate] = 1;
					skactivate = str_to_num(UserSubData[uxd_value_B]);
					if(skactivate) PlayerSkills[id][i][Activate] = skactivate - 1;
					break;
				}
			}
		}

		//
		//XP Values
		XPDeactivate[id] = UserAllData[uxdh_xpdeactivated];
		PlayerSkills[id][XP][CurrentValue] = UserAllData[uxdh_xpvalue];
		PlayerSkills[id][XP][ReqValue] = UserAllData[uxdh_xpreqvalue];
		PlayerSkills[id][XP][TopValue] = UserAllData[uxdh_userxptotal];
		//Level Values
 
		PlayerSkills[id][PlayerLevel][CurrentValue] = UserAllData[uxdh_userlevel];
		user_canchangelevel(id, id, setlevel_load, 0, PlayerSkills[id][PlayerLevel][CurrentValue]);
		PlayerSkills[id][PlayerLevel][CurrentLevel] = UserAllData[uxdh_userlevel_max];
		//Class Values
		PlayerSkills[id][Class][CurrentValue] = UserAllData[uxdh_userclass];
		//Prestige Value
		PlayerSkills[id][PrestigeCount][CurrentValue] = UserAllData[uxdh_prestige];
		//Password Values
		PlayerSkills[id][Banned][CurrentValue] =  UserAllData[uxdh_banned];
		EnergyKillValue[id] =  UserAllData[uxdh_energykill];
		new FWReturnEx;
		ExecuteForward(fw_energyvalchanged, FWReturnEx, id, 0, EnergyKillValue[id]);
		//Changed From 1.2: 04.04.2014
		if(PlayerSkills[id][XP][ReqValue] <= 0 && PlayerSkills[id][Class][CurrentValue] > 0)
		{
			new PLCL = PlayerSkills[id][PlayerLevel][CurrentLevel] + 1;
			if(PLCL < MaxLevels[PlayerSkills[id][Class][CurrentValue]])
			{
				PlayerSkills[id][XP][ReqValue] = StartXP + PLCL * XPMultiplier;
			}
		}
		else
		{
			PlayerSkills[id][XP][ReqValue] = (PlayerSkills[id][PlayerLevel][CurrentValue] + 1) * XPMultiplier +  StartXP;
			if(PlayerSkills[id][XP][CurrentValue] >= PlayerSkills[id][XP][ReqValue] )
			{
				PlayerSkills[id][XP][CurrentValue] = 0;
			}
		}
		//
		if(PlayerSkills[id][PlayerLevel][CurrentLevel] > PlayerSkills[id][PlayerLevel][CurrentValue])
		{
			 PlayerSkills[id][PlayerLevel][CurrentLevel] = PlayerSkills[id][PlayerLevel][CurrentValue];
		}
		if(SkillType)
		{
			if(PlayerSkills[id][PrestigeCount][CurrentValue] <= 0 && PlayerSkills[id][Class][CurrentValue] == Prestige)
			{
				PlayerSkills[id][Class][CurrentValue] = -1;
				if(PlayerSkills[id][PlayerLevel][CurrentValue] > 0)
				{
					PlayerSkills[id][PlayerLevel][CurrentLevel] = PlayerSkills[id][PlayerLevel][CurrentValue];
					for(new gp = 0; gp < registered_skills; gp++)
					{
						PlayerSkills[id][gp][CurrentLevel] = 0;
					}
					resetplayervariants(id);
				}
			}
		}
		else
		{
			PlayerSkills[id][Class][CurrentValue] = Prestige;
		}
	}
	else
	{
		if(!SkillType)
		{
			PlayerSkills[id][Class][CurrentValue] = Prestige;
		}
		else
		{
			PlayerSkills[id][Class][CurrentValue] = -1;
		}
		PlayerSkills[id][PlayerLevel][CurrentValue] = 0;
		PlayerSkills[id][PrestigeCount][CurrentValue] = 0;
		PlayerSkills[id][XP][CurrentValue] = 0;
		PlayerSkills[id][XP][TopValue] = 0;
		PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
		ClearSkills(id);
		PlayerSkills[id][XP][ReqValue] = StartXP + XPMultiplier
	}
	ArrayDestroy(UserAllData[uxdh_UserData]);
}
public OyuncuAyarlariniYukle(id, const plid[])
{
	new authid[80]
	get_user_name(id, authid, 79);
	resetplayervariants(id);
	OyuncuAyarlariniYukleB(id, plid, authid);
}
public LevelAyarla(id)
{
	CheckPlayerIllegalLevel(id);
	CheckPlayerVariants(id);
}
public CheckPlayerIllegalLevel(id)
{
	if(!isUserLoggedIn(id)) return;
	new PlLevel = PlayerSkills[id][PlayerLevel][CurrentValue];
	new PLEx = PlayerSkills[id][PlayerLevel][CurrentLevel];
	new TopLvl = 0;
	new Fark;
	for(new i = 0;i < registered_skills;i++)
	{
		TopLvl += PlayerSkills[id][i][CurrentLevel];
	}

	if(TopLvl + PLEx < PlLevel)
	{
		Fark = PlLevel - TopLvl + PLEx;
		PlayerSkills[id][PlayerLevel][CurrentLevel] += PlLevel - TopLvl + PLEx;
		return;
	}
	if(TopLvl + PLEx > PlLevel)
	{
		Fark = TopLvl + PLEx - PlLevel;
		if(PlayerSkills[id][PlayerLevel][CurrentLevel] > 0) 
		{
			if(Fark > PlayerSkills[id][PlayerLevel][CurrentLevel])
			{
				Fark -= PlayerSkills[id][PlayerLevel][CurrentLevel];
				PlayerSkills[id][PlayerLevel][CurrentLevel] = 0
			}
			else if( PlayerSkills[id][PlayerLevel][CurrentLevel] > Fark)
			{
				PlayerSkills[id][PlayerLevel][CurrentLevel] -= Fark;
				Fark = 0;
			}
			else
			{
				Fark -= PlayerSkills[id][PlayerLevel][CurrentLevel];
				PlayerSkills[id][PlayerLevel][CurrentLevel] = 0
			}
		}
				
		//Added 1.3: 30.03.2014
		new bool:IsDecreased;
		while(Fark > 0)
		{
			for(new i = 0;i < registered_skills;i++)
			{
				if(PlayerSkills[id][i][CurrentLevel] > 0)
				{
					IsDecreased = true;
					PlayerSkills[id][i][CurrentLevel]--;
				}
			}
			if(!IsDecreased) break;
			IsDecreased = false;
		}
		//
	}
}
public SinifSecmeMenusuGoster(id)
{
	new MenuHeader[60];
	new MenuContent[90];
	formatex(MenuHeader, 59, "\r%s%L", PREFIX, id, "XP_MENUSKILL_HEADER");
	new menu = menu_create( MenuHeader, "SinifMenuHandler" )
	formatex(MenuContent, 89, "\w%L - %L", id, "XP_CLASS_MEDIC", id, "XP_CLASS_MEDIC_CT");
	menu_additem( menu, MenuContent, "", 0 );
	formatex(MenuContent, 89, "\w%L - %L", id, "XP_CLASS_SOL", id, "XP_CLASS_SOL_CT");
	menu_additem( menu, MenuContent, "", 0 );
	formatex(MenuContent, 89, "\w%L - %L", id, "XP_CLASS_MB", id, "XP_CLASS_MB_CT");
	menu_additem( menu, MenuContent, "", 0 );
	if(PlayerSkills[id][PrestigeCount][CurrentValue])
	{
		formatex(MenuContent, 89, "\w%L - %L", id, "XP_CLASS_PR", id, "XP_CLASS_PR_CT");
		menu_additem( menu, MenuContent, "", 0 );
	}
	menu_display( id, menu, 0 );
}
public SinifMenuHandler( id, menu, item )
{
	new selectedclass;
	PlayerSkills[id][XP][ReqValue] =  StartXP + XPMultiplier;
	switch(item)
	{
		case 0:
		{
			client_print( id, print_chat, "%s%L", PREFIX, id, "XP_CLASS_MEDIC_MSG" );
			selectedclass = Medic;
		}
		case 1:
		{
			client_print( id, print_chat, "%s%L", PREFIX, id, "XP_CLASS_SOL_MSG" );
			selectedclass = Soldier;
		}
		case 2:
		{
			client_print( id, print_chat, "%s%L", PREFIX, id, "XP_CLASS_MB_MSG" )
			selectedclass = Maroon_Berets;
		}
		case 3:
		{
			client_print( id, print_chat, "%s%L", PREFIX, id, "XP_CLASS_PR_MSG" );
			selectedclass = Maroon_Berets;
		}
        case MENU_EXIT:
        {
            selectedclass = -1;
        }
    }
	PlayerSkills[id][Class][CurrentValue] = selectedclass;
	if(PlayerSkills[id][Class][CurrentLevel] > 0)
	{
		new Float:LevPoint = floatmul(float(MaxLevels[selectedclass]), floatdiv(float(PlayerSkills[id][PlayerLevel][CurrentLevel]), float(MaxLevels[Prestige])));
		PlayerSkills[id][Class][CurrentLevel] = floatround(LevPoint);
	}
	if(selectedclass > -1) 
	{
		menu_destroy( menu );
	}
}

 //Changed 1.4.0 Beta 1: 12.09.2018
public xp_savexp(id)
{
	if(is_running("svencoop"))
	{
		new steamid[32];
		get_user_authid( id, steamid, charsmax(steamid));
		xp_ibm_savexp(id, steamid);
	}
	else
	{
		#if !defined game_svencoop
		new uid[15];
		if(xp_login_getplayerid(id, uid, 14))
		{
			xp_ibm_savexp(id, uid);
		}
		#endif
	}

}
public xp_ibm_savexp(id, userid[])
{
	if(!DataNormallyLoaded[id]) return PLUGIN_HANDLED;
	//Added 1.3.2: 21.08.2014
	new authid[80]
	new vaultkey[100];
	get_user_name(id, authid, 79);
	if(strlen(userid) > 0)
	{
		formatex(vaultkey,99,"%s",userid)
	}
	else
	{

		formatex(vaultkey,99,"%s",authid)
	}
	OyuncuHeaderiKontrolEtOlustur(vaultkey, authid);
	//
	for(new i = 0;i < registered_skills;i++)
	{
		new strA[10];
		new strB[10];
		formatex(strA, 9, "%i", PlayerSkills[id][i][CurrentLevel]);
		formatex(strB, 9, "%i", PlayerSkills[id][i][Activate] + 1);
		OyuncuDegeriGuncelleOlustur(vaultkey, LevelString[i], strA, strA, "", "");
	}
	
	
	OyuncuInfoDegerleriniGuncelle(vaultkey, PlayerSkills[id][PlayerLevel][CurrentValue], PlayerSkills[id][PlayerLevel][CurrentLevel], PlayerSkills[id][XP][TopValue], PlayerSkills[id][Banned][CurrentValue], XPDeactivate[id], EnergyKillValue[id], PlayerSkills[id][Class][CurrentValue], PlayerSkills[id][XP][CurrentValue], PlayerSkills[id][XP][ReqValue], PlayerSkills[id][PrestigeCount][CurrentValue], 1);
	return PLUGIN_HANDLED;
}
//
public client_connect(id)
{

}
public xp_player_disconnected(id, plid[])
{
	if(!is_running("svencoop"))
	{
		xp_ibm_savexp(id, plid);
		Work_client_disconected(id);
		DataNormallyLoaded[id] = false;
		UserFrag[id] = 0;
	}
}
public Work_client_disconected(id)
{
	XPDeactivate[id] = 0;
	SelectedPage[id] = 0;
	SelectedSkills[id] = 0;
	PlayerSkills[id][Class][CurrentValue] = -1;
	PlayerSkills[id][PlayerLevel][CurrentValue] = 0;
	PlayerSkills[id][PrestigeCount][CurrentValue] = 0;
	PlayerSkills[id][XP][CurrentValue] = 0;
	PlayerSkills[id][XP][TopValue] = 0;
	PlayerSkills[id][XP][ReqValue] = 0;
	PlayerSkills[id][PlayerLevel][CurrentLevel] = 0;
	PlayerSkills[id][LoggedIn][CurrentValue] = 0;
	//Added 1.3: 30.03.2014
	PlayerSkills[id][Frags][CurrentValue] = 0;
	//
	PlayerSkills[id][Banned][CurrentValue] = 0;
	PlayerSkills[id][Others][CurrentValue] = 0;
	PlayerSkills[id][PlayerLevel][LastValue] = -1;
	ClearSkills(id);
	clear_usermaxlevels(id);
}
public client_disconnect(id)
{
	if(!is_running("svencoop")) return;
	UserXPMultiplier[id] = 1.0;
	XPSuperAdmin[id] = 0;
	XPSpecRankid[id] = 0;
	new steamid[32]
	get_user_authid( id, steamid, charsmax(steamid))  
	xp_ibm_savexp(id, steamid);
	Work_client_disconected(id);
	DataNormallyLoaded[id] = false;
}
public client_disconnected(id)
{
	if(is_running("svencoop"))
	{
		return;
	}
	else
	{
		if(!PlayerSkills[id][LoggedIn][CurrentValue])
		{
			Work_client_disconected(id);
		}
	}
	UserXPMultiplier[id] = 1.0;
	XPSuperAdmin[id] = 0;
	XPSpecRankid[id] = 0;
	FirstCalced[id] = false;
}
public ClearSkills(id)
{
	for(new i = 0; i < registered_skills; i++)
	{
		PlayerSkills[id][i][CurrentLevel] = 0;
		PlayerSkills[id][i][Activate] = 1;
	}
}

//Added 1.3.4: 20.07.2015
public YetenekAyarMenusuGoster(id)
{
	if(!id) return;
	if(SelectedSkills[id] == -1) return;
	new skid = SelectedSkills[id];
	new strk[300];
	new strings[90];
	formatex(strings, 89, "%L", id, LevelString[skid]);
	formatex(strk, 299, "\r%L", id, "XP_SET_HEAD", strings);
	new menu = menu_create( strk, "SetSkillsHandler" );
	menu_display( id, menu, 0 );
	new LangStr[200];
	if(!PlayerSkills[id][skid][Activate])
	{
		formatex(LangStr, 199, "%L", id, "XP_SET_ACTIVE"); 
	}
	else
	{
		formatex(LangStr, 199, "%L", id, "XP_SET_DEACTIVATE"); 
	}
	menu_additem( menu, LangStr, "", 0 );
	if(PlayerSkills[id][skid][CurrentLevel] > 0)
	{
		formatex(LangStr, 199, "%L", id, "XP_SET_CLEAR"); 
		menu_additem( menu, LangStr, "", 0 );
	}
	menu_display( id, menu, 0);
}
//
//Added 1.3.4: 20.07.2015
public SetSkillsHandler( id, menu, item )
{
	new selectedskills = SelectedSkills[id];
	if(selectedskills == -1)
	{
		return PLUGIN_HANDLED;
	}
	new skilllevel = PlayerSkills[id][selectedskills][CurrentLevel];
	switch(item)
	{
		case 0: //Activate/Deactivate values
		{
			if(PlayerSkills[id][selectedskills][Activate])
			{
				PlayerSkills[id][selectedskills][Activate] = 0;
			}
			else
			{
				PlayerSkills[id][selectedskills][Activate] = 1;
			}
		
		}
        case 1:  //Clear active values
        {
			PlayerSkills[id][PlayerLevel][CurrentLevel] += skilllevel;
			PlayerSkills[id][selectedskills][CurrentLevel] = 0;
		}
    }
	menu_destroy(menu);
	YetenekMenusuGoster(id, SelectedPage[id]);
	return PLUGIN_HANDLED;
}
//1.4.0 Beta 1 Srmyle eklendi: 14.09.2018
stock bool:user_canaccessskill(id, plclass, skillid, ulevel=-2)
{
	if(skillid == -1)
	{
		skillid = Prestige;
	}
	if(!LevelClass[plclass][skillid][Usable])
	{
		return false;
	}
	new PL_Level;
	PL_Level = ulevel;
	if(PL_Level == -2)
	{
		PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	}
	new LCMinlevel = LevelClass[plclass][skillid][MinLevel];
	new LCAccess = LevelClass[plclass][skillid][AccessFlag];
	if(PL_Level < LCMinlevel) return false;
	if(LCAccess != 0 && !access(id, LCAccess)) return false;
	return true;
}
//1.4.0 Beta 1 Srm ile eklendi: 14.09.2018
stock clear_usermaxlevels(id)
{
	MaxLevels_player[id][0] = 0;
	MaxLevels_player[id][1] = 0;
	MaxLevels_player[id][2] = 0;
	MaxLevels_player[id][3] = 0;
}
//1.4.0 Beta 1 Srm ile eklendi: 14.09.2018
stock calc_usermaxlevels(id)
{
	new PL_Level = PlayerSkills[id][PlayerLevel][CurrentValue];
	new PL_Class = PlayerSkills[id][Class][CurrentValue];
	if(PL_Class == -1) PL_Class = Prestige;
	new maxlevel = get_pcvar_num(Cvar_MaxLevel);
	for(new i = 0; i < registered_skills;i++)
	{
		if(!user_canaccessskill(id, PL_Class, i, PL_Level)) continue;
		MaxLevels_player[id][PL_Class] += LevelClass[PL_Class][i][MaxLevel];
	}
	MaxLevels_player[id][PL_Class] = clamp(MaxLevels_player[id][PL_Class], 0, maxlevel);
	if(!FirstCalced[id])
	{
		FirstCalced[id] = true;
	}
}
//1.4.0 Beta 2 Srm ile eklendi: 14.09.2018
stock bool:user_canselectskill(id, classid, skid)
{
	new FWReturnEx;
	ExecuteForward(fw_plselectskill, FWReturnEx, id, classid, skid);
	if(FWReturnEx == XP_HANDLED) return false;
	return true;
}
//1.4.0 Beta 1 Srm ile eklendi: 14.09.2018
stock bool:user_canchangelevel(id, adminid, n_type, oldlevel, newlevel)
{
	new FWReturnEx;
	ExecuteForward(fw_pllevelchanged, FWReturnEx, id, adminid, n_type, oldlevel, newlevel);
	if(FWReturnEx == XP_HANDLED && n_type != setlevel_load) return false;
	calc_usermaxlevels(id);
	return true;
}
 //
public plugin_end() 
{
	if(SQLConnection != Empty_Handle)
	{
		SQL_FreeHandle(SQLConnection);
		SQL_FreeHandle(g_Tuple);
	}
}



/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
