#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <scxpmod>
#include <fun>
#define VERSION "1.0"
new skillid;
new SkArray[4][SkillData];
new FirstMaxArmor[33];
public plugin_init()
{
	register_plugin("SCXP MaxArmor", VERSION, "Ibm")
}
public xp_main()
{
	skillid = xp_newskill("SK_MAXARMOR");
	if(skillid < 0) return;
	SkArray[XP_CL_PRESTIGE][skd_MaxLevel] = 25
	SkArray[XP_CL_PRESTIGE][skd_MaxInterval] = 0
	SkArray[XP_CL_PRESTIGE][skd_MaxEffect] = 30
	SkArray[XP_CL_PRESTIGE][skd_MaxRadius] = 0
	
	SkArray[XP_CL_MEDIC][skd_MaxLevel] = 20
	SkArray[XP_CL_MEDIC][skd_MaxInterval] = 0
	SkArray[XP_CL_MEDIC][skd_MaxEffect] = 100
	SkArray[XP_CL_MEDIC][skd_MaxRadius] = 0
	xp_setskill(XP_CL_PRESTIGE, skillid, SkArray[XP_CL_PRESTIGE]);
	xp_setskill(XP_CL_MEDIC, skillid, SkArray[XP_CL_MEDIC]);
}
public xp_player_prethink(id, plclass)
{
	if(!xp_enabled()) return;
	new Float:MaxArmor;
	if(!xp_isplayerbanned(id) && xp_isplayerloggedin(id))
	{
		pev(id, pev_armortype, MaxArmor);
		if(MaxArmor != xp_calcmax(id, skillid, pev_armortype))
		{
			set_pev(id, pev_armortype, xp_calcmax(id, skillid, pev_armortype));
		}
	}
}
public xp_need_calc(id, skid, plclass)
{
	if(skid != skillid) return;
	CheckPlayerMaxArmor(id, plclass);
}
public xp_need_reset(id, skid, plclass)
{
	if(skid != skillid) return;
	ResetArmor(id);
}
public xp_player_spawned(id, plclass)
{
	SetPlArmor(id);
}
public SetPlArmor(id)
{
	if(xp_isplayerbanned(id) || !xp_isplayerloggedin(id))
	{
		return;
	}
	if(xp_get_userlevel(id, skillid) <= 0)
	{	
		return;
	}
	new Float:MaxArmor;
	new Float:plArmor;
	new MMaxArmor;
	pev(id, pev_armorvalue, plArmor);
	pev(id, pev_armortype, MaxArmor);
	MMaxArmor = floatround(floatmul(MaxArmor, 0.15)) + floatround(plArmor);
	if(MMaxArmor > floatround(MaxArmor))
	{
		MMaxArmor = floatround(MaxArmor);
	}
	set_pev(id, pev_armorvalue, float(MMaxArmor));
}
public client_connect(id)
{
	new Float:Variable
	pev(id, pev_armortype, Variable);
	FirstMaxArmor[id] = floatround(Variable);
}
public ResetArmor(id)
{
	new MaxPHealth = FirstMaxArmor[id];
	if(MaxPHealth <= 0) MaxPHealth = 100;
	new Float:MHealth = float(MaxPHealth);
	if(is_user_alive(id))
	{
		new Float:cHealth;
		pev(id, pev_armorvalue, cHealth);
		new ccHealth = floatround(cHealth);
		if(ccHealth > MaxPHealth)
		{
			set_pev(id, pev_armorvalue, float(MaxPHealth))
		}
	}
	set_pev(id, pev_armortype, MHealth);
}
public CheckPlayerMaxArmor(id, plclass)
{
	if(plclass < 0) return;
	if(plclass != XP_CL_PRESTIGE && plclass != XP_CL_MEDIC) return;
	if(!is_user_alive(id)) return;
	new Float:cOncekiHealth;
	new Float:EntHealth;
	pev(id, pev_armorvalue, EntHealth);
	pev(id, pev_armortype, cOncekiHealth);
	new Float:CalcedHealth = xp_calcmax(id, skillid, pev_armortype);
	EntHealth = floatmul(floatdiv(EntHealth, cOncekiHealth), CalcedHealth);
	set_pev(id, pev_armortype, CalcedHealth);
	set_pev(id, pev_armorvalue, EntHealth);
}

/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
