#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <core>
#include <fakemeta>
#include <scxpmod>
#include <hamsandwich>
#include <xp_monster>
#include <fun>
#define VERSION "1.0"
new skillid;
new ULatency[33];
new SkArray[4][SkillData];
new Float:ULastVampireTime[33];
public plugin_init()
{
	register_plugin("SCXP Vampire", VERSION, "Ibm")
}
public xp_main()
{
	skillid = xp_newskill("SK_VAMPIRE");
	if(skillid < 0) return;
	
	SkArray[XP_CL_PRESTIGE][skd_MaxLevel] = 25
	SkArray[XP_CL_PRESTIGE][skd_MaxInterval] = 0
	SkArray[XP_CL_PRESTIGE][skd_MaxEffect] = 25
	SkArray[XP_CL_PRESTIGE][skd_MaxRadius] = 0
	
	SkArray[XP_CL_SOLDIER][skd_MaxLevel] = 100
	SkArray[XP_CL_SOLDIER][skd_MaxInterval] = 0
	SkArray[XP_CL_SOLDIER][skd_MaxEffect] = 25
	SkArray[XP_CL_SOLDIER][skd_MaxRadius] = 0
	xp_setskill(XP_CL_PRESTIGE, skillid, SkArray[XP_CL_PRESTIGE]);
	xp_setskill(XP_CL_SOLDIER, skillid, SkArray[XP_CL_SOLDIER]);
}
public client_putinserver(id)
{
	if(!is_running("svencoop"))
	{
		ULastVampireTime[id] = get_gametime();
	}
}
public xp_player_takedamage(id, plclass, inflictor, attacker, Float:damage, damagebits)
{
	if(is_running("svencoop")) return XP_IGNORED;
	//if(plclass < 0) plclass = XP_CL_PRESTIGE;
	new aplclass = xp_get_userclass(attacker);
	new userid;
	userid = attacker;
	if(aplclass < 0) return XP_IGNORED;
	if(get_gametime() - ULastVampireTime[id] < 1.0) return XP_IGNORED;
	ULastVampireTime[id] = get_gametime();
	if(userid < 33 && userid > 0)
	{
		if(!xp_isplayerloggedin(userid)) return XP_IGNORED;
		new Float:Max_Level = float(SkArray[aplclass][skd_MaxLevel]);
		new User_Level = xp_get_userlevel(userid, skillid);
		new User_Latency = ULatency[userid]
		User_Latency = User_Latency - 1;
		if(User_Latency < 0) User_Latency = 0;
		ULatency[userid] = User_Latency;
		if(User_Level > 0 && User_Latency <= 0)
		{
			new Float:skd_MaxEffectVal = float(SkArray[aplclass][skd_MaxEffect] );
			new Float:CHealth;
			new Float:MaxHealth;
			pev(userid, pev_max_health, MaxHealth);
			pev(userid, pev_health, CHealth);
			new Float:Multiplier = floatmul(floatdiv(float(User_Level) , Max_Level), skd_MaxEffectVal);
			new Float:DivisionB = 100.0;
			new Float:VictimMaxHealth;
			pev(id, pev_max_health, VictimMaxHealth);
			if(VictimMaxHealth > 30000.0)
			{
				VictimMaxHealth = 30000.0;
			}
			new IntVictimHealth = floatround(VictimMaxHealth);
			new IntDamage = floatround(damage);
			if(IntDamage > IntVictimHealth)
			{
				damage = VictimMaxHealth;
			}
			new Float:AwardedHealth = floatmul(damage, floatdiv(Multiplier , DivisionB));
			new FroundC = floatround(CHealth);
			new FroundCH = floatround(AwardedHealth, floatround_ceil );
			if(AwardedHealth >= 30.0) AwardedHealth = 30.0;
			FroundC += FroundCH;
			if (FroundC > floatround(MaxHealth))
			{
				return XP_IGNORED;
			}
			set_pev(userid, pev_health, float(FroundC));
			ULatency[userid] = 3;
		}
	}
	return XP_IGNORED;
}
public xp_monster_takedamage(id, plclass, inflictor, attacker, Float:damage, damagebits)
{
	if(plclass != XP_CL_MAROONBERETS && plclass != XP_CL_PRESTIGE) return XP_IGNORED;
	new userid;

	if(plclass < 0) return XP_IGNORED;
	if(attacker > 32 && pev_valid(attacker))
	{
		userid = pev(attacker, pev_owner);
	}
	else
	{
		userid = attacker;
	}
	if(!isMonsterAlly(id) && isMonsterAlive(id) && userid < 33 && userid > 0)
	{
		if(!xp_isplayerloggedin(userid)) return XP_IGNORED;
		new Float:Max_Level = float(SkArray[plclass][skd_MaxLevel]);
		new User_Level = xp_get_userlevel(userid, skillid);
		new User_Latency = ULatency[userid]
		User_Latency = User_Latency - 1;
		if(User_Latency < 0) User_Latency = 0;
		ULatency[userid] = User_Latency;
		if(User_Level > 0 && User_Latency <= 0)
		{
			new Float:skd_MaxEffectVal = float(SkArray[plclass][skd_MaxEffect] );
			new Float:CHealth;
			new Float:MaxHealth;
			pev(userid, pev_max_health, MaxHealth);
			pev(userid, pev_health, CHealth);
			new Float:Multiplier = floatmul(floatdiv(float(User_Level) , Max_Level), skd_MaxEffectVal);
			new Float:DivisionB = 100.0;
			new Float:VictimMaxHealth;
			pev(id, pev_max_health, VictimMaxHealth);
			if(VictimMaxHealth > 30000.0)
			{
				VictimMaxHealth = 30000.0;
			}
			new IntVictimHealth = floatround(VictimMaxHealth);
			new IntDamage = floatround(damage);
			if(IntDamage > IntVictimHealth)
			{
				damage = VictimMaxHealth;
			}
			new Float:AwardedHealth = floatmul(damage, floatdiv(Multiplier , DivisionB));
			new FroundC = floatround(CHealth);
			new FroundCH = floatround(AwardedHealth, floatround_ceil );
			FroundC += FroundCH;
			if(FroundC > floatround(MaxHealth))
			{
				FroundC = floatround(MaxHealth);
			}
			set_pev(userid, pev_health, float(FroundC));
			ULatency[userid] = 3;
		}
	}
	return XP_IGNORED;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
